{************************* JUEGO DE LA OCA *************************}
program juegoDeLaOca;

uses crt;

var
x,y,z,pd,cv,cntU,cntM:integer;
pt1,pt2,occa:boolean;
c:char;

{************************* PROCEDURE LEYENDA ************************}
  {Este procedimiento da informacion acerca de las casillas especilaes
   y de las fichas del usuario y de la maquina}

procedure leyenda;
          begin
          writeln;writeln('Las casillas especiales se sealaran de la siguiente forma:');
          writeln;write('Las ocas en verde: ');textcolor(10);write('X');textcolor(15);
          writeln;write('Los puentes en gris: ');textcolor(8);write('X');textcolor(15);
          writeln;write('La posada en marron: ');textcolor(6);write('X');textcolor(15);
          writeln;write('La muerte en morado: ');textcolor(5);write('X');textcolor(15);
          writeln;write('El jardin de la oca en azul cielo: ');textcolor(11);write('X');textcolor(15);
          writeln;write('El usuario tendra la ficha:');textcolor(14);write(' # ');textcolor(15);
          writeln;write('La maquina tendra la ficha:');textcolor(4);write(' * ');textcolor(15);
          end;

{************************* PROCEDURE POSADA *************************}
{Este procedimiento manda un mensaje por pantalla,
y lee del teclado a variable psd}

procedure posada(var psd:integer);

    begin
         repeat
         writeln('Elija la casilla de la posada,de la 13 a la 26.');
         Writeln('Exceptuando los numeros: 14, 18, 23.');
         {$I-}
         read(psd);
         {$I+}
         until (IOresult=0)and(psd<26)and (psd>12) and (psd<>14)
          and (psd<>18)and (psd<>23);

    end;
{************************* PROCEDURE CALAVERA *************************}
{Este procedimiento manda un mensaje por pantalla,
y lee del teclado a variable clv}

procedure calavera(psd:integer;var clv:integer);

    begin
         repeat
         writeln('Elija la casilla de la calavera,de 1 a 26.');
         Writeln('Exceptuando los numeros: 5, 6, 9, 12, 14, 18, 23 y el numero de la posada.');
         {$I-}
         read(clv);
         {$I+}
         until(IOresult=0)and (clv<26) and (clv>0) and (clv<>5)and (clv<>9) and (clv<>14) and (clv<>18)
         and (clv<>23) and  (clv<>6) and (clv<>12) and (clv<>psd);

    end;

{************************* PROCEDURE INICIO *************************}
{Este procedimiento da la bienveida al juego de la oca,
llama al procedimiento anterior y elige aleatoriamente quien empieza a jugar}

procedure inicio(i,j:integer; var turno:integer);
      begin
          leyenda;writeln;writeln;
          writeln('Vamos a ver quien empieza a jugar, si la maquina o el usuario. ');
          writeln;writeln('Pulse enter para lanzar el dado');
          readln;readln;

      repeat
          i:=random(6)+1;
          j:=random(6)+1;

      until i<>j;
          Writeln('Has sacado un: ',i);
          writeln('La maquina a sacado un: ',j);
          if i>j then
           begin
            writeln('Empieza el usuario');
            turno:=1;
           end
          else
           begin
            writeln('Empieza la maquina');
            turno:=0;
           end;
      readln;
      end;

{************************* PROCEDURE COLOCAFICHA *************************}
{Este procedimeinto, dibuja el tablero y la posicion
en la que se encuentran el usuario y la maquina en cada tirada}


procedure colocaFicha(contM,contU,psd,clv:integer);
   var i:integer;
      begin
        for i:=1 to 27 do
           begin
                if (i=5) or (i=9) or  (i=14) or  (i=18) or  (i=23) then
                begin
                     textcolor(10);
                     write(i);
                     textcolor(15);
                end
                else
                if (i=27)then
                begin
                 textcolor(11);
                 write(i);
                 textcolor(15);
                end
                else
                 if i=psd then
                 begin
                  textcolor(6);
                  write(i);
                  textcolor(15)
                 end
                 else
                 if (i=6) or (i=12) then
                 begin
                  textcolor(8);
                  write(i);
                  textcolor(15);
                 end
                 else
                 if i=clv then
                 begin
                  textcolor(5);
                  write(i);
                  textcolor(15)
                 end
                 else
                  write(i);
              if contM=i then
                 begin
                  textcolor(4);
                  write('*');
                  textcolor(15);
                 end
              else
               write(' ');
              if contU=i then
               begin
               textcolor(14);
               write ('#');
               textcolor(15);
               end
              else
               write (' ');
               write('|');
           end;
      end;

{************************* FUNCTION MUERTE *************************}
{Esta funcion compara el valor de la variable contX
 con el de la variable clv y si son iguales devuelve el valor 1 a contx}

function muerte(var contX,clv:integer):integer;

         begin
         if contX=clv then
         begin
         writeln; writeln('Has caido en la calavera, que mala zuerte chato.');
         writeln('Retrocedes a la casilla uno');writeln;
           contX:=1;
         end;
         end;

{************************* PROCEDURE GANADOR *************************}
 {Este procedimiento, cuando contU o contM es igual a 27
 escribe un mensaje por pantalla diciendo quien es el gnador}

procedure ganador(contM,contU:integer);
     begin
       if contM=27 then
       begin
       writeln;
          writeln('***** LA MAQUINA HA GANADO!!! *****');
       end;
       if contU=27 then
       begin
       writeln;
          writeln('##### EL USUARIO HA GANADO!!! #####');
       end;
     end;

{************************* PROCEDURE REBOTE *************************}
 {Este procedimiento sirve para que el contador no se pase
  de 27 y rebote tantas casillas como se ha pasado}

 procedure rebote(var contX:integer);
           begin
            if (contX>27) then
            contX:=((-(contX-27))+27);
           end;

 {************************* PROCEDURE LAPOSADA *************************}
 {Procedimiento que ejecuta las pautas establecidas en el enunciado para la posada,
 compara la casilla actual, con las casillas puente y posada y hace perder turno}

 procedure laposada(var casillaActual:integer;var psd:integer; var pierdeturno:boolean);

           begin
           pierdeturno:=false;
           if (casillaActual=6) then
              begin writeln;writeln;
                    writeln('Has caido en el puente, vas a la posada y pierdes turno');
                    casillaActual := psd;
                    pierdeTurno := true;
              end
                else
                 if (casillaActual=12) then
                 begin writeln;writeln;
                       writeln('Has caido en el puente, vas a la posada y pierdes turno');
                       casillaActual := psd;
                       pierdeTurno := true;
                 end
                else
                 if (casillaActual=psd) then
                  begin writeln;writeln;
                        writeln('Has caido en la posada, pierdes un turno');
                        casillaActual := psd;
                        pierdeTurno := true;
                  end;

        end;

 {************************* PROCEDURE EJECUTATIRADA *************************}
  {el procedure reconoce las casillas de tipo oca y nos lleva
  a la siuiente casilla del mismo tipo permitiendonos volver a tirar.}

 procedure ejecutaTirada(var jugador:integer; var casillaActual:integer;var oca : boolean);

          begin

          oca := false;

          case casillaActual of
             5: begin writeln;writeln;
                      writeln('De oca a oca y tiro porque me toca');
                      casillaActual := 9;
                      oca := true;
                end;

             9: begin writeln;writeln;
                      writeln('De oca a oca y tiro porque me toca');
                      casillaActual := 14;
                      oca := true;
                end;

             14:begin writeln;writeln;
                      writeln('De oca a oca y tiro porque me toca');
                      casillaActual := 18;
                      oca := true;
                end;
             18:begin writeln;writeln;
                      writeln('De oca a oca y tiro porque me toca');
                      casillaActual := 23;
                      oca := true;
                      end;
             23:begin writeln;writeln;
                      writeln('De oca al Jardin de la oca');
                      casillaActual := 27;

                end;
          end;

     end;

{************************* PROCEDURE JUEGO *************************}
{Este procedimiento se encarga de ejecutar todas las partes del juego:cambio de turnos,
repeticion de tiradas etc, recibiendo los datos de los demas procedimientos o
llamandolos directamente}
procedure juego(turno,contM,contU,psd:integer;pierdeturno1,pierdeturno2,oca:boolean);
    var
     u,m,p:integer;
     tiradasquedan:integer;
    begin
         tiradasquedan:=1;
         repeat
         if ((turno=0) and (contU<>27)) then
          begin
            while( (tiradasquedan>0) and (pierdeturno1=false)) do
          begin
            writeln;writeln;
            writeln('Pulse enter para que la maquina tire el dado');
            readln;
            m:=random(6)+1;
            writeln;
            writeln('La maquina ha sacado un ', m );writeln;
            contM:=contM+m;
            rebote(contM);
            p:= muerte(contM,cv);
            colocaficha(contM,contU,pd,cv);
            ejecutatirada(turno,contM,oca);
            laposada(contM,pd,pierdeturno1);
            tiradasquedan:=tiradasquedan-1;
            turno:=1;
            pierdeturno2:=false;
            if oca=true then
            begin
            turno:=0;
            writeln;
            colocaficha(contM,contU,pd,cv);
            end;

          end;

          if pierdeturno1=true then
            tiradasquedan:=2
            else
             tiradasquedan:=1;
         end;

         if
          ((turno=1) and (contM<>27)) then
       begin
          while ((tiradasquedan>0) and (pierdeturno2=false)) do
          begin
            writeln;writeln;
            writeln('Pulse enter para lanzar el dado.');
            readln;
            u:=random(6)+1;
            writeln;
            writeln('El usuario ha sacado un ', u );writeln;
            contU:=contU+u;
            rebote(contU);
            p:=muerte(contU,cv);
            colocaficha(contM,contU,pd,cv);
            ejecutatirada(turno,contU,oca);
            laposada(contU,pd,pierdeturno2);
            tiradasquedan:=tiradasquedan-1;
            turno:=0;
            pierdeturno1:=false;
            if oca=true then
            begin
            turno:=1;
            writeln;
            colocaficha(contM,contU,pd,cv)
            end;
          end;
          if pierdeturno2=true then
        tiradasquedan:=2
         else
         tiradasquedan:=1

       end;


          until (contU=27) or (contM=27);
          writeln;writeln;
          colocaficha(contM,contU,pd,cv);
          writeln;writeln;
          ganador(contM,contU);
   end;
{************************* PROGRAMA PRINCIPAL *************************}
{El programa principal llama a los procedimientos, y da la opcion de volver a jugar}

begin
      randomize;
     repeat
     clrscr;
     textcolor(15);
     writeln;
     writeln('BIENVENIDO AL JUEGO DE LA OCA. ');writeln;
     posada(pd);
     calavera(pd,cv);
     inicio(x,y,z);
     juego(z,cntM,cntU,cv,pt1,pt2,occa);
     repeat
     writeln('Quiere jugar otra partida?, en caso afirmativo pulse "s", sino pulse "n"');
     readln(c);
     until
     (c='n') or (c='N') or (c='s') or (c='S');
     until
     (c='n') or (c='N');
     writeln('El programa ha finalizado');
     readln;

end.

