Program JuegoOca;

uses crt;

Procedure ElijeCasilla (var posada,calavera: integer);
{Procedimiento para pedir al usuario la casilla que desea asignar a la posada
y la calavera}
   Begin
      repeat
         writeln('Qu casilla desea asignar a la posada?');
         writeln('(Entre 13 y 26, excepto 14,18,23)');
         {$I-}
         readln(posada);
         {$I+}
      until (IOresult=0) and (posada<26) and (posada>12) and (posada<>14) and (posada<>18) and (posada<>23);

      writeln;

      repeat
         writeln('Qu casilla desea asignar a la calavera?');
         writeln('(Entre 2 y 26, excepto 5,6,9,12,14,18,23)');
         {$I-}
         readln(calavera);
         {$I+}
      until (IOresult=0) and (calavera<26) and (calavera>1) and (calavera<>5) and (calavera<>6) and (calavera<>9)
         and (calavera<>12) and (calavera<>14) and (calavera<>18) and (calavera<>23) and (calavera<>posada);
   end;

Function Dado :integer;{Funcin para sacar la puntuacin del dado}
   Begin
      Dado:= random(6)+1
   end;

Procedure DibujaTablero (JugadorA,JugadorB:integer);
{Procedimiento que dibuja el tablero y la posicin de ambos jugadores}
   Var
    i:integer;
   Begin
      For i:=1 to 9 do
         begin
            write('   ',i);
            if JugadorA=i then
            write('*');
            if JugadorB=i then
            write('/');
         end;
      writeln;
      For i:=10 to 18 do
         begin
            write('  ',i);
            if JugadorA=i then
            write('*');
            if JugadorB=i then
            write('/');
         end;
      writeln;
      For i:=19 to 27 do
         begin
            write('  ',i);
            if JugadorA=i then
            write('*');
            if JugadorB=i then
            write('/');
         end;
      writeln;
   end;

Procedure Puente (var posicion:integer;posada:integer);
{Procedimiento que te envia a la posada en caso de caer en puente}
   Begin
      if (posicion=6) or (posicion=12) then
          Begin
             posicion:= posada;
             writeln('     Vas directo a la posada');
             writeln('     PIERDES UN TURNO!!');
          end;
      end;

Procedure PierdeTurno (var JugadorA,JugadorB:integer; posada:integer);
{Procedimiento que se activa al caer en la posada, perdiendo un turno}
   var
      Tira_el_dado:integer;
   Begin
      if (JugadorA=posada) then
         begin
            writeln('Me vuelve a tocar a mi');
            Tira_el_dado:=Dado;
            writeln('    He sacado un...', Tira_el_dado,' ');
            JugadorB:=JugadorB + Tira_el_dado ;
            writeln;
            Dibujatablero(JugadorA,JugadorB);
         end;
      if (JugadorB=posada) then
         begin
            writeln('Le vuelve a tocar a usted');
            Tira_el_dado:=Dado;
            writeln('    Ha sacado un...', Tira_el_dado,' ');
            JugadorA:=JugadorA + Tira_el_dado;
            writeln;
            Dibujatablero(JugadorA,JugadorB);
         end;
   end;


Procedure Oca (var posicion:integer);
{Procedimiento que avanza hasta la siguiente oca}
   Begin
      case posicion of
         5: begin
               posicion:=9;
               writeln('     De oca a oca y tiro por que me toca');
               writeln('     Avanzas hasta la casilla 9');
             end;
         9:  begin
               posicion:=14;
               writeln('     De oca a oca y tiro por que me toca');
               writeln('     Avanzas hasta la casilla 14');
             end;
         14: begin
               posicion:=18;
               writeln('     De oca a oca y tiro por que me toca');
               writeln('     Avanzas hasta la casilla 18');
             end;
         18: begin
               posicion:=23;
               writeln('     De oca a oca y tiro por que me toca');
               writeln('     Avanzas hasta la casilla 23');
             end;
         23: begin
               posicion:=27;
               writeln('     De oca a oca y tiro por que me toca');
               writeln('     Avanzas hasta la casilla 27');
             end;
      end;
   end;

Procedure VuelveInicio (var JugadorA,JugadorB:integer; calavera:integer);
{Procedimiento que te manda a la casilla 1 en caso de caer en calavera}
   Begin
      If (JugadorA=calavera) then
         Begin
             writeln('Ha caido en la Calavera,vuelva a la casilla de salida');
             JugadorA:=1;
         end;
      If (JugadorB=calavera) then
         Begin
             writeln('He caido en la Calavera,vuelvo a la casilla de salida');
             JugadorB:=1;
         end;
    end;

Procedure FinExacto (var JugadorA,JugadorB:integer; tirada,posicion_anterior:integer);
{Procedimiento que actualiza tu posicin en caso de pasarte de la casilla 27}
   Begin
      If (JugadorA>27) then
         begin
            JugadorA:= 27-(tirada-(27-posicion_anterior));
            writeln;
            writeln('Se ha pasado de el "Jardin de la Oca", esta es su posicion actual');
            writeln;
            DibujaTablero(JugadorA,jugadorB);
         end;
      If (JugadorB>27) then
         begin
            JugadorB:= 27-(tirada-(27-posicion_anterior));
            writeln;
            writeln('Me he pasado de el "Jardin de la Oca", esta es mi posicion actual');
            writeln;
            DibujaTablero(JugadorA,jugadorB);
         end
   end;
{Programa principal}
var
   posada,calavera,posicion,posicion_anterior,tirada,JugadorA,JugadorB:integer;

begin
     clrscr;
     randomize;
     writeln('BIENVENIDO AL JUEGO DE LA OCA. MUCHA SUERTE!!!');
     writeln;
     ElijeCasilla(posada,calavera);
     JugadorA:=0;
     JugadorB:=0;
     writeln;

     repeat
         writeln('Es su turno. Lance los dados');
         tirada:= Dado;
         posicion_anterior:=JugadorA;
         JugadorA:=JugadorA + tirada;
         writeln('    Ha sacado un...', tirada,' ');
         DibujaTablero(JugadorA,jugadorB);
         VuelveInicio(JugadorA,JugadorB,calavera);
         FinExacto (JugadorA,JugadorB,tirada,posicion_anterior);
         posicion:=JugadorA;
         Puente(posicion,posada);
         PierdeTurno (JugadorA,JugadorB,posada);
         Oca(posicion);
         JugadorA:=posicion;
         writeln;
         readln;

         writeln('Me toca a mi');
         tirada:= Dado;
         posicion_anterior:=JugadorB;
         JugadorB:=JugadorB + tirada;
         writeln('    He sacado un...', tirada,'    ');
         DibujaTablero(JugadorA,jugadorB);
         VuelveInicio(JugadorA,JugadorB,calavera);
         FinExacto (JugadorA,JugadorB,tirada,posicion_anterior);
         posicion:=JugadorB;
         Puente(posicion,posada);
         PierdeTurno (JugadorA,JugadorB,posada);
         Oca(posicion);
         JugadorB:=posicion;
         writeln;
         readln;

     until (JugadorA=27) or (JugadorB=27);
     If (JugadorA=27) then
     writeln('ENHORABUENA HAS GANADO LA PARTIDA!!!!')
     else
     writeln('TE HE GANADO, SIGUE INTENTANDOLO!!!!');
     readln;
end.

