Program oca;

Const
     Casillaoca1=5;
     Casillaoca2=9;
     Casillaoca3=14;
     Casillaoca4=18;
     Casillaoca5=23;
     Puente1=6;
     Puente2=12;
     Jardin_de_la_Oca=27;
Type
    casilla=0..27;

Procedure MostrarInstrucciones;
{Mostrar las instrucciones del juego al usuario}
Begin
     writeln;
     writeln('                 Bienvenido al juego de la Oca!!!');
     writeln('                   Vas a jugar contra el ordenador.');
     writeln('           El tablero consta de 27 casillas, empiezas en la 0.');
     writeln('        Tu objetivo es llegar al jardn de la Oca, en la casilla 27.');
     writeln('           Hay casillas especiales como las de la Oca, Puente,');
     writeln('                           Posada y Calavera.');
     writeln('                Si caes en la Posada, pierdes un turno.');
     writeln('           Si caes en la Calavera, vuelves a la primera casilla.');
     writeln('       Tu elegirs las casillas donde estarn la Posada y la Calavera.');
     writeln;
     writeln('                             SUERTE!');
     writeln('INICIO');
     writeln('=======');
     writeln;
     writeln
End;

Procedure PosicionPosada (var posada:casilla);
{Procedure para que el usuario eliga la casilla donde ir la posada,
la posada no puede estar ni en las casillas especiales ni antes de las
casillas de puente}
Var
   posd:integer;

Begin
     Repeat
     writeln('Escribe la casilla donde va la Posada, puedes seleccionar');
     writeln('cualquiera de las casillas entre la 13 y la 26, exceptuando');
     write('las casillas especiales que son la 14, 18 y 23: ');
     read(posd);
     writeln
     Until ((posd>12) and (posd<27)) and ((posd<>14) and (posd<>18) and (posd<>23));
     posada:=posd;
     writeln('La posada est en la casilla: ',posada);
     writeln
end;

Procedure PosicionCalavera(posada:casilla;var Calavera:casilla);
{Procedure para que el usuario eliga la casilla donde ir la calavera,
la calavera no puede estar ni en las casillas especiales ni en la salida ni
en el jardn de la Oca}
Var
   cal:integer;
Begin
     Repeat
     writeln('Escribe la posicion donde va la Calavera, puedes seleccionar');
     writeln('cualquiera de las casillas entre la 2 y la 26, exceptuando');
     write('las casillas especiales que son la 5, 9, 14, 18 y 23: ');
     read(cal);
     Until ((cal>1) and (cal<27)) and ((cal<>5) and (cal<>9) and (cal<>14) and (cal<>18) and (cal<>23)and(cal<>posada));
     Calavera:=cal;
     writeln('La Calavera est en la casilla: ',Calavera);
     writeln
end;

Procedure POSICION(posicionJ,posicionM:casilla);
var
i:integer;
begin
     For i:= 0 to 27 do
     write('|',i,'| ');
     writeln;
     writeln('El jugador est en la casilla ',posicionJ);
     writeln('La mquina est en la casilla ',posicionM);
end;

Function Dados:integer;
var
   x:integer;
Begin
     repeat
           randomize;
           x:=random(7);
     until
          x<>0;
     Dados:=x
end;

Procedure Jugador(posicionM:casilla; var PosicionJ:casilla);
var
   tirada:integer;

Begin
     writeln('Es tu turno, tira el dado!');
     readln;
     tirada:=dados;
     writeln('Has sacado un ',tirada);
     if (posicionJ+tirada)<=27 then
        posicionJ:=posicionJ+tirada
     else
         posicionJ:=(27-(posicionJ+tirada-27));

     readln;
     POSICION(posicionJ,posicionM)

end;

Procedure Maquina(posicionJ:casilla; var posicionM:casilla);
var
   tirada:integer;
Begin

     writeln('Es turno de la mqina');
     readln;
     tirada:=dados;
     writeln('La mquina ha sacado un ',tirada);

     if (posicionM+tirada)<=27 then
        posicionM:=posicionM+tirada
     else
         posicionM:=(27-(posicionM+tirada-27));

     readln;
     POSICION(posicionJ,posicionM)

end;
Var
   posicionJ, posicionM, posada, calavera:casilla;

Begin

     MostrarInstrucciones;
     PosicionPosada(posada);
     readln;
     PosicionCalavera(posada,calavera);
     posicionJ:=0;
     posicionM:=0 ;
     While (posicionJ<27) and (posicionM<27)do
           Begin
               Jugador(posicionM,PosicionJ);
               readln;
               Maquina(posicionJ,posicionM);
               readln;
           end;
     If posicionJ=27 then
        writeln('Has ganado!')
     else
         writeln('La maquina ha ganado')

end.
