PROGRAM LaOca;

USES crt;

CONST
     oca1=5;
     oca2=9;
     oca3=14;
     oca4=18;
     oca5=23;
     puen1=6;
     puen2=12;
     jardin=27;
     casillas=27;

VAR

 posada,calavera,jugador,maquina,posjugador,posmaquina,dado,quiensiguiente:integer;
 c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,c20,c21,c22,c23,c24,c25,c26,c27:char;
 coloranterior:byte;

BEGIN
     {Establezco primero las condiciones previas a comenzar la partida}
     {A la vez tambin muestro el tablero para dejarlo ms claro}
     coloranterior:=textattr;

     textcolor(13);
     writeln('Este es el juego de la oca, a continuacin se muestra el tablero');
     readln;
     writeln('**  1 **  2 **  3 **  4 ** OCA**PUEN**  7 **  8 ** OCA**  10 **');
     writeln('**    **    **    **    **    **    **    **    **    **     **');
     writeln('** 11 **PUEN** 13 ** OCA** 15 ** 16 ** 17 ** OCA** 19 **  20 **');
     writeln('**    **    **    **    **    **    **    **    **    **     **');
     writeln('** 21 ** 22 ** OCA** 24 ** 25 ** 26 ** 27 **');
     writeln('**    **    **    **    **    **    **    **');
     readln;


     writeln('Hola, tienes que elegir la casilla de posada, siempre y cuando no coincida con ');
     writeln('ninguna casilla de la oca, ni puente, ni jardn de la oca, ademas de ser ');
     writeln('posterior al primer puente:');


     {Introducimos la funcin IORESULT para evitar que el usuario introduzca caracteres}

     REPEAT
     {$I-}
     readln(posada);
     {$I+}
          IF IORESULT<>0 THEN
             writeln('Tienes que escribir un nmero');
     UNTIL IORESULT=0;

     IF (posada>12) AND (posada<>oca3) AND (posada<>oca4) AND (posada<>oca5) AND (posada<>jardin) AND (posada<26) THEN
         writeln('Muy bien, has elegido la posada en la casilla nmero ',posada)
     ELSE
         REPEAT
               writeln('ATENCIN!Debe de ser mayor que la 12 y no debe coincidir con 14, 18, 23 y 27');
               readln(posada);
         UNTIL (posada>12) AND (posada<>oca3) AND (posada<>oca4) AND (posada<>oca5) AND (posada<>jardin);

     readln;

     {Seguimos las mismas pautas para la eleccin de la casilla calavera}

     writeln('Ahora toca elegir la casilla calavera, la cual no puede coincidir con ninguna ya marcada');
     REPEAT
     {$I-}
     readln(calavera);
     {$I+}
     UNTIL IORESULT=0;

     IF (calavera<>oca2) AND (calavera<>oca3) AND (calavera<>oca4) AND (calavera<>oca5) AND (calavera<>jardin)
     AND (calavera<>oca1) AND (calavera<26) AND (calavera<>posada) THEN
         writeln('Muy bien, has elegido la calavera en la casilla nmero ',calavera)
     ELSE
         REPEAT
               writeln('ATENCIN!No debe coincidir con ninguna casilla marcada');
               readln(posada);
         UNTIL (posada>12) AND (posada<>oca3) AND (posada<>oca4) AND (posada<>oca5) AND (posada<>jardin);

     readln;




     {Una vez, definidas las casillas, entonces comenzaremos la partidoa}
     {Utilizamos la funcin randomize para lanzar el dado y saber quien empieza}

     readln;
     writeln('Ahora tiraremos el dado y quien mayor nmero saque empezar');
     randomize;
     jugador:=random(6)+1;
     writeln('Has sacado un ',jugador);
     maquina:=random(6)+1;
     writeln('Y la mquina ha sacado un ',maquina);
     posjugador:=0;
     posmaquina:=0;

     {Como variante al juego he decidido que empiece a jugar, el que saque mayor nmero en el dado}
     IF (jugador>=maquina)
     THEN
         BEGIN
              writeln('Sacas porque has sacado ms nmero que la maquina');
              quiensiguiente:=0;
         END
     ELSE
         BEGIN
              writeln('Empieza la mquina porque ha sacado ms nmero que nosotros');
              quiensiguiente:=1;
         END;

     {Una vez efectuada esta variante, comenzar el juego}

     IF quiensiguiente=0 THEN

     {En esta condicional, tira primero el jugador, y luego la mquina.}

         REPEAT
         BEGIN
              textcolor(10);
              writeln('Te toca tirar el dado');
              dado:=random(6)+1;
              writeln('Has sacado ',dado);
              posjugador:=dado+posjugador;
              IF posjugador<27 THEN
              writeln('Estas en la casilla ',posjugador);
              readln;


     {Este Case, lo utilizamos para limpiar las casillas del tablero}

         CASE posjugador OF
              1: c1:=' ';
              2: c2:=' ';
              3: c3:=' ';
              4: c4:=' ';
              5: c5:=' ';
              6: c6:=' ';
              7: c7:=' ';
              8: c8:=' ';
              9: c9:=' ';
              10: c10:=' ';
              12: c12:=' ';
              13: c13:=' ';
              14: c14:=' ';
              15: c15:=' ';
              16: c16:=' ';
              17: c17:=' ';
              18: c18:=' ';
              19: c19:=' ';
              20: c20:=' ';
              21: c21:=' ';
              22: c22:=' ';
              23: c23:=' ';
              24: c24:=' ';
              25: c25:=' ';
              26: c26:=' ';
              27: c27:=' ';

          END;

     {Y este otro es para seleccionar con x, la posicin del jugador}

         CASE posjugador OF
              1: c1:='x';
              2: c2:='x';
              3: c3:='x';
              4: c4:='x';
              5: c5:='x';
              6: c6:='x';
              7: c7:='x';
              8: c8:='x';
              9: c9:='x';
              10: c10:='x';
              12: c12:='x';
              13: c13:='x';
              14: c14:='x';
              15: c15:='x';
              16: c16:='x';
              17: c17:='x';
              18: c18:='x';
              19: c19:='x';
              20: c20:='x';
              21: c21:='x';
              22: c22:='x';
              23: c23:='x';
              24: c24:='x';
              25: c25:='x';
              26: c26:='x';
              27: c27:='x';
          END;
     {Esta condicional es para que el jugador cuando llega a 27 diga que ha ganado}

         IF posjugador=27 THEN
            writeln('HAS GANADO');

     {Las siguientes condicionales son para cuando el jugador cae en la casilla de
     la oca salte a la siguiente y vuelva a tirar}

         IF posjugador=5 THEN
            BEGIN
                 writeln('DE OCA A OCA Y TIRO PORQUE ME TOCA!!');
                 writeln('Avanzas hasta la casilla 9');
                 posjugador:=9;
                 writeln('Te toca tirar el dado');
                 dado:=random(6)+1;
                 writeln('Has sacado',dado);
                 posjugador:=dado+posjugador;
                 writeln('Estas en la casilla ',posjugador);
                 readln;
            END;

         IF posjugador=9 THEN
            BEGIN
                 writeln('DE OCA A OCA Y TIRO PORQUE ME TOCA!!');
                 writeln('Avanzas hasta la casilla 14');
                 posjugador:=14;
                 writeln('Te toca tirar el dado');
                 dado:=random(6)+1;
                 writeln('Has sacado ',dado);
                 posjugador:=dado+posjugador;
                 writeln('Estas en la casilla ',posjugador);
                 readln;
            END;

         IF posjugador=14 THEN
            BEGIN
                 writeln('DE OCA A OCA Y TIRO PORQUE ME TOCA!!');
                 writeln('Avanzas hasta la casilla 18');
                 posjugador:=18;
                 writeln('Te toca tirar el dado');
                 dado:=random(6)+1;
                 writeln('Has sacado ',dado);
                 posjugador:=dado+posjugador;
                 writeln('Estas en la casilla ',posjugador);
                 readln;
            END;

         IF posjugador=18 THEN
            BEGIN
                 writeln('DE OCA A OCA Y TIRO PORQUE ME TOCA!!');
                 writeln('Avanzas hasta la casilla 23');
                 posjugador:=23;
                 writeln('Te toca tirar el dado');
                 dado:=random(6)+1;
                 writeln('Has sacado',dado);
                 posjugador:=dado+posjugador;
                 writeln('Estas en la casilla ',posjugador);
                 readln;
            END;

     {Esta oca es especial porque en caso de caer en ella el jugador va directamente
     al jardn de la oca, por lo tanto gana}

         IF posjugador=23 THEN
            BEGIN
                 writeln('DE OCA A OCA Y TIRO PORQUE ME TOCA!!');
                 writeln('Avanzas hasta el jardn de la OCA');
                 posjugador:=27;
                 writeln('HAS GANADO');
                 readln;
            END;

     {Esta condicional es para cuando el jugador cae en el puente, por lo tanto vuelve a
     la posada y adems pierde el turno}

         IF (posjugador=6) OR (posjugador=12) THEN
           BEGIN
                posjugador:=posada;
                writeln('Has caido en el puente!!!');
                writeln('Vuelves a la posada y pierdes el turno');
                readln;
                textcolor(11);
                writeln('Le toca tirar el dado a la mquina');
                dado:=random(6)+1;
                writeln('La mquina ha sacado ', dado);
                posmaquina:=dado+posmaquina;
                writeln('La mquina est en la casilla ',posmaquina);
                readln;
           END;

     {Esta condicional es para cuando el jugador cae en la posada y por lo tanto pierde
     un turno}

         IF posjugador=posada THEN
            BEGIN
                 textcolor(10);
                 writeln('Has caido en la posada');
                 writeln('Pierdes el turno');
                 readln;
                 textcolor(11);
                 writeln('Le toca tirar el dado a la mquina');
                 dado:=random(6)+1;
                 writeln('La mquina ha sacado ', dado);
                 posmaquina:=dado+posmaquina;
                 writeln('La mquina est en la casilla ',posmaquina);
                 readln;
             END;
     {Esta condicional es para cuando el jugador cae en calavera y tiene que volver a
     la casilla nmero 1}

         IF posjugador=calavera THEN
            BEGIN
                 posjugador:=1;
                 textcolor(10);
                 writeln('Has caido en la calavera');
                 writeln('Vuelves a la casilla 1');
            END;

     {Las siguientes condicionales son para cuando el jugador se pasa del jardn de la oca}
         IF (posjugador=28)THEN
            BEGIN
            writeln('Pasando del jardn de la oca?');
            posjugador:=26;
            writeln('Vuelves a la casilla ',posjugador);
            readln;
            END;

         IF (posjugador=29)THEN
            BEGIN
            writeln('Pasando del jardn de la oca?');
            posjugador:=25;
            writeln('Vuelves a la casilla ',posjugador);
            readln;
            END;

         IF (posjugador=30) THEN
            BEGIN
            writeln('Pasando del jardn de la oca?');
            posjugador:=24;
            writeln('Vuelves a la casilla ',posjugador);
            readln;
            END;

         IF (posjugador=31) THEN
            BEGIN
            writeln('Pasando del jardn de la oca?');
            posjugador:=23;
            writeln('Vuelves a la casilla ',posjugador);
            readln;
            END;

         IF (posjugador=32) THEN
            BEGIN
            writeln('Pasando del jardn de la oca?');
            posjugador:=24;
            writeln('Vuelves a la casilla ',posjugador);
            readln;
            END;

          writeln('***************************************************');
          writeln('**  1  **  2  **   3 **   4 ** OCA **PUENT**  7  **');
          writeln('**    ',c1,'**    ',c2,'**    ',c3,'**    ',c4,'**    ',c5,'**    ',c6,'**    ',c7,'**');
          writeln('***************************************************');
          writeln('**  8  ** OCA **  10 **  11 **PUENT**  13 ** OCA **');
          writeln('**    ',c8,'**    ',c9,'**    ',c10,'**    ',c11,'**    ',c12,'**    ',c13,'**    ',c14,'**');
          writeln('***************************************************');
          writeln('** 15  **  16 **  17 ** OCA **  19 **  20 **  21 **');
          writeln('**    ',c15,'**    ',c16,'**    ',c17,'**    ',c18,'**    ',c19,'**    ',c20,'**    ',c21,'**');
          writeln('***************************************************');
          writeln('**  22 ** OCA **  24 **  25 **  26 **  27 **');
          writeln('**    ',c22,'**    ',c23,'**    ',c24,'**    ',c25,'**    ',c26,'**    ',c27,'**');




     {Una vez puestas todas las condicones al jugador le tocar tirar a la mquina, a la
     cual tambin he tenido que ponerle una serie de condiciones}


          textcolor(11);
          writeln('Le toca tirar el dado a la mquina');
          dado:=random(6)+1;
          writeln('La mquina ha sacado', dado);
          posmaquina:=dado+posmaquina;
          IF posmaquina<27 THEN
             writeln('La mquina est en la casilla ',posmaquina);
             readln;

     {Las mismas condiciones que le he puesto al jugador las tiene la mquina por lo
     que ya estn todas explicadas}

          CASE posmaquina OF
              1: c1:=' ';
              2: c2:=' ';
              3: c3:=' ';
              4: c4:=' ';
              5: c5:=' ';
              6: c6:=' ';
              7: c7:=' ';
              8: c8:=' ';
              9: c9:=' ';
              10: c10:=' ';
              12: c12:=' ';
              13: c13:=' ';
              14: c14:=' ';
              15: c15:=' ';
              16: c16:=' ';
              17: c17:=' ';
              18: c18:=' ';
              19: c19:=' ';
              20: c20:=' ';
              21: c21:=' ';
              22: c22:=' ';
              23: c23:=' ';
              24: c24:=' ';
              25: c25:=' ';
              26: c26:=' ';
              27: c27:=' ';

          END;

         CASE posmaquina OF
              1: c1:='o';
              2: c2:='o';
              3: c3:='o';
              4: c4:='o';
              5: c5:='o';
              6: c6:='o';
              7: c7:='o';
              8: c8:='o';
              9: c9:='o';
              10: c10:='o';
              12: c12:='o';
              13: c13:='o';
              14: c14:='o';
              15: c15:='o';
              16: c16:='o';
              17: c17:='o';
              18: c18:='o';
              19: c19:='o';
              20: c20:='o';
              21: c21:='o';
              22: c22:='o';
              23: c23:='o';
              24: c24:='o';
              25: c25:='o';
              26: c26:='o';
              27: c27:='o';
          END;

         IF posmaquina=27 THEN
            writeln('LA MAQUINA HA GANADO');


         IF posmaquina=5 THEN
            BEGIN
                 writeln('DE OCA A OCA Y TIRA PORQUE LE TOCA!!');
                 writeln('La mquina avanza hasta la casilla 9');
                 posmaquina:=9;
                 writeln('Le toca tirar el dado');
                 dado:=random(6)+1;
                 writeln('Ha sacado ',dado);
                 posmaquina:=dado+posmaquina;
                 writeln('Esta en la casilla ',posmaquina);
                 readln;
            END;



         IF posmaquina=9 THEN
            BEGIN
                 writeln('DE OCA A OCA Y TIRA PORQUE LE TOCA!!');
                 writeln('La mquina avanza hasta la casilla 14');
                 posmaquina:=14;
                 writeln('Le toca tirar el dado');
                 dado:=random(6)+1;
                 writeln('Ha sacado ',dado);
                 posmaquina:=dado+posmaquina;
                 writeln('Esta en la casilla ',posmaquina);
                 readln;
            END;



         IF posmaquina=14 THEN
            BEGIN
                 writeln('DE OCA A OCA Y TIRO PORQUE ME TOCA!!');
                 writeln('Avanzas hasta la casilla 18');
                 posmaquina:=18;
                 writeln('Le toca tirar el dado');
                 dado:=random(6)+1;
                 writeln('Ha sacado ',dado);
                 posmaquina:=dado+posmaquina;
                 writeln('Esta en la casilla ',posmaquina);
                 readln;
            END;



         IF posmaquina=18 THEN
            BEGIN
                 writeln('DE OCA A OCA Y TIRO PORQUE ME TOCA!!');
                 writeln('Avanzas hasta la casilla 23');
                 posmaquina:=23;
                 writeln('Le toca tirar el dado');
                 dado:=random(6)+1;
                 writeln('Ha sacado ',dado);
                 posmaquina:=dado+posmaquina;
                 writeln('Esta en la casilla ',posmaquina);
                 readln;
            END;



         IF posmaquina=23 THEN
            BEGIN
                 writeln('DE OCA A OCA Y TIRO PORQUE ME TOCA!!');
                 writeln('Avanza hasta el jardn de la OCA');
                 posmaquina:=27;
                 writeln('TE HAN GANADO');
                 readln;
            END;

        IF (posmaquina=6) OR (posmaquina=12) THEN
           BEGIN
                posmaquina:=posada;
                writeln('La mquina ha caido en el puente!!!');
                writeln('Vuelve a la posada y pierde el turno');
                textcolor(10);
                writeln('Ahora te toca tirar el dado');
                dado:=random(6)+1;
                writeln('Has sacado', dado);
                posjugador:=dado+posjugador;
                writeln('Estas en la casilla ',posjugador);
                readln;
           END;

          IF posmaquina=posada THEN
            BEGIN
                 textcolor(11);
                 writeln('La mquina ha caido en la posada');
                 writeln('Pierde el turno');
                 readln;
                 textcolor(10);
                 writeln('Le toca tirar el dado al jugador');
                 dado:=random(6)+1;
                 writeln('Has sacado ', dado);
                 posjugador:=dado+posjugador;
                 writeln('Estas en la casilla ',posjugador);
                 readln;
             END;


         IF posmaquina=calavera THEN
            BEGIN
                 posmaquina:=1;
                 textcolor(11);
                 writeln('La mquina ha caido en la calavera');
                 writeln('Vuelve a la casilla 1');
            END;



         IF (posmaquina=28)THEN
            BEGIN
            writeln('Pasando del jardn de la oca?');
            posmaquina:=26;
            writeln('La mquina vuelve a la casilla ',posmaquina);
            readln;
            END;



         IF (posmaquina=29) THEN
            BEGIN
            writeln('Pasando del jardn de la oca?');
            posmaquina:=25;
            writeln('La mquina vuelve a la casilla ',posmaquina);
            readln;
            END;



         IF (posmaquina=30)THEN
            BEGIN
            writeln('Pasando del jardn de la oca?');
            posmaquina:=24;
            writeln('La mquina vuelve a la casilla ',posmaquina);
            readln;
            END;



         IF (posmaquina=31) THEN
            BEGIN
            writeln('Pasando del jardn de la oca?');
            posmaquina:=23;
            writeln('La mquina vuelve a la casilla ',posmaquina);
            readln;
            END;



         IF (posmaquina=32) THEN
            BEGIN
            writeln('Pasando del jardn de la oca?');
            posmaquina:=24;
            writeln('La mquina vuelve a la casilla ',posmaquina);
            readln;
            END;

          writeln('***************************************************');
          writeln('**  1  **  2  **   3 **   4 ** OCA **PUENT**  7  **');
          writeln('**  ',c1,'  **  ',c2,'  **  ',c3,'  **  ',c4,'  **  ',c5,'  **  ',c6,'  **  ',c7,'  **');
          writeln('***************************************************');
          writeln('**  8  ** OCA **  10 **  11 **PUENT**  13 ** OCA **');
          writeln('**  ',c8,'  **  ',c9,'  **  ',c10,'  **  ',c11,'  **  ',c12,'  **  ',c13,'  **  ',c14,'  **');
          writeln('***************************************************');
          writeln('** 15  **  16 **  17 ** OCA ** 19  ** 20  **  21 **');
          writeln('**  ',c15,'  **  ',c16,'  **  ',c17,'  **  ',c18,'  **  ',c19,'  **  ',c20,'  **  ',c21,'  **');
          writeln('***************************************************');
          writeln('**  22 ** OCA **  24 **  25 **  26 **  27 **');
          writeln('**  ',c22,'  **  ',c23,'  **  ',c24,'  **  ',c25,'  **  ',c26,'  **  ',c27,'  **');




        END;
        UNTIL ((posjugador=27) OR (posmaquina=27))

        {Esta es la posibilidad de que la mquina saque mas puntuacin al tirar que
        el jugador por lo tanto empezara la maquina}

        ELSE

         REPEAT

          CASE posmaquina OF
              1: c1:=' ';
              2: c2:=' ';
              3: c3:=' ';
              4: c4:=' ';
              5: c5:=' ';
              6: c6:=' ';
              7: c7:=' ';
              8: c8:=' ';
              9: c9:=' ';
              10: c10:=' ';
              12: c12:=' ';
              13: c13:=' ';
              14: c14:=' ';
              15: c15:=' ';
              16: c16:=' ';
              17: c17:=' ';
              18: c18:=' ';
              19: c19:=' ';
              20: c20:=' ';
              21: c21:=' ';
              22: c22:=' ';
              23: c23:=' ';
              24: c24:=' ';
              25: c25:=' ';
              26: c26:=' ';
              27: c27:=' ';

          END;



          textcolor(10);
          writeln('Le toca tirar el dado a la mquina');
          dado:=random(6)+1;
          writeln('La mquina ha sacado ', dado);
          posmaquina:=dado+posmaquina;
          IF posmaquina<27 THEN
             writeln('La mquina est en la casilla ',posmaquina);
             readln;


          CASE posmaquina OF
              1: c1:='o';
              2: c2:='o';
              3: c3:='o';
              4: c4:='o';
              5: c5:='o';
              6: c6:='o';
              7: c7:='o';
              8: c8:='o';
              9: c9:='o';
              10: c10:='o';
              12: c12:='o';
              13: c13:='o';
              14: c14:='o';
              15: c15:='o';
              16: c16:='o';
              17: c17:='o';
              18: c18:='o';
              19: c19:='o';
              20: c20:='o';
              21: c21:='o';
              22: c22:='o';
              23: c23:='o';
              24: c24:='o';
              25: c25:='o';
              26: c26:='o';
              27: c27:='o';
          END;

         IF posmaquina=27 THEN
            writeln('LA MAQUINA HA GANADO');

         IF posmaquina=5 THEN
            BEGIN
                 writeln('DE OCA A OCA Y TIRA PORQUE LE TOCA!!');
                 writeln('La mquina avanza hasta la casilla 9');
                 posmaquina:=9;
                 writeln('Le toca tirar el dado');
                 dado:=random(6)+1;
                 writeln('Ha sacado ',dado);
                 posmaquina:=dado+posmaquina;
                 writeln('Esta en la casilla ',posmaquina);
                 readln;
            END;

         IF posmaquina=9 THEN
            BEGIN
                 writeln('DE OCA A OCA Y TIRA PORQUE LE TOCA!!');
                 writeln('La mquina avanza hasta la casilla 14');
                 posmaquina:=14;
                 writeln('Le toca tirar el dado');
                 dado:=random(6)+1;
                 writeln('Ha sacado ',dado);
                 posmaquina:=dado+posmaquina;
                 writeln('Esta en la casilla ',posmaquina);
                 readln;
            END;

         IF posmaquina=14 THEN
            BEGIN
                 writeln('DE OCA A OCA Y TIRO PORQUE ME TOCA!!');
                 writeln('Avanzas hasta la casilla 18');
                 posmaquina:=18;
                 writeln('Le toca tirar el dado');
                 dado:=random(6)+1;
                 writeln('Ha sacado ',dado);
                 posmaquina:=dado+posmaquina;
                 writeln('Esta en la casilla ',posmaquina);
                 readln;
            END;

         IF posmaquina=18 THEN
            BEGIN
                 writeln('DE OCA A OCA Y TIRO PORQUE ME TOCA!!');
                 writeln('Avanzas hasta la casilla 23');
                 posmaquina:=23;
                 writeln('Le toca tirar el dado');
                 dado:=random(6)+1;
                 writeln('Ha sacado ',dado);
                 posmaquina:=dado+posmaquina;
                 writeln('Esta en la casilla ',posmaquina);
                 readln;
            END;

         IF posmaquina=23 THEN
            BEGIN
                 writeln('DE OCA A OCA Y TIRO PORQUE ME TOCA!!');
                 writeln('Avanza hasta el jardn de la OCA');
                 posmaquina:=27;
                 writeln('TE HAN GANADO');
                 readln;
            END;

        IF (posmaquina=6) OR (posmaquina=12) THEN
           BEGIN
                posmaquina:=posada;
                writeln('La mquina ha caido en el puente!!!');
                writeln('Vuelve a la posada y pierde el turno');
                textcolor(11);
                writeln('Ahora te toca tirar el dado');
                dado:=random(6)+1;
                writeln('Has sacado', dado);
                posjugador:=dado+posjugador;
                writeln('Estas en la casilla ',posjugador);
                readln;
           END;

         IF posmaquina=calavera THEN
            BEGIN
                 posmaquina:=1;
                 textcolor(10);
                 writeln('La mquina ha caido en la calavera');
                 writeln('Vuelve a la casilla 1');
            END;

         IF posmaquina=posada THEN
            BEGIN
                 writeln('La mquina ha caido en la posada');
                 writeln('Pierde el turno');
                 readln;
                 textcolor(11);
                 writeln('Le toca tirar el dado al jugador');
                 dado:=random(6)+1;
                 writeln('Has sacado ', dado);
                 posjugador:=dado+posjugador;
                 writeln('Estas en la casilla ',posjugador);
                 readln;
             END;

         IF (posmaquina=28)THEN
            BEGIN
            textcolor(10);
            writeln('Pasando del jardn de la oca?');
            posmaquina:=26;
            writeln('La mquina vuelve a la casilla ',posmaquina);
            readln;
            END;

         IF (posmaquina=29) THEN
            BEGIN
            writeln('Pasando del jardn de la oca?');
            posmaquina:=25;
            writeln('La mquina vuelve a la casilla ',posmaquina);
            readln;
            END;

         IF (posmaquina=30)THEN
            BEGIN
            writeln('Pasando del jardn de la oca?');
            posmaquina:=24;
            writeln('La mquina vuelve a la casilla ',posmaquina);
            readln;
            END;

         IF (posmaquina=31) THEN
            BEGIN
            writeln('Pasando del jardn de la oca?');
            posmaquina:=23;
            writeln('La mquina vuelve a la casilla ',posmaquina);
            readln;
            END;

         IF (posmaquina=32) THEN
            BEGIN
            writeln('Pasando del jardn de la oca?');
            posmaquina:=24;
            writeln('La mquina vuelve a la casilla ',posmaquina);
            readln;
            END;

          writeln('***************************************************');
          writeln('**  1  **  2  **   3 **   4 ** OCA **PUENT**  7  **');
          writeln('**  ',c1,'  **  ',c2,'  **  ',c3,'  **  ',c4,'  **  ',c5,'  **  ',c6,'  **  ',c7,'  **');
          writeln('***************************************************');
          writeln('**  8  ** OCA **  10 **  11 **PUENT**  13 ** OCA **');
          writeln('**  ',c8,'  **  ',c9,'  **  ',c10,'  **  ',c11,'  **  ',c12,'  **  ',c13,'  **  ',c14,'  **');
          writeln('***************************************************');
          writeln('** 15  **  16 **  17 ** OCA ** 19  ** 20  **  21 **');
          writeln('**  ',c15,'  **  ',c16,'  **  ',c17,'  **  ',c18,'  **  ',c19,'  **  ',c20,'  **  ',c21,'  **');
          writeln('***************************************************');
          writeln('**  22 ** OCA **  24 **  25 **  26 **  27 **');
          writeln('**  ',c22,'  **  ',c23,'  **  ',c24,'  **  ',c25,'  **  ',c26,'  **  ',c27,'  **');

         CASE posjugador OF
              1: c1:=' ';
              2: c2:=' ';
              3: c3:=' ';
              4: c4:=' ';
              5: c5:=' ';
              6: c6:=' ';
              7: c7:=' ';
              8: c8:=' ';
              9: c9:=' ';
              10: c10:=' ';
              12: c12:=' ';
              13: c13:=' ';
              14: c14:=' ';
              15: c15:=' ';
              16: c16:=' ';
              17: c17:=' ';
              18: c18:=' ';
              19: c19:=' ';
              20: c20:=' ';
              21: c21:=' ';
              22: c22:=' ';
              23: c23:=' ';
              24: c24:=' ';
              25: c25:=' ';
              26: c26:=' ';
              27: c27:=' ';

          END;
              textcolor(11);
              writeln('Te toca tirar el dado');
              dado:=random(6)+1;
              writeln('Has sacado',dado);
              posjugador:=dado+posjugador;
              IF posjugador<27 THEN
              writeln('Estas en la casilla ',posjugador);
              readln;

         CASE posjugador OF
              1: c1:='x';
              2: c2:='x';
              3: c3:='x';
              4: c4:='x';
              5: c5:='x';
              6: c6:='x';
              7: c7:='x';
              8: c8:='x';
              9: c9:='x';
              10: c10:='x';
              12: c12:='x';
              13: c13:='x';
              14: c14:='x';
              15: c15:='x';
              16: c16:='x';
              17: c17:='x';
              18: c18:='x';
              19: c19:='x';
              20: c20:='x';
              21: c21:='x';
              22: c22:='x';
              23: c23:='x';
              24: c24:='x';
              25: c25:='x';
              26: c26:='x';
              27: c27:='x';
          END;

         IF posjugador=27 THEN
            writeln('HAS GANADO');

         IF posjugador=5 THEN
            BEGIN
                 writeln('DE OCA A OCA Y TIRO PORQUE ME TOCA!!');
                 writeln('Avanzas hasta la casilla 9');
                 posjugador:=9;
                 writeln('Te toca tirar el dado');
                 dado:=random(6)+1;
                 writeln('Has sacado',dado);
                 posjugador:=dado+posjugador;
                 writeln('Estas en la casilla ',posjugador);
                 readln;
            END;

         IF posjugador=9 THEN
            BEGIN
                 writeln('DE OCA A OCA Y TIRO PORQUE ME TOCA!!');
                 writeln('Avanzas hasta la casilla 14');
                 posjugador:=14;
                 writeln('Te toca tirar el dado');
                 dado:=random(6)+1;
                 writeln('Has sacado ',dado);
                 posjugador:=dado+posjugador;
                 writeln('Estas en la casilla ',posjugador);
                 readln;
            END;

         IF posjugador=14 THEN
            BEGIN
                 writeln('DE OCA A OCA Y TIRO PORQUE ME TOCA!!');
                 writeln('Avanzas hasta la casilla 18');
                 posjugador:=18;
                 writeln('Te toca tirar el dado');
                 dado:=random(6)+1;
                 writeln('Has sacado ',dado);
                 posjugador:=dado+posjugador;
                 writeln('Estas en la casilla ',posjugador);
                 readln;
            END;

         IF posjugador=18 THEN
            BEGIN
                 writeln('DE OCA A OCA Y TIRO PORQUE ME TOCA!!');
                 writeln('Avanzas hasta la casilla 23');
                 posjugador:=23;
                 writeln('Te toca tirar el dado');
                 dado:=random(6)+1;
                 writeln('Has sacado',dado);
                 posjugador:=dado+posjugador;
                 writeln('Estas en la casilla ',posjugador);
                 readln;
            END;

         IF posjugador=23 THEN
            BEGIN
                 writeln('DE OCA A OCA Y TIRO PORQUE ME TOCA!!');
                 writeln('Avanzas hasta el jardn de la OCA');
                 posjugador:=27;
                 writeln('HAS GANADO');
                 readln;
            END;

         IF (posjugador=6) OR (posjugador=12) THEN
           BEGIN
                posjugador:=posada;
                writeln('Has caido en el puente!!!');
                writeln('Vuelves a la posada y pierdes el turno');
                textcolor(10);
                writeln('Le toca tirar el dado a la mquina');
                dado:=random(6)+1;
                writeln('La mquina ha sacado', dado);
                posmaquina:=dado+posmaquina;
                writeln('La mquina est en la casilla ',posmaquina);
                readln;
           END;

         IF posjugador=posada THEN
            BEGIN
                 textcolor(11);
                 writeln('Has caido en la posada');
                 writeln('Pierdes el turno');
                 readln;
                 textcolor(10);
                 writeln('Le toca tirar el dado a la mquina');
                 dado:=random(6)+1;
                 writeln('La mquina ha sacado ', dado);
                 posmaquina:=dado+posmaquina;
                 writeln('La mquina est en la casilla ',posmaquina);
                 readln;
             END;

         IF posjugador=calavera THEN
            BEGIN
                 posjugador:=1;
                 textcolor(11);
                 writeln('Has caido en la calavera');
                 writeln('Vuelves a la casilla 1');
            END;

         IF (posjugador=28)THEN
            BEGIN
            writeln('Pasando del jardn de la oca?');
            posjugador:=26;
            writeln('Vuelves a la casilla ',posjugador);
            readln;
            END;

         IF (posjugador=29)THEN
            BEGIN
            writeln('Pasando del jardn de la oca?');
            posjugador:=25;
            writeln('Vuelves a la casilla ',posjugador);
            readln;
            END;

         IF (posjugador=30) THEN
            BEGIN
            writeln('Pasando del jardn de la oca?');
            posjugador:=24;
            writeln('Vuelves a la casilla ',posjugador);
            readln;
            END;

         IF (posjugador=31) THEN
            BEGIN
            writeln('Pasando del jardn de la oca?');
            posjugador:=23;
            writeln('Vuelves a la casilla ',posjugador);
            readln;
            END;

         IF (posjugador=32) THEN
            BEGIN
            writeln('Pasando del jardn de la oca?');
            posjugador:=24;
            writeln('Vuelves a la casilla ',posjugador);
            readln;
            END;

          writeln('***************************************************');
          writeln('**  1  **  2  **   3 **   4 ** OCA **PUENT**  7  **');
          writeln('**    ',c1,'**    ',c2,'**    ',c3,'**    ',c4,'**    ',c5,'**    ',c6,'**    ',c7,'**');
          writeln('***************************************************');
          writeln('**  8  ** OCA **  10 **  11 **PUENT**  13 ** OCA **');
          writeln('**    ',c8,'**    ',c9,'**    ',c10,'**    ',c11,'**    ',c12,'**    ',c13,'**    ',c14,'**');
          writeln('***************************************************');
          writeln('** 15  **  16 **  17 ** OCA **  19 **  20 **  21 **');
          writeln('**    ',c15,'**    ',c16,'**    ',c17,'**    ',c18,'**    ',c19,'**    ',c20,'**    ',c21,'**');
          writeln('***************************************************');
          writeln('**  22 ** OCA **  24 **  25 **  26 **  27 **');
          writeln('**    ',c22,'**    ',c23,'**    ',c24,'**    ',c25,'**    ',c26,'**    ',c27,'**');

         UNTIL (posmaquina=27) OR (posjugador=27);   


     readln;
     textattr:=coloranterior;

END.