
Program oca;    {Definimos las casillas que van a ser constantes en todo el juego}

Const
  oca1=5;            puente1=6;
  oca2=9;            puente2=12;
  oca3=14;
  oca4=18;
  oca5=23;
  jardin=27;

{En esta funcin comprobaremos si un nmero dado para la posada pasado por referencia es vlido
o no,devolvindonos un valor verdadero si se puede asignar esa casilla a la posada}
function posadacorrecta(p:integer):boolean;
  var
    casilla:boolean;
  begin

    if (p<12) or (p=12) or (p=oca3) or (p=oca4) or (p=oca5) or (p=jardin) or (p>jardin) then
    casilla:=false
    Else casilla:=true;
    posadacorrecta:=casilla
  end;
{Esta funcin es similar a la anterior, pero ahora evaluamos si la casilla puede ser calavera o no,
pasando por referencia tanto la calavera como la posada.Devolver verdadero si la calavera elegida por
el usuario (c) es posible.}
function calaveracorrecta(c,p:integer):boolean;
  var
    casilla:boolean;
  begin

    if (c=1) or (c=p) or (c=oca1) or (c=oca2) or (c=oca3) or (c=oca4)
    or (c=oca5) or (c=jardin) or (c=puente1) or (c=puente2) or (c>jardin) then
    casilla:=false
    Else casilla:=true;
    calaveracorrecta:=casilla
  end;
{Funcin que devuelve un entero al azar del uno al 6.}
function tirardado:integer;
  var
    n:integer;
  begin
    {$I-}
     n:=random(6)+1;
    While (IORESULT<>0) and ((n<0) or (n>6)) DO
      n:=random(6)+1;
    {$I+}
    tirardado:=n
  end;

{En este procedimiento pasamos por referencia una variable que nos indica el nmero
obtenido en la funcin anterior, es decir, el nmero obtenido en el dado. Pasamos por
valor la variable posac (indica la posicin actual del usuario) a la que se sumar el valor del dado actualizando la posicin
en la que se encontrar el usuario despus de tirar el dado.}
procedure sumadado(num:integer; Var posac:integer);

  begin
    case num of
      1: posac:=posac+1;
      2: posac:=posac+2;
      3: posac:=posac+3;
      4: posac:=posac+4;
      5: posac:=posac+5;
      6: posac:=posac+6
    end
  end;

{En este procedimiento, evalamos la posicin en la que se encuentra el usuario despus de tirar
el dado, es decir, si su nueva posicin es alguna casilla especial, se le indicar el si debe
desplazarse a otra casilla o permanecer en la misma. Posac la pasaremos por valor porque puede
actualizarse(variable de entrara/salida) , mientras que num, posada y calavera las pasamos por referencia.
A su vez, tendremos una variable de salida booleana, tirar, que devolver el valor verdadero si este
usuario debe volver a jugar otro turno.}

procedure nuevacasilla(num:integer;posada,calavera:integer;Var posac:integer; var tirar:boolean);


   begin
    tirar:=false;
    sumadado(num,posac);
     if posac=oca1 then
        begin
           posac:=oca2;
           tirar:=true
        end;
     if posac=oca2 then
        begin
           posac:=oca3;
           tirar:=true
        end;
     if posac=oca3 then
        begin
           posac:=oca4;
           tirar:=true
        end;
     if posac=oca4 then
        begin
           posac:=oca5 ;
           tirar:=true
        end;
     if (posac=puente1) or (posac=puente2) then
        posac:=posada;
     if posac=calavera then posac:=1

   end;

  {Este procedimiento mostrar el tablero de 27 casillas por pantalla al usuario.}

   procedure tablero;

    Var
     i:integer;

    Begin
    writeln('___________________________');
    for i:=1 to 9 do
     begin
      write('| ',i)

     end;
    writeln('| ');
    for i:=10 to 18 do
     begin
      write('|',i)

     end;
    writeln('| ');
    for i:=19 to 27 do
      begin
        write('|',i)

      end;
    writeln('|');
    writeln('___________________________')

    end;


 {Declaracin de variables del programa principal.}

VAR

    posada,calavera:integer;
     pcorrecta,ccorrecta:boolean;
     jugador1,jugador2:boolean;
     posac1,posac2:integer;
     dado:integer;
     tirar:boolean;


BEGIN
     posac1:=0;
     posac2:=0;

    {$I-}
     writeln ('Dime en qu casilla quieres la posada');
     readln(posada);
     pcorrecta:=posadacorrecta(posada);
     While (IORESULT<>0) or (not pcorrecta) Do

       Begin
        writeln('Dime otra vez la posada. No puede ser 12 o menor, o las siguientes casillas: 14,18,23 y 27.');
        readln(posada);
        pcorrecta:=posadacorrecta(posada)
       end;
    {$I+}
    {$I-}
     writeln('Dime en qu casilla quieres la calavera');
     readln(calavera);
     ccorrecta:=calaveracorrecta(calavera,posada);
     While (IORESULT<>0) or (not ccorrecta) Do

      begin
        writeln('Dime otra vez la calavera. No puede ser ninguna oca, ni puente, ni la posada.');
        readln(calavera);
        ccorrecta:=calaveracorrecta(calavera,posada)
      end;
     {$I+}
     tablero;
     Repeat


     dado:=tirardado;
     nuevacasilla(dado,posada,calavera,posac1,tirar);

     until (posac1=27) or (posac2=27);



END.