PROGRAM OCA; {Vctor Jos Herrero Rubio _ G11 _ P8}
USES crt;         {Necesario para poder utilizar algunas rdenes muy tiles para el juego, como: clrscr, textcolor...}
CONST             {Declaramos estas constantes por si queremos modificar}
     inicio=0;    {la situacin de las casillas especiales}
     oca1=5;
     puente1=6;
     oca2=9;
     puente2=12;
     oca3=14;
     oca4=18;
     oca5=23;
     jardin=27;                             {pos=casilla de la posada}
PROCEDURE TABLERO (var pos, cal:integer);   {cal=casilla de la calavera}
  VAR
     cas:integer;                           {cas=nmero de casilla}
  BEGIN
     clrscr;      {Con esta orden limpiamos la pantalla para mayor claridad}
     textcolor(green);
     textbackground(11);
     writeln('');
     writeln('                       * * * * * * * * *     ');
     writeln('                     *                   *   ');
     writeln('                   *    JUEGO DE LA OCA    * ');
     writeln('                     *                   *   ');
     writeln('                       *               *     ');
     textcolor(blue);
     FOR cas:=0 TO 27 DO
       BEGIN
            IF (cas=inicio) THEN
            BEGIN
            textcolor(white);
            Writeln('                        \  INICIO  ',0,'  /      ');
            END
            ELSE
                IF (cas=oca1) OR (cas=oca2) THEN
                BEGIN
                textcolor(green);
                writeln('                        [   OCA    ',cas,'  ]      ')
                END
                ELSE
                    IF (cas=oca3) OR (cas=oca4) OR (cas=oca5) THEN
                    BEGIN
                    textcolor(green);
                    writeln('                        [   OCA    ',cas,' ]      ')
                    END
                    ELSE
                        IF (cas=puente1) THEN
                        BEGIN
                        textcolor(brown);
                        writeln('                        [  PUENTE  ',cas,'  ]      ')
                        END
                        ELSE
                            IF (cas=puente2) THEN
                            BEGIN
                            textcolor(brown);
                            writeln('                        [  PUENTE  ',cas,' ]      ')
                            END
                            ELSE
                                IF (cas=jardin) THEN
                                BEGIN
                                textcolor(yellow);
                                Writeln('                    <<JARDIN DE LA OCA! >>      ');
                                Writeln('                     \\   CASILLA  ',cas,'   //  ');
                                Writeln('                      \\_._._.___._._._//        ');
                                writeln(' ');
                                END
                                ELSE
                                    IF (cas=pos) THEN
                                    BEGIN
                                    textcolor(red);
                                    writeln('                        [  POSADA  ',cas,' ]      ');
                                    END
                                    ELSE
                                        IF (cas=cal) and (cas<10) THEN
                                        BEGIN
                                        textcolor(black);
                                        writeln('                        [ CALAVERA ',cas,'  ]      ');
                                        END
                                        ELSE
                                            IF (cas=cal) and (cas>=10) THEN
                                            BEGIN
                                            textcolor(black);
                                            writeln('                        [ CALAVERA ',cas,' ]      ');
                                            END
                                            ELSE
                                                IF (cas<10) THEN
                                                BEGIN
                                                Writeln('                        [ Casilla  ',cas,'  ]      ');
                                                END
                                                ELSE
                                                    IF (cas>10) THEN
                                                    Writeln('                        [ Casilla  ',cas,' ]      ');
       textcolor(blue);
       END;
{QUITAR}  writeln('Posada=',pos,' Calavera=',cal);
  END;{FIN del procedimiento TABLERO}

PROCEDURE EligeCASILLAS (var pos, cal:integer);
  VAR
     posada, calavera:integer;
  BEGIN
     textcolor(white); {Dentro de este procedimiento el texto ser blanco}
                       {Eleccin de casilla para la posada}
     writeln('');
     writeln('                Bienvenido al juego de la Oca!');
     writeln('');
     writeln('                  Antes de comenzar a jugar...');
     writeln('');
     {$I-}
     {$r-}
     REPEAT
     writeln('         Elije la casilla en la cual quieres situar la POSADA:');
     readln(posada);
     IF (posada<=puente2) OR (posada=oca3) OR (posada=oca4) OR (posada=oca5) OR (posada>=jardin) THEN
        BEGIN
        writeln('         Esa posicin para la posada no es correcta.');
        writeln('');
        writeln('         Elije otra casilla libre (de ',puente2+1,' a ',jardin-1,'):');
        readln(posada);
        END;           {Para aseguranos de que tecleamos una casilla vlida}
     UNTIL (ioresult=0) AND (posada>puente2) AND (posada<jardin) AND (posada<>oca3) AND (posada<>oca4) AND (posada<>oca5);
     pos:=posada;
     {$I+}
     {$r+}
                       {Eleccin de la casilla para la calavera}
     {$I-}
     {$r-}
     REPEAT
     clrscr;
     writeln('');
     writeln('');
     writeln('');
     writeln('');
     writeln('           Has elegido situar la POSADA en la casilla ',posada,'.');
     writeln('');
     writeln('           Ahora elije una casilla vlida para la CALAVERA:');
     writeln('');
     readln(calavera);
     IF (calavera=posada) OR (calavera=oca1) OR (calavera=puente1) OR (calavera=oca2) OR (calavera=puente2)
        OR (calavera=oca3) OR (calavera=oca4) OR (calavera=oca5) OR (calavera=jardin) THEN
        BEGIN
        writeln('           La casilla elegida para la CALAVERA ya est ocupada.');
        writeln('');
        writeln('           Elije una casilla libre diferente (de 2 a ',jardin-1,'):');
        readln(calavera);
        END;           {Nos aseguramos de que tecleamos una casilla vlida}
     UNTIL (ioresult=0) AND(calavera>1) AND(calavera<jardin) AND(calavera<>posada) AND(calavera<>oca1) AND(calavera<>puente1)
           AND (calavera<>oca2) AND (calavera<>puente2) AND (calavera<>oca3) AND (calavera<>oca4) AND (calavera<>oca5);
     cal:=calavera;
     {$I+}
     {$r+}
  END;{FIN del procedimiento eligeCASILLAS}

PROCEDURE TirarDADO (var tirada:integer);
  BEGIN
       clrscr;
       randomize;
       tirada:= random(6)+1;
       writeln('');
       writeln('');
       writeln('');
       writeln('');
       writeln('');
       writeln('');
       writeln('');
       writeln('');
       writeln('');
       writeln('                 Ha salido un ',tirada, '!');
       writeln('');
  END; {Fin del procedimiento TirarDADO}

PROCEDURE MoverFICHAS(pos,cal:integer);
  VAR
    fichaYO, fichaPC, tirada: integer;
    jugador: boolean;                     {fichaYO=posicin de mi ficha}
                                          {fichaPC=posicin de la ficha del PC}
  BEGIN                                   {tirada=lo que sale con el dado}
       jugador:=true;                     {jugador=true indica que juego yo}
       fichaYO:=0;                        {jugador=false indica que juega la mquina}
       fichaPC:=0;
       WHILE NOT ((fichaYO>=jardin)OR(fichaPC>=jardin)) DO
{MUEVO YO}   IF jugador=true THEN
                  BEGIN
                  writeln('');
                  writeln('                              Te toca.');
                  writeln('');
                  writeln('                  Pulsa ENTER para tirar el dado.');
                  readln;
{Llama a proced.} TirarDADO(tirada);
                  writeln('                      Pulsa ENTER para mover tu ficha.');
                  readln;                              {Recoge el dato de la tirada}
                  fichaYO:=fichaYO+tirada;             {Muevo la ficha}
                  CASE fichaYO OF
                       oca1: BEGIN
                                  clrscr;
                                  writeln('');
                                  writeln('');
                                  writeln('');
                                  writeln('');
                                  writeln('              Has caido en la casilla ',oca1,'.');
                                  writeln('         "De OCA a OCA y tiras porque te toca!"');
                                  writeln('              Saltas a la casilla ',oca2,'.');
                                  writeln('                 Vuelve a tirar');
                                  readln;
                                  fichaYO:=oca2;
{Llama a proced.}                 TirarDADO(tirada);
                                  writeln('     Pulsa ENTER para mover tu ficha.');
                                  readln;
                                  fichaYO:=fichaYO+tirada;
{Llama a proced.}                 TABLERO (pos, cal);
                                  writeln('');
                                  writeln('           Tu ficha est en la casilla ',fichaYO);
                                  writeln('           Mi ficha est en la casilla ',fichaPC);
                                  jugador:=false;
                             END;
                       oca2: BEGIN
                                  clrscr;
                                  writeln('');
                                  writeln('');
                                  writeln('');
                                  writeln('');
                                  writeln('              Has caido en la casilla ',oca2,'.');
                                  writeln('         "De OCA a OCA y tiras porque te toca!"');
                                  writeln('              Saltas a la casilla ',oca3,'!');
                                  writeln('                 Vuelve a tirar');
                                  readln;
                                  fichaYO:=oca3;
{Llama a proced.}                 TirarDADO(tirada);
                                  writeln('     Pulsa ENTER para mover tu ficha.');
                                  readln;
                                  fichaYO:=fichaYO+tirada;
{Llama a proced.}                 TABLERO (pos, cal);
                                  writeln('');
                                  writeln('           Tu ficha est en la casilla ',fichaYO);
                                  writeln('           Mi ficha est en la casilla ',fichaPC);
                                  jugador:=false;
                             end;
                       oca3: BEGIN
                                  clrscr;
                                  writeln('');
                                  writeln('');
                                  writeln('');
                                  writeln('');
                                  writeln('              Has cado en la casilla ',oca3,'.');
                                  writeln('         "De OCA a OCA y tiras porque te toca!"');
                                  writeln('              Saltas a la casilla ',oca4,'.');
                                  writeln('                 Vuelve a tirar');
                                  readln;
                                  fichaYO:=oca4;
{Llama a proced.}                 TirarDADO(tirada);
                                  writeln('     Pulsa ENTER para mover tu ficha.');
                                  readln;
                                  fichaYO:=fichaYO+tirada;
{Llama a proced.}                 TABLERO (pos, cal);
                                  writeln('');
                                  writeln('           Tu ficha est en la casilla ',fichaYO);
                                  writeln('           Mi ficha est en la casilla ',fichaPC);
                                  jugador:=false;
                             END;
                       oca4: BEGIN
                                  clrscr;
                                  writeln('');
                                  writeln('');
                                  writeln('');
                                  writeln('');
                                  writeln('              Has cado en la casilla ',oca4,'.');
                                  writeln('         "De OCA a OCA y tiras porque te toca!"');
                                  writeln('              Saltas a la casilla ',oca5,'.');
                                  writeln('                 Vuelve a tirar');
                                  readln;
                                  fichaYO:=oca5;
{Llama a proced.}                 TirarDADO(tirada);
                                  writeln('     Pulsa ENTER para mover tu ficha.');
                                  readln;
                                  fichaYO:=fichaYO+tirada;
{Llama a proced.}                 TABLERO (pos, cal);
                                  writeln('');
                                  writeln('           Tu ficha est en la casilla ',fichaYO);
                                  writeln('           Mi ficha est en la casilla ',fichaPC);
                                  jugador:=false;
                             END;

                       oca5: BEGIN
                                  clrscr;
                                  writeln('');
                                  writeln('');
                                  writeln('');
                                  writeln('');
                                  writeln('              Has cado en la casilla ', oca5,'.');
                                  writeln('         "De OCA a OCA y tiras porque te toca!"');
                                  writeln('              Saltas a la casilla ',jardin,'.');
                                  writeln('         Llegaste al JARDIN de la OCA!!!');
                                  readln;
                                  fichaYO:=jardin;

                                  jugador:=false;
                             END;
                    puente1: BEGIN
                                  clrscr;
                                  writeln('');
                                  writeln('');
                                  writeln('');
                                  writeln('');
                                  writeln('              Has cado en la casilla ',puente1,'.');
                                  writeln('           "Del PUENTE saltas a la POSADA!"      ');
                                  writeln('              Saltas a la casilla ',pos,'.        ');
                                  writeln('                        y                         ');
                                  writeln('                 pierdes un turno.                ');
                                  readln;
                                  fichaYO:=pos;
{Llama a proced.}                 TABLERO (pos, cal);
                                  writeln('');
                                  writeln('           Tu ficha est en la casilla ',fichaYO);
                                  writeln('           Mi ficha est en la casilla ',fichaPC);
{Perdemos un turno, es decir...  writeln('');
{el PC tira y le vuelve a tocar. writeln('                              Me toca!');
 ??????                        { writeln('');
{creo que esto hay que hacerlo   writeln('                  Pulsa ENTER para tirar el dado por mi.');
{en la POSADA                    readln;
{Llama a proced.}              { TirarDADO(tirada);
                               { writeln('                      Pulsa ENTER para mover mi ficha.');
                               { readln;
                               { fichaPC:=fichaPC+tirada;}
                                  jugador:=false;
                             END;
                    puente2: BEGIN
                                  clrscr;
                                  writeln('');
                                  writeln('');
                                  writeln('');
                                  writeln('');
                                  writeln('              Has cado en la casilla ',puente2,'.');
                                  writeln('           "Del PUENTE saltas a la POSADA!"      ');
                                  writeln('              Saltas a la casilla ',pos,'         ');
                                  writeln('                            y                     ');
                                  writeln('                     pierdes un turno.            ');
                                  readln;
                                  fichaYO:=pos;
{Llama a proced.}                 TABLERO (pos, cal);
                                  writeln('');
                                  writeln('           Tu ficha est en la casilla ',fichaYO);
                                  writeln('           Mi ficha est en la casilla ',fichaPC);
{Perdemos un turno, es decir...  writeln('');
{el PC tira y le vuelve a tocar. writeln('                              Me toca!');
 ??????                        { writeln('');
                               { writeln('                  Pulsa ENTER para tirar el dado por mi.');
                               { readln;
{Llama a proced.}              { TirarDADO(tirada);
                               { writeln('                      Pulsa ENTER para mover mi ficha.');
                               { readln;
                               { fichaPC:=fichaPC+tirada;}
                                  jugador:=false;
                             END

                  else
                  IF (fichaYO>jardin) THEN             {Condicin para no pasarme de largo}
                     CASE fichaYO OF
                          jardin+1: fichaYO:=jardin-1; {Utilizamos la constante jardin, no 27...}
                          jardin+2: fichaYO:=jardin-2; {...por si queremos cambiar el nmero de casillas}
                          jardin+3: fichaYO:=jardin-3;
                          jardin+4: fichaYO:=jardin-4;
                          jardin+5: fichaYO:=jardin-5;
                     END; {Condiciones de las casillas ESPECIALES}
{>>>>>>>>>>>>>>>>}


{Llama a proced.} TABLERO (pos, cal);
                  writeln('');
                  writeln('           Tu ficha est en la casilla ',fichaYO);
                  writeln('           Mi ficha est en la casilla ',fichaPC);
{Condiciones para casillas especiales, (hacer como en TABLERO, ms o menos.)}
                  jugador:=false;
                  end
             END
{MUEVE el PC}ELSE
             BEGIN
                  writeln('');
                  writeln('                              Me toca!');
                  writeln('');
                  writeln('                  Pulsa ENTER para tirar el dado por mi.');
                  readln;
{Llama a proced.} TirarDADO(tirada);
                  writeln('                      Pulsa ENTER para mover mi ficha.');
                  readln;
                  fichaPC:=fichaPC+tirada;
                  case fichaPC of
                       oca1: begin
                                  clrscr;
                                  writeln('');
                                  writeln('');
                                  writeln('');
                                  writeln('');
                                  writeln('              He cado en la casilla ',oca1,'.');
                                  writeln('         "De OCA a OCA y tiro porque me toca!"');
                                  writeln('              Salto a la casilla ',oca2,'.');
                                  writeln('                 Vuelvo a tirar');
                                  readln;
                                  fichaPC:=oca2;
{Llama a proced.}                 TirarDADO(tirada);
                                  writeln('     Pulsa ENTER para mover mi ficha.');
                                  readln;
                                  fichaPC:=fichaPC+tirada;
{Llama a proced.}                 TABLERO (pos, cal);
                                  writeln('');
                                  writeln('           Tu ficha est en la casilla ',fichaYO);
                                  writeln('           Mi ficha est en la casilla ',fichaPC);
                                  jugador:=true;
                                  end;
                       oca2: begin
                                  clrscr;
                                  writeln('');
                                  writeln('');
                                  writeln('');
                                  writeln('');
                                  writeln('              He cado en la casilla ',oca2,'.');
                                  writeln('         "De OCA a OCA y tiro porque me toca!"');
                                  writeln('              Salto a la casilla ',oca3,'!');
                                  writeln('                 Vuelvo a tirar');
                                  readln;
                                  fichaPC:=oca3;
{Llama a proced.}                 TirarDADO(tirada);
                                  writeln('     Pulsa ENTER para mover mi ficha.');
                                  readln;
                                  fichaPC:=fichaPC+tirada;
{Llama a proced.}                 TABLERO (pos, cal);
                                  writeln('');
                                  writeln('           Tu ficha est en la casilla ',fichaYO);
                                  writeln('           Mi ficha est en la casilla ',fichaPC);
                                  jugador:=true;
                                  end;
                       oca3: begin
                                  clrscr;
                                  writeln('');
                                  writeln('');
                                  writeln('');
                                  writeln('');
                                  writeln('              He cado en la casilla ',oca3,'.');
                                  writeln('         "De OCA a OCA y tiro porque me toca!"');
                                  writeln('              Salto a la casilla ',oca4,'.');
                                  writeln('                 Vuelvo a tirar');
                                  readln;
                                  fichaPC:=oca4;
{Llama a proced.}                 TirarDADO(tirada);
                                  writeln('     Pulsa ENTER para mover mi ficha.');
                                  readln;
                                  fichaPC:=fichaPC+tirada;
{Llama a proced.}                 TABLERO (pos, cal);
                                  writeln('');
                                  writeln('           Tu ficha est en la casilla ',fichaYO);
                                  writeln('           Mi ficha est en la casilla ',fichaPC);
                                  jugador:=true;
                                  end;
                       oca4: begin
                                  clrscr;
                                  writeln('');
                                  writeln('');
                                  writeln('');
                                  writeln('');
                                  writeln('              He cado en la casilla ',oca4,'.');
                                  writeln('         "De OCA a OCA y tiro porque me toca!"');
                                  writeln('              Salto a la casilla ',oca5,'.');
                                  writeln('                 Vuelvo a tirar');
                                  readln;
                                  fichaPC:=oca5;
{Llama a proced.}                 TirarDADO(tirada);
                                  writeln('     Pulsa ENTER para mover mi ficha.');
                                  readln;
                                  fichaPC:=fichaPC+tirada;
{Llama a proced.}                 TABLERO (pos, cal);
                                  writeln('');
                                  writeln('           Tu ficha est en la casilla ',fichaYO);
                                  writeln('           Mi ficha est en la casilla ',fichaPC);
                                  jugador:=true;
                                  end;

                       oca5: begin
                                  clrscr;
                                  writeln('');
                                  writeln('');
                                  writeln('');
                                  writeln('');
                                  writeln('              He cado en la casilla ', oca5,'.');
                                  writeln('         "De OCA a OCA y tiro porque me toca!"');
                                  writeln('              Salto a la casilla ',jardin,'.');
                                  writeln('         Llegu al JARDIN de la OCA!!!');
                                  readln;
                                  fichaPC:=jardin;

                                  jugador:=true;
                                  end;

                  END; {Fin del CASE...OF}
                  IF (fichaPC>jardin) THEN             {Condicin para que no se pase de largo la ficha del PC}
                     CASE fichaPC OF
                          jardin+1: fichaPC:=jardin-1; {Utilizamos la constante jardin, no 27}
                          jardin+2: fichaPC:=jardin-2; {Por si queremos cambiar el nmero de casillas}
                          jardin+3: fichaPC:=jardin-3;
                          jardin+4: fichaPC:=jardin-4;
                          jardin+5: fichaPC:=jardin-5;
                     END;

{Llama a proced.} TABLERO (pos, cal);
                  writeln('');
                  writeln('           Tu ficha est en la casilla ',fichaYO);
                  writeln('           Mi ficha est en la casilla ',fichaPC);
{Condiciones para casillas especiales}
                  jugador:=true;
             END;
       IF (jugador=false) THEN
             BEGIN
                  writeln('');
                  writeln('                               ^ ^              ');
                  writeln('                                               ');
                  writeln('                          Enhorabuena!         ');
                  writeln('                         Me has ganado!    :-( ');
                  writeln('                               ');
             END
             ELSE
             BEGIN
             writeln('');
             writeln('                                                    ');
             writeln('                                Te gan!!!        ');
             END;

  END;{FIN del procedimiento MoverFICHAS}


{PROGRAMA PRINCIPAL}
VAR                       {cal=casilla de la calavera}
  pos, cal: integer;      {pos=casilla de la posada}
  jugador: boolean;       {jugador=PC(false) o YO(true)}
  seguir: char;           {seguir=elegir si repetimos o salimos}
BEGIN
repeat
  pos:=0;
  cal:=0;
  textbackground(11);
  TABLERO (pos,cal);      {Llamada al procedimiento}
  EligeCASILLAS(pos,cal); {Llama a proced.}
  TABLERO (pos,cal);      {Llama a proced.}
  MoverFICHAS(pos,cal);   {Llama a proced.}

  readln;
  clrscr;                 {Para poder volver a jugar}
  writeln('');
  writeln('');
  writeln('');
  writeln('');
  writeln('               Pulsa "y" para volver a jugar.');
  writeln('               Pulsa cualquier otra tecla para SALIR.');
  readln(seguir);
until (seguir<>'y');
END. {FIN del programa}