{Practica 1 de diseo, realizada por Ramn Uriol Prieto, Grupo 12 Puesto 3}

Program oca;
uses crt;

{tiradado es la funcion que genera un numero aleatorio del 1 al 6}
Function tiradado : integer;

  Begin
   tiradado:= random(6)+1;
  End;

{poscasillas es un procedimiento que pide al usuario que le indique
las casillas de calavera y posada, y comprueba que sus valores son
 validos}
Procedure poscasillas (var posada, calavera : integer);

   Var
   errorcalavera, errorposada: integer;

   Begin

   repeat

     {Primero pide la casilla de la posada y comprueba que no se introduce
     un valor que de error, por ejemplo una linea de caracteres. Si no, pide
     que se vuelva a introducir}
     {$I-}
     writeln('');
     write('Seleccione la casilla de la posada: ');
     readln(posada);
     While IOResult<>0 do
        begin
        clrscr;
        writeln('');
        write('Valor no valido para la posada, introduzca otro:');
        readln(posada)
        end;
     {$I+}

     {Si el valor introducido es un numero entero comprueba que
     se a introducido un valor de una casilla libre (que no esta
     ocupado por casillas especiales como oca, puente...) y adecuada
     (por encima de los puentes y dentro del rango del tablero).
     Si no pide que se vuelva a introducir}
     case posada of
        13,15,16,17,19,20,21,22,24,25,26: errorposada:=0;
        else begin
               errorposada:=1;
               clrscr;
               writeln('');
               writeln('Valor no valido, introduzca otro');
             end;
     end;
   until errorposada=0;

   clrscr;
   writeln('');
   writeln('Posada asignada a la casilla: ',posada);

   repeat

     {Ahora pide la casilla de la calavera y comprueba que no se introduce
     un valor que de error, por ejemplo una linea de caracteres. Si no, pide
     que se vuelva a introducir}
     {$I-}
     writeln('');
     write('Seleccione la casilla de la calavera: ');
     readln(calavera);
     While IOResult<>0 do
        begin
        clrscr;
        writeln('');
        write('Valor no valido para la calavera, introduzca otro:');
        readln(calavera)
        end;
     {$I+}

     {Si el valor introducido es un numero entero comprueba que
     se a introducido un valor de una casilla libre (que no esta
     ocupado por casillas especiales como oca, puente...) y dentro
     del rango del tablero. Si no pide que se vuelva a introducir}
     case calavera of
        1,2,3,4,7,8,10,11,13,15,16,17,19,20,21,22,24,25,26: errorcalavera:=0;
        else begin
               errorcalavera:=1;
               clrscr;
               writeln('');
               writeln('Posada asignada a la casilla: ',posada);
               writeln('Valor no valido, introduzca otro');
               end;
     end;

     {Por ultimo comprueba que la posada y la calavera no se hayan intentado
     poner en la misma casilla}
     If calavera=posada
       then begin
              errorcalavera:=1;
              clrscr;
              writeln('');
              writeln('Posada asignada a la casilla: ',posada);
              writeln('Posada y calavera no pueden estar en la misma casilla, introduzca otro valor');
              end;
   until (errorcalavera=0);

   {Saca por pantalla las casillas definitivas de posada y calavera}
   clrscr;
   writeln('');
   writeln('Posada asignada a la casilla: ',posada);
   writeln('Calavera asignada a la casilla: ',calavera);
   writeln('Pulse ENTER para comenzar la partida.');
   readln;

   End;

{El procedimiento tablero dibuja el tablero en la pantalla indicando
las posiciones de las casillas especiales, las posiciones de los usuarios
y de quien es el turno de jugar}
Procedure tablero (posada, calavera, posusuario, posmaquina, turno: integer);

 Begin

   clrscr;
   Textcolor(LightGray);
   writeln('                                JUEGO DE LA OCA');
   writeln('                        Realizado por Ramn Uriol Prieto');
   writeln('');
   writeln('------------------------------------------------------------------------------');
   writeln('|     0    |     1    |     2    |     3    |     4    |     5    |     6    |');
   writeln('|          |          |          |          |          |          |          |');
   writeln('|          |          |          |          |          |          |          |');
   writeln('-----------+----------+----------+----------+----------+----------+- - - - - -');
   writeln('|    13    |    12    |    11    |    10    |     9    |     8    |     7    |');
   writeln('|          |          |          |          |          |          |          |');
   writeln('|          |          |          |          |          |          |          |');
   writeln('- - - - - -+----------+----------+----------+----------+----------+-----------');
   writeln('|    14    |    15    |    16    |    17    |    18    |    19    |    20    |');
   writeln('|          |          |          |          |          |          |          |');
   writeln('|          |          |          |          |          |          |          |');
   writeln('-----------+----------+----------+----------+----------+----------+- - - - - -');
   writeln('|    27    |    26    |    25    |    24    |    23    |    22    |    21    |');
   writeln('|          |          |          |          |          |          |          |');
   writeln('|          |          |          |          |          |          |          |');
   writeln('------------------------------------------------------------------------------');

   writeln(' Usuario - ');
   writeln(' Mquina - ');
   If Turno>0
     then writeln('               Turno del Usuario, pulse ENTER para continuar')
   else writeln('                 Turno de la mquina, pulse ENTER para continuar');
   Textcolor(Magenta);
   GotoXY(12,21);          Write('X');
   Textcolor(LightGreen);
   GotoXY(12,22);          Write('X');

   {Pongo en el tablero Inicio, Oca, Jardn y puente}
   Textcolor(Blue);
   GotoXY(4,6);          Write('Inicio');
   Textcolor(Yellow);
   GotoXY(61,6);         Write('Oca');
   GotoXY(50,10);        Write('Oca');
   GotoXY(6,14);         Write('Oca');
   GotoXY(50,14);        Write('Oca');
   GotoXY(50,18);        Write('Oca');
   Textcolor(Green);
   GotoXY(4,18);         Write('Jardn');
   Textcolor(Brown);
   GotoXY(70,6);         Write('Puente');
   GotoXY(15,10);        Write('Puente');

   Textcolor(Red);  {Pone en el tablero la calavera}
   Case calavera of
     1,2,3,4: begin GotoXY(calavera*11+3,6);  Write('Calavera'); End;
     7: begin GotoXY(69,10);  Write('Calavera'); End;
     8: begin GotoXY(58,10);  Write('Calavera'); End;
     10: begin GotoXY(36,10); Write('Calavera'); End;
     11: begin GotoXY(25,10); Write('Calavera'); End;
     13: begin GotoXY(3,10);  Write('Calavera'); End;
     15: begin GotoXY(14,14); Write('Calavera'); End;
     16: begin GotoXY(25,14); Write('Calavera'); End;
     17: begin GotoXY(36,14); Write('Calavera'); End;
     19: begin GotoXY(58,14); Write('Calavera'); End;
     20: begin GotoXY(69,14); Write('Calavera'); End;
     21: begin GotoXY(69,18); Write('Calavera'); End;
     22: begin GotoXY(58,18); Write('Calavera'); End;
     24: begin GotoXY(36,18); Write('Calavera'); End;
     25: begin GotoXY(25,18); Write('Calavera'); End;
     26: begin GotoXY(14,18); Write('Calavera'); End;
   End;

   Textcolor(Cyan);  {Pone en el tablero la posada}
   Case posada of
     13: begin GotoXY(4,10);  Write('Posada'); End;
     15: begin GotoXY(15,14); Write('Posada'); End;
     16: begin GotoXY(26,14); Write('Posada'); End;
     17: begin GotoXY(37,14); Write('Posada'); End;
     19: begin GotoXY(59,14); Write('Posada'); End;
     20: begin GotoXY(70,14); Write('Posada'); End;
     21: begin GotoXY(70,18); Write('Posada'); End;
     22: begin GotoXY(59,18); Write('Posada'); End;
     24: begin GotoXY(37,18); Write('Posada'); End;
     25: begin GotoXY(26,18); Write('Posada'); End;
     26: begin GotoXY(15,18); Write('Posada'); End;
   End;


    {Pone en el tablero la ficha del usuario}
   If turno>0 then
       Textcolor(Magenta+Blink)
       else  Textcolor(Magenta);

   Case posusuario of
     0,1,2,3,4,5,6: begin GotoXY(posusuario*11+6,7);  Write('X'); End;
     7: begin GotoXY(72,11);  Write('X'); End;
     8: begin GotoXY(61,11);  Write('X'); End;
     9: begin GotoXY(50,11);  Write('X'); End;
     10: begin GotoXY(39,11); Write('X'); End;
     11: begin GotoXY(30,11); Write('X'); End;
     12: begin GotoXY(19,11); Write('X'); End;
     13: begin GotoXY(6,11);  Write('X'); End;
     14: begin GotoXY(6,15);  Write('X'); End;
     15: begin GotoXY(17,15); Write('X'); End;
     16: begin GotoXY(28,15); Write('X'); End;
     17: begin GotoXY(39,15); Write('X'); End;
     18: begin GotoXY(50,15); Write('X'); End;
     19: begin GotoXY(61,15); Write('X'); End;
     20: begin GotoXY(72,15); Write('X'); End;
     21: begin GotoXY(72,19); Write('X'); End;
     22: begin GotoXY(61,19); Write('X'); End;
     23: begin GotoXY(50,19); Write('X'); End;
     24: begin GotoXY(39,19); Write('X'); End;
     25: begin GotoXY(30,19); Write('X'); End;
     26: begin GotoXY(17,19); Write('X'); End;
     27: begin GotoXY(6,19);  Write('X'); End;
   End;

   {Pone en el tablero la ficha de la maquina}

   If turno<=0 then
      Textcolor(LightGreen+Blink)
      else textcolor(LightGreen);

   Case posmaquina of
     0,1,2,3,4,5,6: begin GotoXY(posmaquina*11+8,7);  Write('X'); End;
     7: begin GotoXY(74,11);  Write('X'); End;
     8: begin GotoXY(63,11);  Write('X'); End;
     9: begin GotoXY(52,11);  Write('X'); End;
     10: begin GotoXY(31,11); Write('X'); End;
     11: begin GotoXY(32,11); Write('X'); End;
     12: begin GotoXY(21,11); Write('X'); End;
     13: begin GotoXY(8,11);  Write('X'); End;
     14: begin GotoXY(8,15);  Write('X'); End;
     15: begin GotoXY(19,15); Write('X'); End;
     16: begin GotoXY(30,15); Write('X'); End;
     17: begin GotoXY(41,15); Write('X'); End;
     18: begin GotoXY(52,15); Write('X'); End;
     19: begin GotoXY(63,15); Write('X'); End;
     20: begin GotoXY(74,15); Write('X'); End;
     21: begin GotoXY(74,19); Write('X'); End;
     22: begin GotoXY(63,19); Write('X'); End;
     23: begin GotoXY(52,19); Write('X'); End;
     24: begin GotoXY(41,19); Write('X'); End;
     25: begin GotoXY(30,19); Write('X'); End;
     26: begin GotoXY(19,19); Write('X'); End;
     27: begin GotoXY(8,19);  Write('X'); End;
   End;

 End;

{El procedimiento Pasado hace retroceder al jugador si se a pasado
de la casilla 27 al tirar}
Procedure Pasado (var posicion: integer);
Begin
    Textcolor(LightGray);
    GotoXY(20,21);
    Write('Te has pasado, retrocedes ',(posicion-27),' casillas');
    readln;
    posicion:= 27 - (posicion-27);
End;

{El procedimiento Oca1 hace avanzar al jugador a la siguiente oca si a
caido en las ocas de las casillas 5, 14 o 23. Y el jugador vuelve a tirar}
Procedure Oca1 (var posicion, turno: integer);
Begin
    Textcolor(LightGray);
    GotoXY(20,21);
    Write('De oca a oca y tiras porque te toca');
    readln;
    posicion:= posicion + 4;
    {Si turno>0 significa que es el turno del usuario por tanto para que
    tire otra vez hay que sumar 1 a la variable turno, si turno no es >0
    es el turno de la maquina y para que tire otra vez hay que restar 1
    a la variable turno}
    If turno>0 then
       turno:= turno + 1
    else turno:= turno - 1;
End;

{El procedimiento Oca2 hace avanzar al jugador a la siguiente oca si a
caido en las ocas de las casillas 9 o 18. Y el jugador vuelve a tirar}
Procedure Oca2 (var posicion, turno: integer);
Begin
    Textcolor(LightGray);
    GotoXY(20,21);
    Write('De oca a oca y tiras porque te toca');
    readln;
    posicion:= posicion + 5;
    {Si turno>0 significa que es el turno del usuario por tanto para que
    tire otra vez hay que sumar 1 a la variable turno, si turno no es >0
    es el turno de la maquina y para que tire otra vez hay que restar 1
    a la variable turno}
    If turno>0 then
       turno:= turno + 1
    else turno:= turno - 1;
End;

{El procedimiento Puente manda al jugador a la casilla de la posada}
Procedure Puente (posada: integer; var posicion: integer);
Begin
    Textcolor(LightGray);
    GotoXY(20,21);
    Write('Has caido en un puente, vas a la posada');
    readln;
    posicion:=posada;
End;

{El procedimiento CasillaPosada hace que el jugador pierda un turno}
Procedure CasillaPosada (var turno: integer);
Begin
    Textcolor(LightGray);
    GotoXY(20,21);
    Write('Has caido en la posada, pierdes un turno');
    readln;
    {Si turno>0 significa que es el turno del usuario por tanto para que
    pierda un turno hay que restar 1 a la variable turno, si turno no es >0
    es el turno de la maquina y para que tire otra vez hay que sumar 1
    a la variable turno}
    If turno>0 then
       turno:= turno - 1
    else turno:= turno + 1;
End;

{El procedimiento CasillaCalavera manda al jugador a la casilla 1}
Procedure CasillaCalavera (var posicion: integer);
Begin
    Textcolor(LightGray);
    GotoXY(20,21);
    Write('Has caido en la calavera, vuelves a la casilla 1');
    readln;
    posicion:=1;
End;

Var
   posada, calavera, dado, turno : integer;
   posusuario, posmaquina : integer;

Begin

   posusuario:=0;
   posmaquina:=0;
   turno:=1;  {al hacer turno=1 empieza a jugar el usuario}
   Randomize;
   clrscr;

{Esta primera parte pide al usuario que le indique que casillas tienen
 que ser la posada y la calavera}

   Poscasillas(posada,calavera);

{Ahora el programa dibuja el tablero colocando la posada y
 la calavera en las casillas que a indicado el usuario}

   Repeat

     Tablero(posada,calavera,posusuario,posmaquina,turno);

     readln;

     {Se tira el dado}
     dado:=tiradado;
     Textcolor(LightGray);
     GotoXY(28,21);          Write('El dado ha salido: ',dado);
     readln;

     {Si turno>0 significa que es el turno del usuario, si no
       es el turno de la maquina}
     If turno>0
       then
         begin
           {el usuario avanza el numero de casillas que a salido el dado}
           posusuario:=posusuario + dado;
           {Se dibuja en el tablero su nueva posicin}
           Tablero(posada,calavera,posusuario,posmaquina,turno);
           {A continuacin se tienen encuenta las casillas especiales en
           las que haya podido caer el usuario}
           {Primero se comprueba si el usuario se a pasado de 27, y si es
           asi retrocede con el procedimiento correspondiente}
           If posusuario>27 then
              begin
                pasado(posusuario);
                Tablero(posada,calavera,posusuario,posmaquina,turno);
              end;
           {Ahora se comprueba si el usuario a caido en una oca o en un
           puente, hay dos ocas (oca1 y oca2) porque en unas ocas se
           suman 5 casillas hasta la siguiente oca y en otras 4 casillas}
           Case posusuario of
            5,14,23: begin
                        Oca1(posusuario, turno);
                        Tablero(posada,calavera,posusuario,posmaquina,turno);
                     end;
            9,18: begin
                     Oca2(posusuario, turno);
                     Tablero(posada,calavera,posusuario,posmaquina,turno);
                  end;
            6,12: begin
                     Puente(posada, posusuario);
                     Tablero(posada,calavera,posusuario,posmaquina,turno);
                  end;
            end;
            {Despues se comprueba si el usuario a caido en la posada, y si
            es asi pierde un turno}
            If posusuario=posada then
               begin
                  CasillaPosada(turno);
                  Tablero(posada,calavera,posusuario,posmaquina,turno);
               end;
            {Por ultimo se comprueba si el usuario a caido en la calavera y si
            es asi se le envia a la casilla 1}
            If posusuario=calavera then
               begin
                  CasillaCalavera(posusuario);
                  Tablero(posada,calavera,posusuario,posmaquina,turno);
               end;
            {Puesto que al llegar aqui el turno del usuario a terminado se
            le resta 1 al turno, asi si el usuario no a caido en una oca turno
            sera igual a 0 y le tocara jugar a la maquina}
            turno:= turno - 1;
         end
     else
        begin
           {El siguiente bloque es igual al anterior pero para la maquina en lugar
           del usuario, solo cambia como se modifica la variable turno, modificandose
           al reves que cuando juega el usuario}
           posmaquina:=posmaquina + dado;
           Tablero(posada,calavera,posusuario,posmaquina,turno);
           If posmaquina>27 then
              begin
                pasado(posmaquina);
                Tablero(posada,calavera,posusuario,posmaquina,turno);
              end;
           Case posmaquina of
            5,14,23: begin
                        Oca1(posmaquina, turno);
                        Tablero(posada,calavera,posusuario,posmaquina,turno);
                     end;
            9,18: begin
                     Oca2(posmaquina, turno);
                     Tablero(posada,calavera,posusuario,posmaquina,turno);
                  end;
            6,12: begin
                     Puente(posada, posmaquina);
                     Tablero(posada,calavera,posusuario,posmaquina,turno);
                  end;
            end;
            If posmaquina=posada then
               begin
                  CasillaPosada(turno);
                  Tablero(posada,calavera,posusuario,posmaquina,turno);
               end;
            If posmaquina=calavera then
               begin
                  CasillaCalavera(posmaquina);
                  Tablero(posada,calavera,posusuario,posmaquina,turno);
               end;
            turno:= turno + 1;
        end;

     Tablero(posada,calavera,posusuario,posmaquina,turno);

   {Repetira estos bloques hasta que el usuario o la maquina alcancen
   la casilla 27 (el jardin de la oca)}
   Until ((posusuario=27) or (posmaquina=27));

   {Entonces se indicar por pantalla quien a sido el ganador}
   Textcolor(LightGray);
   GotoXY(25,21);
   If posusuario=27 then
     write('FIN DE JUEGO, GANA EL USUARIO')
     else
     write('FIN DE JUEGO, GANA LA MAQUINA');

     readln;

End.
