Program OCA;
uses crt;

{Presentacin inicial}

Procedure Presentacion;

Begin
     writeln;
     writeln('          22222222222222222222222222222222222222222');
     writeln('          22            JUEGO DE LA OCA          22');
     writeln('          22222222222222222222222222222222222222222');
     writeln;
     writeln;
end;


{Elegir casilla posada}

Procedure PosPosada(var posada:byte);
begin
     repeat
     {$I-}
          begin
               writeln;
               writeln ('Introdude posicion posada. Posterior a 6 o 12 (casillas puente)');
               writeln('Numero menor que el numero total de casillas (27).');
               readln(posada);
               If ((posada=5) or (posada=9) or (posada=14) or (posada=18) or (posada=23)) then
               begin
                    writeln;
                    writeln('Introduce una casilla que no sea oca');
                    writeln
               end;
          end;

     until (ioresult=0) and (posada<>5) and (posada<>9) and (posada<>14) and (posada<>18) and (posada<>23) and (posada<=27);
     {$I+}

     writeln;
     writeln('Posada es la casilla ',posada);

end;


{Elegir casilla calavera}

Procedure PosCalavera (var calavera:byte);

begin
     repeat
     {$I-}
          begin
               writeln;
               writeln ('Introdude posicion calavera. Numero menor que el numero total de casillas (27).');
               writeln;

               readln(calavera);
               If ((calavera=5) or (calavera=9) or (calavera=14) or (calavera=18) or (calavera=23)) then
               begin
                    writeln;
                    writeln('Introduce una casilla que no sea oca');
                    writeln;
               end;

          end;

     until (ioresult=0) and (calavera<>5) and (calavera<>9) and (calavera<>14) and (calavera<>18) and (calavera<>23)
           and (calavera<=27);
     {$I+}
     writeln;
     writeln('Calavera es la casilla ',calavera);

end;


{Procedure finaliza}

procedure finaliza (posicionA, posicionB:integer);
var
   ganador:char;
begin
     if (posicionA=27) then
        begin
             ganador:='A';
             writeln('Gana el usuario. ')
        end
     else writeln ('Gana la maquina.')
end;


{Declaracion de variables}

var
   ContadorTurnosA,ContadorTurnosB:byte;
   jugador:char;
   posicionA, posicionB:byte;
   dado:byte; posada:byte;
   calavera:byte;
   aux:char;


begin
     clrscr;   {Limpia la pantalla}
     randomize; {Permite usar el random}
     ContadorTurnosA:=0;  {Inicializamos contadores de turnos}
     ContadorTurnosB:=0;
     posicionA:=0;       {Inicializamos posiciones}
     posicionB:=0;
     writeln;
     writeln;
     writeln('            VAMOS A JUGAR AL JUEGO DE LA OCA!');
     writeln;
     Presentacion;
     PosPosada(posada);
     PosCalavera(calavera);

{Preguntamos al usuario si quiere empezar el o que empiece la maquina}

repeat
           writeln;
           writeln('Quien empieza? Pulsa A si empiezas tu o pulsa B si empiezo yo.');
           writeln;
           readln(jugador);

           case jugador of
                          'A','a':  writeln('Empiezas tu.');
                          'B','b':  writeln('Empiezo yo.')
           end;

until (jugador='A') or (jugador='a') or (jugador='B') or (jugador='b');


     {Empezamos ajugar}

REPEAT

   begin

     If ((jugador='A') or (jugador='a')) then
        begin
             writeln;
             writeln('Juega jugador A ');
             writeln;
             writeln('Pulsa enter para lanzar el dado');
             readln;
             dado:=(1+random(6));    {Lanzar dado}
             writeln;
             writeln('El valor del dado es ',dado);
             writeln;
             posicionA:=posicionA + dado;   {Nueva posicion del jugador}
             writeln('El jugador A esta en la casilla: ',posicionA);
             end;

             {Casillas puente}

             If ((posicionA=6) or (posicionA=12)) then
             begin
                  writeln;
                  writeln('Has caido en un puente.');
                  writeln('Pasas a la casilla posada. Casilla: ',posada);
                  writeln;
                  posicionA:=posada;
                  ContadorTurnosA:=0
             end;


             {Casilla posada}

             If posicionA=posada then
                begin
                     writeln;
                     writeln('Pierdes turno.');
                     writeln;
                     jugador:='B';  {El jugador A pierde turno}
                end;

             {Casilla calavera}

             If posicionA=calavera then
                begin
                     writeln;
                     writeln('Has caido en la casilla calavera.');
                     writeln;
                     posicionA:=1;     {Vuelve a la casilla 1}
                     writeln('Vuelves a la casilla 1')
                end;
             {Oca}
             If  posicionA=5 then   {Si cae en la casilla 5 pasa a la 9}
                            begin
                            writeln;
                            writeln('Has caido en oca.');
                            writeln;
                            writeln('Pasas a la siguiente oca.');
                            posicionA:=9;
                            writeln;
                            writeln('Pulsa enter para volver a tirar.');
                            readln;
                            dado:=(1+random(6));
                            writeln;
                            writeln('El valor del dado es ',dado);
                            writeln;
                            posicionA:=posicionA + dado;
                            writeln('El jugador A esta en la casilla: ',posicionA);
                            writeln;
                            end;
                                 If ContadorTurnosA=0 then
                                    jugador:='B'
                      end;

             If posicionA=9 then    {Si cae en la casilla 9 pasa a la 14}
             begin
                            begin
                            writeln;
                            writeln('Has caido en oca.');
                            writeln;
                            writeln('Pasas a la siguiente oca.');
                            writeln;
                            posicionA:=14;
                            writeln('La nueva posicion es la casilla: ',posicionA);
                            writeln;
                            writeln('Pulsa enter para volver a tirar.');
                            readln;
                            dado:=(1+random(6));
                            writeln;
                            writeln('El valor del dado es ',dado);
                            writeln;
                            posicionA:=posicionA + dado;
                            writeln('El jugador A esta en la casilla: ',posicionA);
                            writeln;
                      end;



             If ContadorTurnosA=0 then       {Cambia de turno}
                jugador:='B'
        end;




             If posicionA=14 then   {Si cae en la casilla 14 pasa a la 18}
             begin
                            begin
                            writeln;
                            writeln('Has caido en oca.');
                            writeln;
                            writeln('Pasas a la siguiente oca.');
                            posicionA:=18;
                            writeln('La nueva posicion es la casilla: ',posicionA);
                            writeln;
                            writeln('Pulsa enter para volver a tirar.');
                            readln;
                            dado:=(1+random(6));
                            writeln;
                            writeln('El valor del dado es ',dado);
                            writeln;
                            posicionA:=posicionA + dado;
                            writeln('El jugador A esta en la casilla: ',posicionA);
                            writeln;
                      end;



             If ContadorTurnosA=0 then
                jugador:='B'
        end;

             If posicionA=18 then
             begin
                            begin
                            writeln;
                            writeln('Has caido en oca.');
                            writeln;
                            writeln('Pasas a la siguiente oca.');
                            posicionA:=23;
                            writeln('La nueva posicion es la casilla: ',posicionA);
                            writeln('Pulsa enter para volver a tirar.');
                            readln;
                            dado:=(1+random(6));
                            writeln;
                            writeln('El valor del dado es ',dado);
                            writeln;
                            posicionA:=posicionA + dado;
                            writeln('El jugador A esta en la casilla: ',posicionA);
                            writeln
                      end;



             If ContadorTurnosA=0 then
                jugador:='B'
        end;


             If posicionA=23 then
             begin
                            begin
                            writeln;
                            writeln('Has caido en oca.');
                            writeln;
                            writeln('Pasas a la siguiente oca.');
                            posicionA:=27;
                            writeln('La nueva posicion es la casilla: ',posicionA);
                            writeln('Has llegado al jardin de la oca.');
                            writeln('Has ganado el juego.');
                            writeln;


                      end;
        end;


     {Juega la maquina}

      If (jugador='B') or (jugador='b') then

              begin
                   writeln;
                   ContadorTurnosB:=ContadorTurnosB + 1;
                   writeln;
                   writeln('Juega jugador B.');
                   dado:=(1+random(6));
                   writeln;
                   writeln('El valor del dado es ',dado);
                   posicionB:=posicionB + dado;
                   writeln;
                   writeln('El jugador B esta en la casilla: ',posicionB);

                   {Casillas puente}


                   If ((posicionB=6) or (posicionB=12)) then
                   begin
                        writeln;
                        writeln('Has caido en puente');
                        writeln('Pasas a la casilla posada: ',posada);
                        posicionB:=posada;
                        ContadorTurnosB:=0
                   end;

                   {Casilla posada}

             If posicionB=posada then
                begin
                     writeln('Pierdes turno.');
                     jugador:='A'
                end;

                  {Casilla calavera}

             If posicionB=calavera then
                begin
                     writeln('Has caido en casilla calavera.');
                     writeln('Vuelves a la casilla 1');
                     posicionB:=1;
                 end;

              {Oca}

             If  posicionA=5 then
                      begin
                            writeln;
                            writeln('Has caido en oca.');
                            writeln;
                            writeln('Pasas a la siguiente oca.');
                            posicionA:=9;
                            writeln('Pulsa enter para volver a tirar.');
                            readln;
                            dado:=(1+random(6));
                            writeln;
                            writeln('El valor del dado es ',dado);
                            writeln;
                            posicionA:=posicionA + dado;
                            writeln('El jugador A esta en la casilla: ',posicionA);
                        end;
                                 If ContadorTurnosA=0 then
                                    jugador:='B'
                      end;

             If posicionA=9 then
             begin
                            begin
                            writeln;
                            writeln('Has caido en oca.');
                            writeln;
                            writeln('Pasas a la siguiente oca.');
                            posicionA:=14;
                            writeln('La nueva posicion es la casilla: ',posicionA);
                            writeln('Pulsa enter para volver a tirar.');
                            readln;
                            dado:=(1+random(6));
                            writeln;
                            writeln('El valor del dado es ',dado);
                            writeln;
                            posicionA:=posicionA + dado;
                            writeln('El jugador A esta en la casilla: ',posicionA);

                      end;



             If ContadorTurnosA=0 then
                jugador:='B'
        end;




             If posicionA=14 then
             begin
                            begin
                            writeln;
                            writeln('Has caido en oca.');
                            writeln;
                            writeln('Pasas a la siguiente oca.');
                            posicionA:=18;
                            writeln('La nueva posicion es la casilla: ',posicionA);
                            writeln('Pulsa enter para volver a tirar.');
                            readln;
                            dado:=(1+random(6));
                            writeln;
                            writeln('El valor del dado es ',dado);
                            writeln;
                            posicionA:=posicionA + dado;
                            writeln('El jugador A esta en la casilla: ',posicionA);

                      end;



             If ContadorTurnosA=0 then
                jugador:='B'
        end;

             If posicionA=18 then
             begin
                            begin
                            writeln;
                            writeln('Has caido en oca.');
                            writeln;
                            writeln('Pasas a la siguiente oca.');
                            posicionA:=23;
                            writeln('La nueva posicion es la casilla: ',posicionA);
                            writeln('Pulsa enter para volver a tirar.');
                            readln;
                            dado:=(1+random(6));
                            writeln;
                            writeln('El valor del dado es ',dado);
                            writeln;
                            posicionA:=posicionA + dado;
                            writeln('El jugador A esta en la casilla: ',posicionA);

                      end;



             If ContadorTurnosA=0 then
                jugador:='B'
        end;


             If posicionA=23 then
             begin
                            begin
                            writeln;
                            writeln('Has caido en oca.');
                            writeln;
                            writeln('Pasas a la siguiente oca.');
                            posicionA:=27;
                            writeln('La nueva posicion es la casilla: ',posicionA);
                            writeln('Has llegado al jardin de la oca.');
                            writeln('Has ganado el juego.');
                            writeln;


                      end;

        end;


                  If (ContadorTurnosA=0) then
                      jugador:='A'


until ((posicionA>26) and (posicionA<33) or
      (posicionB>26) and (posicionB<33)) ;

   finaliza(posicionA,posicionB)


end.
