PROGRAM ElJuegoDeLaOca;
{Programa de interaccin Usuario-Mquina para jugar a la OCA}
{Vlido para 1 jugador contra la mquina}
{Tira primero el usuario}
{ VARIABLE PUNTUALES QUE UTILIZO:
coo : casilla origen ordenador
coj : casilla origen jugador
cao : casilla actual ordenador
caj : casilla actual jugador
vdo : valor dado ordenador
vdj : valor dado jugador
tdo : tirada dado ordenador
tdj : tirada dado jugador }

VAR
    posada:integer; {UTILIZADA EN EL PROCEDURE casilla_posada y
     casilla_calavera, no la pongo en los procedures porque no puedo
     al utilizarse en 2 procedures diferentes}
    calavera:integer; {UTILIZADA EN EL PROCEDUR casilla_calavera. La podra
     definir slo en ese procedure, pero la dejo aqu}
    caj: integer;  {CASILLA ACTUAL JUGADOR}
    cao: integer;  {CASILLA ACTUAL ORDENADOR}


{**************************************************************************}
PROCEDURE texto_entrada;
 BEGIN

    writeln (' *************************************************************');
    writeln (' *************************************************************');
    writeln (' *************************************************************');
    writeln (' **                                                         **');
    writeln (' **                                                         **');
    writeln (' **                                                         **');
    writeln (' **                                                         **');
    writeln (' **        JJJJJJ  U    U  EEEEEE   GGGGGGG   OOOOOO        **');
    writeln (' **            JJ  U    U  EE       G     G   O    O        **');
    writeln (' **             J  U    U  EEEEEE   G         O    O        **');
    writeln (' **        JJ   J  U    U  EE       G   GGG   O    O        **');
    writeln (' **        J    J  U    U  EE       GG   GG   O    O        **');
    writeln (' **        JJJJJJ  UUUUUU  EEEEEE   GGGGGGG   OOOOOO        **');
    writeln (' **                                                         **');
    writeln (' **                                                         **');
    writeln (' **                                                         **');
    writeln (' **                                                         **');
    writeln (' **        DDDDD   EEEEEE       L         AAA               **');
    writeln (' **        D    D  E            L        A   A              **');
    writeln (' **        D    D  EEEEEE       L       AA   AA             **');
    writeln (' **        D    D  E            L       AAAAAAA             **');
    writeln (' **        D    D  E            L       A     A             **');
    writeln (' **        DDDDD   EEEEEE       LLLLLL  A     A             **');
    writeln (' **                                                         **');
    writeln (' **                                                         **');
    writeln (' **                                                         **');
    writeln (' **                                                         **');
    writeln (' **              OOOOOO  CCCCCC    AAA                      **');
    writeln (' **              O    O  C   CC   A   A                     **');
    writeln (' **              O    O  C       AA   AA                    **');
    writeln (' **              O    O  C       AAAAAAA                    **');
    writeln (' **              O    O  C   CC  A     A                    **');
    writeln (' **              OOOOOO  CCCCCC  A     A                    **');
    writeln (' **                                                         **');
    writeln (' **                                                         **');
    writeln (' **                                                         **');
    writeln (' **                                                         **');
    writeln (' *************************************************************');
    writeln (' *************************************************************');
    writeln (' *************************************************************');
    writeln (' ');
    writeln (' ');
    writeln (' -------------------------------------------------------------');
    writeln (' --              Bienvenido al Juego de la Oca              --');
    writeln ('                                                              ');
    writeln (' --               Pulsa INTRO para comenzar                 --');
    writeln (' -------------------------------------------------------------');
    writeln (' ');
    writeln (' ');
    writeln (' ');
    readln ;
  END;
{**************************************************************************}

PROCEDURE dibujo_inicial_tablero;
 BEGIN

      writeln (' -------------------------------------------------------------------------');
      writeln (' -     1-       2-       3-     4-OCA 5-PUENTE 6-     7-     8-OCA  9-');
      writeln (' -      -        -        -      -OCA  -PUENTE  -      -      -OCA   -');
      writeln (' -      -        -        -      -OCA  -PUENTE  -      -      -OCA   -');
      writeln (' -      -        -        -      -OCA  -PUENTE  -      -      -OCA   -');
      writeln (' -      -        -        -      -OCA  -PUENTE  -      -      -OCA   -');
      writeln (' -------------------------------------------------------------------------');
      writeln (' -    10-     11-PUENTE 12-    13-OCA 14-     15-    16-    17-OCA 18-');
      writeln (' -      -       -PUENTE   -      -OCA   -       -      -      -OCA   -');
      writeln (' -      -       -PUENTE   -      -OCA   -       -      -      -OCA   -');
      writeln (' -      -       -PUENTE   -      -OCA   -       -      -      -OCA   -');
      writeln (' -      -       -PUENTE   -      -OCA   -       -      -      -OCA   -');
      writeln (' -------------------------------------------------------------------------');
      writeln (' -    19-     20-       21-    22-OCA 23-     24-    25-    26-FIN 27-');
      writeln (' -      -       -         -      -OCA   -       -      -      -FIN   -');
      writeln (' -      -       -         -      -OCA   -       -      -      -FIN   -');
      writeln (' -      -       -         -      -OCA   -       -      -      -FIN   -');
      writeln (' -      -       -         -      -OCA   -       -      -      -FIN   -');
      writeln (' -------------------------------------------------------------------------');
 END;
{*******************************************************************************************}
PROCEDURE casilla;
  BEGIN
   {INDICA AL USUARIO, QUE CASILLAS ESTAN RESERVADAS E INFORMA DE
   LOS CONDICIONANTES DEL PROGRAMA}
    writeln (' ');
    writeln (' ');
    writeln (' -------------------------------------------------------------------------');
    writeln (' --          Antes de comenzar a jugar, tienes que saber que            --');
    writeln (' --                                                                     --');
    writeln (' --         debes elegir donde colocar la Posada y la Calavera          --');
    writeln (' --                                                                     --');
    writeln (' --       para colocarlas, debes tener cuidado en no seleccionar        --');
    writeln (' --                                                                     --');
    writeln (' --   ninguna de las casillas que ya estn reservadas dentro del juego  --');
    writeln (' -------------------------------------------------------------------------');
    writeln (' -------------------------------------------------------------------------');
    writeln (' --                                                                     --');
    writeln (' --                                                                     --');
    writeln (' --                                                                     --');
    writeln (' --    Las casillas reservadas dentro del juego son las siguientes      --');
    writeln (' --                                                                     --');
    writeln (' --                                                                     --');
    writeln (' --                       Casilla 5 : OCA                               --');
    writeln (' --                                                                     --');
    writeln (' --                       Casilla 6 : PUENTE                            --');
    writeln (' --                                                                     --');
    writeln (' --                       Casilla 9 : OCA                               --');
    writeln (' --                                                                     --');
    writeln (' --                       Casilla 12: PUENTE                            --');
    writeln (' --                                                                     --');
    writeln (' --                       Casilla 14: OCA                               --');
    writeln (' --                                                                     --');
    writeln (' --                       Casilla 18: OCA                               --');
    writeln (' --                                                                     --');
    writeln (' --                       Casilla 23: OCA                               --');
    writeln (' --                                                                     --');
    writeln (' --        Casilla 27: JARDIN DE OCA -  CASILLA GANADORA          --');
    writeln (' --                                                                     --');
    writeln (' -------------------------------------------------------------------------');

 END;

{***************************************************************************}

PROCEDURE casilla_posada; {PIDE AL JUGADOR QUE SELECCIONE DONDE COLOCAR LA POSADA}
{$I-}
 BEGIN
    writeln (' ');
    writeln ('         *******************************************************');
    writeln ('         ****                                               ****');
    writeln ('         ****      SELECCIONA DONDE COLOCAR LA POSADA       ****');
    writeln ('         ****                                               ****');
    writeln ('         *******************************************************');
    writeln (' ');
    writeln (' ');
    writeln (' -------------------------------------------------------------------------');
    writeln (' --                                                                     --');
    writeln (' --       Comienza indicando donde quieres colocar la Posada:           --');
    writeln (' --                                                                     --');
    writeln (' --    Adems, debes colocar la posada entre la casilla 12 y la 27      --');
    writeln (' --                                                                     --');
    writeln (' --           La Posada te dejar un turno sin jugar                    --');
    writeln (' --                                                                     --');
    writeln (' --    Recuerda que caers en la posada siempre que caigas en ella      --');
    writeln (' --                                                                     --');
    writeln (' --                    o caigas en un puente                            --');
    writeln (' --                                                                     --');
    writeln (' -------------------------------------------------------------------------');
    readln (posada);
    WHILE ((IORESULT<>
    0) OR (posada=5) OR (posada=6) OR (posada=12) OR
    (posada=14) OR (posada=18) OR (posada=23) OR
    (posada <=12) OR (posada >=27))
    DO
    BEGIN
    writeln (' ');
    writeln (' ');
    writeln (' ');
    writeln ('         ------------------------------------------------------- ');
    writeln ('         --     Lo siendo, no puedes seleccionar esa casilla  -- ');
    writeln ('         --                                                   -- ');
    writeln ('         --     Esa casilla dentro del tablero est reservada -- ');
    writeln ('         --                                                   -- ');
    writeln ('         --       O no est por encima de la casilla 12       -- ');
    writeln ('         --                                                   -- ');
    writeln ('         --          O por debajo de la casilla 27            -- ');
    writeln ('         --                                                   -- ');
    writeln ('         --  Indica de nuevo donde quieres colocar la Posada  -- ');
    writeln ('         ------------------------------------------------------- ');
    readln (posada);
    END;
{$I+}
END;

{***************************************************************************}

PROCEDURE casilla_calavera;

 BEGIN

    {SE PIDE AL USUARIO LA CASILLA EN LA QUE QUIERE COLOCAR LA CALAVERA}
{$I-}
    writeln (' ');
    writeln (' ');
    writeln ('         *******************************************************');
    writeln ('         ****                                               ****');
    writeln ('         ****     SELECCIONA DONDE COLOCAR LA CALAVERA      ****');
    writeln ('         ****                                               ****');
    writeln ('         *******************************************************');
    writeln (' ');
    writeln (' ');
    writeln (' -------------------------------------------------------------------------');
    writeln (' --                                                                     --');
    writeln (' --       Ahora indica en que casilla quieres colocar la Calavera:      --');
    writeln (' --                                                                     --');
    writeln (' --     La Calavera te dejar de nuevo en la Casilla 1 del Juego        --');
    writeln (' --                                                                     --');
    writeln (' -------------------------------------------------------------------------');
    readln (calavera);

    WHILE ((IORESULT <> 0) OR (calavera<=0) OR (calavera>=27) OR
    (calavera=5) OR (calavera=6) OR (calavera=12) OR (calavera=14)
    OR (calavera=18) OR (calavera=23) OR (calavera=posada))
    DO
    BEGIN
    writeln (' ');
    writeln (' ');
    writeln (' ');
    writeln ('         ------------------------------------------------------------');
    writeln ('         --      Lo siendo, no puedes seleccionar esa casilla      --');
    writeln ('         --                                                        --');
    writeln ('         --    Esa casilla dentro del tablero est reservada       --');
    writeln ('         --                                                        --');
    writeln ('         --       o la has elejido para tener LA POSADA            --');
    writeln ('         --                                                        --');
    writeln ('         --  Indica de nuevo donde quieres colocar la Calavera     --');
    writeln ('         ------------------------------------------------------------');
    readln (calavera);
    END;

 END;

{***************************************************************************}

PROCEDURE jugada_primera_jugador; {PRIMERA JUGADA QUE REALIZA EL JUGADOR}
 CONST
      coj=0; {CASILLA ORIGEN JUGADOR} {DONDE ESTA AL COMENZAR EL JUEGO}
 VAR
      vdj:integer; {VALOR DADO JUGADOR}
      tdj: integer;{TIRADA DADO JUGADOR}

 BEGIN
      writeln (' ');
      writeln (' ');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         ******              COMENZAMOS A JUGAR                ******');
      writeln ('         --                                                        --');
      writeln ('         ******       PULSA INTRO Y REALIZARAS UNA TIRADA      ******');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      readln;
      randomize;
      FOR
      vdj :=0 TO 1
      DO
      tdj:=(random(6)+1);
      writeln (' ');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                            Has sacado un: ' ,tdj,                '  ');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln (' ');
      readln ;
      caj:=coj + tdj;
      writeln (' ');
      writeln (' ');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                           Has pasado de la casilla: ' , coj,     '  ');
      writeln ('         --                                                        --');
      writeln ('                              A la casilla: ' , caj,              '  ');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln (' ');
      writeln (' ');
 END;

{***************************************************************************************}

PROCEDURE jugadas_jugador; {RESTO DE JUGADAS QUE REALIZA EL JUGADOR}

 VAR

     vdj: integer; {VALOR DADO JUGADOR}
     tdj: integer; {TIRADA DADO JUGADOR}

 BEGIN
      writeln (' ');
      writeln (' ');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         ******            AHORA TE TOCA A TI DE NUEVO         ******');
      writeln ('         --                                                        --');
      writeln ('         ******         PULSA INTRO Y REALIZARAS UNA TIRADA    ******');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      readln;
      randomize;
      FOR
      vdj :=0 TO 1
      DO
      tdj:=(random(6)+1);
      writeln (' ');
      writeln (' ');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                               Has sacado un:  ' , tdj,           '  ');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                           Has pasado de la casilla: ' , caj,     '  ');
      caj:=caj+tdj;
      writeln ('         --                                                        --');
      writeln ('                               A la casilla: ' , caj,             '  ');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln (' ');
      writeln (' ');

END;

{******************************************************************************}

PROCEDURE jugada_primera_ordenador; {PRIMERA JUGADA QUE REALIZA EL ORDENADOR}
 CONST
     coo=0; {CASILLA ORIGEN ORDENADOR} {DONDE ESTA AL COMENZAR EL JUEGO}
 VAR
     vdo: integer; {VALOR DADO ORDENADOR}
     tdo: integer; {VALOR TIRADA ORDENADOR}


 BEGIN
      writeln (' ');
      writeln (' ');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         ******              AHORA ME TOCA A MI                ******');
      writeln ('         --                                                        --');
      writeln ('         ******        PULSA INTRO Y REALIZARE UNA TIRADA      ******');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      readln;
      randomize;
      FOR
      vdo :=0 TO 1
      DO
      tdo:=(random(6)+1);
      writeln (' ');
      writeln (' ');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                               He sacado un:  ' , tdo,           '  ');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                           He pasado de la casilla: ' , coo,     '  ');
      cao:=coo+tdo;
      writeln ('         --                                                        --');
      writeln ('                               A la casilla: ' , cao,             '  ');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln (' ');
      writeln (' ');

END;

{********************************************************************************}

PROCEDURE jugadas_ordenador; {RESTO DE JUGADAS QUE REALIZA EL ORDENADOR}
 VAR
     vdo: integer; {VALOR DADO ORDENADOR}
     tdo: integer; {VALOR TIRADA ORDENADOR}


 BEGIN
      writeln (' ');
      writeln (' ');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         ******              AHORA ME TOCA A MI                ******');
      writeln ('         --                                                        --');
      writeln ('         ******        PULSA INTRO Y REALIZARE UNA TIRADA      ******');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      readln;
      randomize;
      FOR
      vdo :=0 TO 1
      DO
      tdo:=(random(6)+1);
      writeln (' ');
      writeln (' ');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                               He sacado un:  ' , tdo,           '  ');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                           He pasado de la casilla: ' , cao,     '  ');
      cao:=cao+tdo;
      writeln ('         --                                                        --');
      writeln ('                               A la casilla: ' , cao,             '  ');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln (' ');
      writeln (' ');

END;
{*******************************************************************************}
{ PROCEDURES DE TIPO DE JUGADA SI OCA, PUENTE, POSADA O CALAVERA DIFERENCIANDO
SI ES PARA EL JUGADOR O PARA EL ORDENADOR ADEMAS DE DIFERENCIARSE POR NUMERO}
{*******************************************************************************}
PROCEDURE oca_5_caj;
 VAR
 vdj :integer;
 tdj : integer;
 BEGIN
  IF caj=5
  THEN
   caj:=5+4;
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         --      -- OCA -- OCA -- OCA -- OCA -- OCA -- OCA --      --');
      writeln ('         --                                                        --');
      writeln ('         --                                                        --');
      writeln ('                    Has saltado hasta la casilla ' , caj           );
      writeln ('         --                                                        --');
      writeln ('         --     Y de OCA a OCA y tiras porque te toca        --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         --        Pulsa Intro y realizars una tirada             --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      readln;
      randomize;
      FOR
      vdj :=0 TO 1
      DO
      tdj:=(random(6)+1);
      writeln (' ');
      writeln (' ');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                               Has sacado un:  ' , tdj,           '  ');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                           Has pasado de la casilla: ' , caj,     '  ');
      caj:=caj+tdj;
      writeln ('         --                                                        --');
      writeln ('                               A la casilla: ' , caj,             '  ');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln (' ');
      writeln (' ');

 END;
{*************************************************************************}
PROCEDURE oca_9_caj;
 VAR
 vdj :integer;
 tdj : integer;
 BEGIN
  IF caj=9
  THEN
   caj:=9+5;
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         --      -- OCA -- OCA -- OCA -- OCA -- OCA -- OCA --      --');
      writeln ('         --                                                        --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                    Has saltado hasta la casilla ' , caj           );
      writeln ('         --                                                        --');
      writeln ('         --     Y de OCA a OCA y tiras porque te toca        --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         --        Pulsa Intro y realizars una tirada             --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      readln;
      randomize;
      FOR
      vdj :=0 TO 1
      DO
      tdj:=(random(6)+1);
      writeln (' ');
      writeln (' ');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                               Has sacado un:  ' , tdj,           '  ');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                           Has pasado de la casilla: ' , caj,     '  ');
      caj:=caj+tdj;
      writeln ('         --                                                        --');
      writeln ('                               A la casilla: ' , caj,             '  ');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln (' ');
      writeln (' ');

 END;

 {*************************************************************************}
PROCEDURE oca_14_caj;
 VAR
 vdj :integer;
 tdj : integer;
 BEGIN
  IF caj=14
  THEN
   caj:=14+4;
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         --      -- OCA -- OCA -- OCA -- OCA -- OCA -- OCA --      --');
      writeln ('         --                                                        --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                    Has saltado hasta la casilla ' , caj           );
      writeln ('         --                                                        --');
      writeln ('         --     Y de OCA a OCA y tiras porque te toca        --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         --        Pulsa Intro y realizars una tirada             --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      readln;
      randomize;
      FOR
      vdj :=0 TO 1
      DO
      tdj:=(random(6)+1);
      writeln (' ');
      writeln (' ');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                               Has sacado un:  ' , tdj,           '  ');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                           Has pasado de la casilla: ' , caj,     '  ');
      caj:=caj+tdj;
      writeln ('         --                                                        --');
      writeln ('                               A la casilla: ' , caj,             '  ');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln (' ');
      writeln (' ');

 END;

 {*************************************************************************}
PROCEDURE oca_18_caj;
 VAR
 vdj :integer;
 tdj : integer;
 BEGIN
  IF caj=18
  THEN
   caj:=18+5;
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         --      -- OCA -- OCA -- OCA -- OCA -- OCA -- OCA --      --');
      writeln ('         --                                                        --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                    Has saltado hasta la casilla ' , caj           );
      writeln ('         --                                                        --');
      writeln ('         --     Y de OCA a OCA y tiras porque te toca        --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         --        Pulsa Intro y realizars una tirada             --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      readln;
      randomize;
      FOR
      vdj :=0 TO 1
      DO
      tdj:=(random(6)+1);
      writeln (' ');
      writeln (' ');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                               Has sacado un:  ' , tdj,           '  ');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                           Has pasado de la casilla: ' , caj,     '  ');
      caj:=caj+tdj;
      writeln ('         --                                                        --');
      writeln ('                               A la casilla: ' , caj,             '  ');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln (' ');
      writeln (' ');


 END;
 {*************************************************************************}
PROCEDURE oca_23_caj;
 VAR
 vdj :integer;
 tdj : integer;
 BEGIN
  IF caj=23
  THEN
   caj:=23+4;
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         --      -- OCA -- OCA -- OCA -- OCA -- OCA -- OCA --      --');
      writeln ('         --      -- OCA -- OCA -- OCA -- OCA -- OCA -- OCA --      --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                    Has saltado hasta la casilla ' , caj           );
      writeln ('         --                                                        --');
      writeln ('         --                   HAS GANADO                     --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         --                   HAS GANADO                     --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln;

 END;
{*************************************************************************}
PROCEDURE oca_5_cao;
 VAR
 vdo :integer;
 tdo : integer;
 BEGIN
  IF cao=5
  THEN
   cao:=5+4;
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         --      -- OCA -- OCA -- OCA -- OCA -- OCA -- OCA --      --');
      writeln ('         --                                                        --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                    He saltado hasta la casilla ' , cao            );
      writeln ('         --                                                        --');
      writeln ('         --     Y de OCA a OCA y tiro porque me toca         --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         --        Pulsa Intro y realizar una tirada              --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      readln;
      randomize;
      FOR
      vdo :=0 TO 1
      DO
      tdo:=(random(6)+1);
      writeln (' ');
      writeln (' ');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                               He sacado un:  ' , tdo,            '  ');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                           He pasado de la casilla: ' , cao,      '  ');
      cao:=cao+tdo;
      writeln ('         --                                                        --');
      writeln ('                               A la casilla: ' , cao,             '  ');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln (' ');
      writeln (' ');


 END;
{***************************************************************************************}
PROCEDURE oca_9_cao;
 VAR
 vdo :integer;
 tdo : integer;
 BEGIN
  IF cao=9
  THEN
   cao:=9+5;
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         --      -- OCA -- OCA -- OCA -- OCA -- OCA -- OCA --      --');
      writeln ('         --                                                        --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                    He saltado hasta la casilla ' , cao            );
      writeln ('         --                                                        --');
      writeln ('         --     Y de OCA a OCA y tiro porque me toca         --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         --        Pulsa Intro y realizar una tirada              --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      readln;
      randomize;
      FOR
      vdo :=0 TO 1
      DO
      tdo:=(random(6)+1);
      writeln (' ');
      writeln (' ');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                               He sacado un:  ' , tdo,            '  ');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                           He pasado de la casilla: ' , cao,      '  ');
      cao:=cao+tdo;
      writeln ('         --                                                        --');
      writeln ('                               A la casilla: ' , cao,             '  ');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln (' ');
      writeln (' ');

 END;

 {*************************************************************************}
PROCEDURE oca_14_cao;
 VAR
 vdo :integer;
 tdo : integer;
 BEGIN
  IF cao=14
  THEN
   cao:=14+4;
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         --      -- OCA -- OCA -- OCA -- OCA -- OCA -- OCA --      --');
      writeln ('         --                                                        --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                    He saltado hasta la casilla ' , cao            );
      writeln ('         --                                                        --');
      writeln ('         --     Y de OCA a OCA y tiro porque me toca         --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         --        Pulsa Intro y realizar una tirada              --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      readln;
      randomize;
      FOR
      vdo :=0 TO 1
      DO
      tdo:=(random(6)+1);
      writeln (' ');
      writeln (' ');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                               He sacado un:  ' , tdo,            '  ');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                           He pasado de la casilla: ' , cao,      '  ');
      cao:=cao+tdo;
      writeln ('         --                                                        --');
      writeln ('                               A la casilla: ' , cao,             '  ');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln (' ');
      writeln (' ');

 END;

 {**************************************************************************************}
PROCEDURE oca_18_cao;
 VAR
 vdo :integer;
 tdo : integer;
 BEGIN
  IF cao=18
  THEN
   cao:=18+5;
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         --      -- OCA -- OCA -- OCA -- OCA -- OCA -- OCA --      --');
      writeln ('         --                                                        --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                    He  saltado hasta la casilla ' , cao           );
      writeln ('         --                                                        --');
      writeln ('         --     Y de OCA a OCA y tiro porque me toca         --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         --        Pulsa Intro y realizar una tirada              --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      readln;
      randomize;
      FOR
      vdo :=0 TO 1
      DO
      tdo:=(random(6)+1);
      writeln (' ');
      writeln (' ');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                               He sacado un:  ' , tdo,            '  ');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                           He pasado de la casilla: ' , cao,      '  ');
      cao:=cao+tdo;
      writeln ('         --                                                        --');
      writeln ('                               A la casilla: ' , cao,              '  ');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln (' ');
      writeln (' ');


 END;

 {*************************************************************************}
PROCEDURE oca_23_cao;
 VAR
 vdo :integer;
 tdo : integer;
 BEGIN
  IF cao=23
  THEN
   cao:=23+4;
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         --      -- OCA -- OCA -- OCA -- OCA -- OCA -- OCA --      --');
      writeln ('         --      -- OCA -- OCA -- OCA -- OCA -- OCA -- OCA --      --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                    He saltado hasta la casilla ' , cao           );
      writeln ('         --                                                        --');
      writeln ('         --                   HE GANADO                      --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         --                   HE GANADO                      --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln;

 END;
{***************************************************************************************}

PROCEDURE puente_6_caj;
 BEGIN
  IF caj=6
  THEN
  caj:=posada;
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         --         --  PUENTE  --  PUENTE  --  PUENTE --          --');
      writeln ('         --         --  PUENTE  --  PUENTE  --  PUENTE --          --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                    Has saltado hasta la casilla ' , posada        );
      writeln ('         --                                                        --');
      writeln ('         --          Porque en ella habas puesto LA POSADA        --');
      writeln ('         --                                                        --');
      writeln ('         --             --       PIERDES TURNO        --           --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln (' ');

  END;
{*************************************************************************}
PROCEDURE puente_6_cao;
 BEGIN
  IF
  cao=6
  THEN
  cao:=posada;
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         --         --  PUENTE  --  PUENTE  --  PUENTE --          --');
      writeln ('         --         --  PUENTE  --  PUENTE  --  PUENTE --          --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                    He saltado hasta la casilla ' , posada         );
      writeln ('         --                                                        --');
      writeln ('         --          Porque en ella habas puesto LA POSADA        --');
      writeln ('         --                                                        --');
      writeln ('         --            --       PIERDO TURNO        --             --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln (' ');

  END;
{*************************************************************************}

PROCEDURE puente_12_caj;
 BEGIN
  IF caj=12
  THEN
  caj:=posada;
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         --         --  PUENTE  --  PUENTE  --  PUENTE --          --');
      writeln ('         --         --  PUENTE  --  PUENTE  --  PUENTE --          --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                    Has saltado hasta la casilla ' , posada        );
      writeln ('         --                                                        --');
      writeln ('         --          Porque en ella habas puesto LA POSADA        --');
      writeln ('         --                                                        --');
      writeln ('         --            --       PIERDES TURNO        --            --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln (' ');


  END;
{*************************************************************************}
PROCEDURE puente_12_cao;
 BEGIN
  IF
  cao=12
  THEN
  cao:=posada;
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         --         --  PUENTE  --  PUENTE  --  PUENTE --          --');
      writeln ('         --         --  PUENTE  --  PUENTE  --  PUENTE --          --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                    He saltado hasta la casilla ' , posada         );
      writeln ('         --                                                        --');
      writeln ('         --          Porque en ella habas puesto LA POSADA        --');
      writeln ('         --                                                        --');
      writeln ('         --            --       PIERDO TURNO        --             --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln (' ');

  END;
{***************************************************************************}

 PROCEDURE calavera_caj;
 BEGIN
  IF caj=calavera
     THEN
     caj:=1;
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         --       --  CALAVERA  --  CALAVERA  -- CALAVERA  --      --');
      writeln ('         --       --  CALAVERA  --  CALAVERA  -- CALAVERA  --      --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                          VUELVES A LA CASILLA  1              ');
      writeln ('         --                                                        --');
      writeln ('         --                           Y                            --');
      writeln ('         --                                                        --');
      writeln ('         --             --       PIERDES TURNO        --           --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln (' ');

  END;

{***************************************************************************}
 PROCEDURE calavera_cao;
 BEGIN
  IF cao=calavera
     THEN
     cao:=1;
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         --       --  CALAVERA  --  CALAVERA  -- CALAVERA  --      --');
      writeln ('         --       --  CALAVERA  --  CALAVERA  -- CALAVERA  --      --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                          VUELVO A LA CASILLA  1               ');
      writeln ('         --                                                        --');
      writeln ('         --                           Y                            --');
      writeln ('         --                                                        --');
      writeln ('         --              --       PIERDO TURNO        --           --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln (' ');

  END;

{***************************************************************************}

 PROCEDURE posada_caj;
 BEGIN
  IF caj=posada
     THEN
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         --         --  POSADA  --  POSADA  --  POSADA --          --');
      writeln ('         --         --  POSADA  --  POSADA  --  POSADA --          --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                         Has caido en LA POSADA                   ');
      writeln ('         --                                                        --');
      writeln ('         --          Porque en ella habas puesto LA POSADA        --');
      writeln ('         --                                                        --');
      writeln ('         --            --       PIERDES TURNO        --            --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln (' ');

  END;

 {***************************************************************************}

 PROCEDURE posada_cao;
 BEGIN
  IF cao=posada
     THEN
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         --         --  POSADA  --  POSADA  --  POSADA --          --');
      writeln ('         --         --  POSADA  --  POSADA  --  POSADA --          --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('                         He caido en LA POSADA                    ');
      writeln ('         --                                                        --');
      writeln ('         --          Porque en ella habas puesto LA POSADA        --');
      writeln ('         --                                                        --');
      writeln ('         --            --       PIERDO TURNO        --             --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln (' ');

  END;
{**************************************************************************************}
{**************************************************************************************}
{ PROCEDIMIENTOS COMPROBACIONES DEL PROGRAMA, TESTEOS TRAS TIRADAS }
{**************************************************************************************}
{**************************************************************************************}
PROCEDURE comprobar_jugador;
 BEGIN
      CASE caj OF
      5 : oca_5_caj;
      6 : puente_6_caj;
      9 : oca_9_caj;
      12 : puente_12_caj;
      14: oca_14_caj;
      18: oca_18_caj;
      23: oca_23_caj;
      ELSE
      IF caj=calavera
      THEN
      calavera_caj
      ELSE
      IF caj=posada
      THEN
      posada_caj
      END;
END;


{**************************************************************************************}
PROCEDURE comprobar_ordenador;
 BEGIN
      CASE cao OF
      5 : oca_5_cao;
      6 : puente_6_cao;
      9 : oca_9_cao;
      12 : puente_12_cao;
      14: oca_14_cao;
      18: oca_18_cao;
      23: oca_23_cao;
      ELSE
      IF cao=calavera
      THEN
      calavera_cao
      ELSE
      IF cao=posada
      THEN
      posada_cao
      END;
END;

{**************************************************************************************}
PROCEDURE celebracion_j;
 BEGIN
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         --         --   HAS GANADO   --   HAS GANADO  --          --');
      writeln ('         --         --   HAS GANADO   --   HAS GANADO  --          --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         --         --   HAS GANADO   --   HAS GANADO  --          --');
      writeln ('         --         --   HAS GANADO   --   HAS GANADO  --          --');
      writeln ('         --         --   HAS GANADO   --   HAS GANADO  --          --');
      writeln ('         --         --   HAS GANADO   --   HAS GANADO  --          --');
      writeln ('         --         --   HAS GANADO   --   HAS GANADO  --          --');
      writeln ('         --         --   HAS GANADO   --   HAS GANADO  --          --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln (' ');
      writeln (' ');
 END;
{**************************************************************************************}
{**************************************************************************************}
PROCEDURE celebracion_o;
 BEGIN
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         --          --   HE GANADO   --    HE GANADO  --          --');
      writeln ('         --          --   HE GANADO   --    HE GANADO  --          --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln ('         --                                                        --');
      writeln ('         --         --    HE GANADO   --    HE GANADO  --          --');
      writeln ('         --         --    HE GANADO   --    HE GANADO  --          --');
      writeln ('         --         --    HE GANADO   --    HE GANADO  --          --');
      writeln ('         --         --    HE GANADO   --    HE GANADO  --          --');
      writeln ('         --         --    HE GANADO   --    HE GANADO  --          --');
      writeln ('         --         --    HE GANADO   --    HE GANADO  --          --');
      writeln ('         --                                                        --');
      writeln ('         ------------------------------------------------------------');
      writeln ('         ------------------------------------------------------------');
      writeln (' ');
      writeln (' ');
 END;
{**************************************************************************************}
{**************************************************************************************}
{**************************************************************************************}
{ COMIENZA EL PROGRAMA }
{**************************************************************************************}
{**************************************************************************************}
{**************************************************************************************}

BEGIN {PROGRAMA DEL JUEGO DE LA OCA}
    texto_entrada;
    casilla;
    readln;
    dibujo_inicial_tablero;
    casilla_posada;
    casilla_calavera;
    jugada_primera_jugador;
      comprobar_jugador;
    jugada_primera_ordenador;
      comprobar_ordenador;
    REPEAT
    jugadas_jugador;
      comprobar_jugador;
    jugadas_ordenador;
      comprobar_ordenador;
    UNTIL
    (caj>=27) or (cao>=27);
    IF caj >=27
    THEN
     celebracion_j
    ELSE
     celebracion_o;

    readln;

{ ME FALTA TERMINAR LA ROBUSTEZ DEL JUEGO, ASI COMO RESTAR LAS TIRADAS SUPERIORES
A LA CASILLA 27 }

 END.









