program juego_de_la_oca;
{este algoritmo esta basado en el juego de la oca}

       uses  {ejecuta la libreria de entorno grafico}
           crt;

      const   {defino las casillas que no van a variar}

        jardin = 27;
        oca_1 = 5;
        oca_2 = 9;
        oca_3 = 14;
        oca_4 = 18;
        oca_5 = 23;
        puente_1 = 6;
        puente_2 = 12;

      type   {creo unos nuevos tipos para acotar su rango de uso}

        t_casilla = 0..27;
        t_dado = 1..6;

      var   {defino las casillas que pueden cambiar segun el jugador
            y las fichas}

        ficha_jugador: t_casilla;
        ficha_ordenador: t_casilla;
        ficha_anterior_jugador: t_casilla;
        ficha_anterior_ordenador: t_casilla;
        posada_casilla: t_casilla;
        calavera_casilla: t_casilla;
        turno_jugador: boolean;
        turno_ordenador: boolean;
        mensaje_jugador: string;
        mensaje_ordenador: string;
        dado_jugador: t_dado;
        dado_ordenador: t_dado;

        {Este procedimiento transforma las cadenas de caracteres a numeros}
      procedure conversion_cadena_numero(var numero_elegido:integer;
                                         var dato_usuario:boolean;
                                         var cadena_usuario:string);

           var
               caracter1:char;
               caracter2:char;
           begin

               caracter1:= cadena_usuario[1];
               caracter2:= cadena_usuario[2];
               dato_usuario:= true;
               if (ord(caracter1)>= ord('0')) and (ord(caracter1)<=ord('9')) then
                      begin
                        numero_elegido:= (ord(caracter1)-ord('0'))*10;
                        if (ord(caracter2) >= ord('0')) and (ord(caracter2) <= ord('9')) then
                               numero_elegido := numero_elegido + (ord(caracter2)-ord('0'))
                        else
                            begin
                                 writeln ('El segundo caracter introducido no es valido.');
                                 numero_elegido := 0;
                                 dato_usuario := false;
                            end;
                      end
               else
                     begin
                        writeln ('El primer caracter introducido no es un numero');
                        numero_elegido := 0;
                        dato_usuario := false;
                     end;
               cadena_usuario:='xx'
           end;
               {fin del procedimiento }




      function inicio_posada: t_casilla;
                {Esta funcion determina la posicion de la casilla posada}

               const
                         defecto_posada = 15;

               var
                        posada_usuario: string;
                        posada_caracter1: char;
                        posada_caracter2: char;
                        posada_num: integer;
                        {puesto que la entrada del teclado puede ser un numero que desbrode el tipo casilla}
                        dato_posada: boolean;
                        intento_posada: integer;


             begin
                  intento_posada:= 0;
                  dato_posada:=false;
                  posada_usuario:= 'xx';
                  while (intento_posada<5) and (dato_posada=false) do
                                              begin
                                                   writeln ('Introduce el numero de la casilla posada.');
                                                   writeln ('El numero tiene que ser mayor que 12 y menor que 27 y');
                                                   write('estan escluidos los numeros:');
                                                   writeln(oca_3,' ', oca_4,' ', oca_5) ;
                                                   writeln ('Solo leera los 2 primeros caracteres');
                                                   readln (posada_usuario);
                                                   posada_num:=0;

                                                   {voy al procedimiento conversion cadena en numero}
                                                   conversion_cadena_numero(posada_num, dato_posada,posada_usuario);
                                                   {Cuando se que es un numero valoramos si es correcto o no}
                                                   if dato_posada = true then
                                                      case posada_num of
                                                           1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12:
                                                           begin  {Cuando el numero es menor o igual que 12}
                                                                writeln ('Has puesto un numero igual o menor que 12');
                                                                dato_posada := false;
                                                                posada_num:= 0;

                                                           end;

                                                           oca_3, oca_4, oca_5:
                                                           begin {Cuando el numero dado esta ya ocupado por otras casillas}
                                                                posada_num:= posada_num + 1;
                                                                write ('La casilla est ocupada pero ');
                                                                write ('te designaremos la siguiente casilla:');
                                                                writeln(posada_num);
                                                           end;

                                                      else
                                                           begin
                                                                if posada_num >= jardin then
                                                                   begin  {Cuando el numero dado es mayor o igual que 27}
                                                                     writeln ('Has elegido un numero mayor o igual que 27');
                                                                     dato_posada := false;
                                                                     posada_num:= 0;

                                                                   end
                                                                else{ Ocurre si es el numero cumple todos los requisitos}
                                                                   begin
                                                                     write ('La posada se ubicar en la casilla: ');
                                                                     writeln (posada_num);
                                                                   end;
                                                           end;
                                                   end;

                                                   intento_posada := intento_posada + 1;
                                                   delay(8000);
                                                   clrscr;

                                              end;

                  {Al ver que el usuario no acierta con los numeros le designo un numero}
                  if (intento_posada = 5) and (dato_posada=false) then
                                       begin
                                            writeln ('Has agotado tus intentos de asignar una casilla a posada');
                                            posada_num := defecto_posada;
                                            writeln (defecto_posada);
                                            delay(8000);
                                            clrscr;
                                       end;
                  inicio_posada:=posada_num;
             end;
                {Fin de la funcion posada}

      function inicio_calavera (evitar_posada: t_casilla): t_casilla;
                {Esta funcion me dara la posicion que tendra la casilla calavera}

               const
                    defecto_calavera = 22;

               var
                  calavera_usuario: string;
                  calavera_caracter1: char;
                  calavera_caracter2: char;
                  calavera_num: integer;
                  dato_calavera: boolean;
                  intento_calavera: integer;


               begin
                    intento_calavera:= 0;
                    dato_calavera:=false;
                    calavera_usuario:='xx';
                    while (intento_calavera < 5) and (dato_calavera = false) do
                          begin
                               writeln ('Introduce el numero de la casilla calavera.');
                               write ('El numero no puede ser:');
                               write (oca_1,' ',oca_2,' ', oca_3,' ', oca_4,' ', oca_5,' ');
                               write (evitar_posada,' ',jardin,' ',puente_1,' ',puente_2,' ');
                               writeln (' y ademas no puede ser mayor o igual que 27');
                               writeln ('Solo leera los 2 primeros caracteres');
                               writeln ('en caso de llevar solo unidades, sin decenas, introducir primero el 0');
                               readln (calavera_usuario);
                               calavera_num:=0;

                               {voy al procedimiento conversion cadena en numero}
                               conversion_cadena_numero(calavera_num, dato_calavera,calavera_usuario);

                               if dato_calavera = true then
                                    case calavera_num of
                                         oca_1, oca_2, oca_3, oca_4, oca_5, puente_1, puente_2:
                                                   begin {Cuando el numero dado es una casilla predefinida}
                                                        calavera_num:= calavera_num + 1;
                                                        write ('La casilla est ocupada pero ');
                                                        write ('te designare la siguiente casilla:');
                                                        writeln(calavera_num);
                                                   end;
                                    else

                                        if calavera_num >= jardin then
                                                 begin {Cuando es mayor o igual que 27}
                                                      writeln ('Has elegido un numero mayor o igual que 27');
                                                      dato_calavera:= false;
                                                      calavera_num:= 0;
                                                 end;
                                    end;
                                              if calavera_num=evitar_posada then
                                                 {Esto sucedera cuando el numero dado sea el mismo que el de posada}
                                                    begin
                                                         calavera_num:= calavera_num + 1;
                                                         write ('La casilla est ocupada por la posada,');
                                                         write ('te designare la siguiente casilla:');
                                                         writeln (calavera_num);

                                                    end
                                              else
                                                     begin {Cuando el numero es correcto}
                                                          write ('La calavera se ubicar en la casilla: ');
                                                          writeln (calavera_num);
                                                     end;

                          intento_calavera := intento_calavera + 1;
                          delay(8000);
                          clrscr;
                          end;



                    if (intento_calavera = 5) and (dato_calavera = false) then
                     begin  {Tras los fallos obtenidos le designo un valor}
                          writeln ('Has agotado tus intentos de asignar una casilla a calavera');
                          calavera_num := defecto_calavera;
                          writeln (defecto_calavera);
                          delay(8000);
                          clrscr;
                     end;
                    inicio_calavera := calavera_num;
               end;


               {Fin de la funcion calavera}




      procedure movimiento (var ficha_movimiento: t_casilla;
                           var turno,turno_oponente:boolean;
                           var mensaje: string;
                           var dado: t_dado;
                           movimiento_calavera: t_casilla;
                           movimiento_posada: t_casilla);
           var
                 rebote: t_dado;
           begin
              mensaje:= '                                                       ';
              if turno = true then
                begin
                     dado:= random (6)+1 ;
                     if (dado + ficha_movimiento) <= jardin then
                        ficha_movimiento:= ficha_movimiento+ dado
                     else
                       begin
                            rebote:= (dado + ficha_movimiento) - jardin;
                            ficha_movimiento:= jardin - rebote;
                       end;

                     case ficha_movimiento of
                          oca_1, oca_2, oca_3, oca_4, oca_5:
                                 begin
                                      mensaje:= ' de oca a oca y tiro porque me toca';
                                      turno_oponente := false;
                                      case ficha_movimiento of
                                           oca_1: ficha_movimiento := oca_2;
                                           oca_2: ficha_movimiento := oca_3;
                                           oca_3: ficha_movimiento := oca_4;
                                           oca_4: ficha_movimiento := oca_5;
                                           oca_5: ficha_movimiento := jardin;
                                      end;
                                 end;
                          puente_1, puente_2:
                                    begin
                                         mensaje := (' Has caido en el puente ve a la posada y pierde turno        ');
                                         turno := false;
                                         ficha_movimiento := movimiento_posada;
                                    end;
                          jardin: turno_oponente := false;
                     else
                         begin
                              if (ficha_movimiento = movimiento_posada) then
                                 begin
                                      mensaje:= ' Posada, pierde turno                                 ';
                                      turno:= false;
                                 end;
                              if (ficha_movimiento = movimiento_calavera) then
                                        begin
                                             mensaje := ' Retroceda a la casilla 1                               ';
                                             ficha_movimiento:= 1;
                                        end;
                         end;
                     end;
                end
              else
                  turno:= true;
           end;{del procedimiento movimiento}


           {procedimiento iniciar pantalla}
      procedure iniciar_pantalla(posada_pantalla, calavera_pantalla: t_casilla);

              var
                 x:integer;
                 aux:integer;{la variable aux viene de auxiliar y no tiene
                             otro fin que ser un contador en varias lineas}


              begin
                   clrscr;
                   textcolor(15);

                   {linea 1}
                   {linea de rayas horizontales}
                   for x:=1 to 69 do
                       begin
                            gotoxy(x+5,5);
                            write('-');
                       end;

                   {linea 2}
                   {linea de rayas vertizales y espacios}
                   for x:=1 to 28 do
                       begin
                            gotoxy(x*2+16,6);
                            write('| ')
                       end;
                   {coloco los 1 y 2 de las decenas de las casillas}

                   for x:=1 to 10 do
                       begin
                            gotoxy(x*2+37,6);
                            write('1|')
                       end;

                   for x:=1 to 8 do
                       begin
                       gotoxy(x*2+57,6);
                       write('2|')
                   end;

                   {linea 3}
                   {relleno las casillas con los numeros y el nombre de casilla}
                   gotoxy(6,7);
                   write('N Casilla');
                   aux:=0;
                   for x:=1 to 10 do
                       begin
                            gotoxy(x*2+16,7);
                            write('|', aux);
                            aux:=aux+1;
                       end;

                   aux:=0;
                   for x:=1 to 10 do
                       begin
                            gotoxy(x*2+36,7);
                            write('|', aux);
                            aux:=aux+1;
                       end;

                   aux:=0;
                   for x:=1 to 8 do
                       begin
                            gotoxy(x*2+56,7);
                            write('|', aux , '|');
                            aux:=aux+1;
                       end;

                   {linea 4}
                   {linea de rayas horizontales}
                   for x:=1 to 69 do
                       begin
                            gotoxy(x+5,8);
                            write('-');
                       end;

                   {linea 5}
                   {linea de rayas vertizales y espacios}
                   for x:=1 to 28 do
                       begin
                            gotoxy(x*2+16,9);
                            write('| |')
                       end;

                   {linea 6}
                   {linea de rayas vertizales y espacios}
                   for x:=1 to 28 do
                       begin
                            gotoxy(x*2+16,9);
                            write('| |')
                       end;

                   {linea 7}
                   {linea de rayas vertizales y espacios}
                   for x:=1 to 28 do
                       begin
                            gotoxy(x*2+16,10);
                            write('| |')
                       end;

                   {escribio jugador e inicio la casilla}
                   textcolor(9);
                   gotoxy (6,10);
                   write('jugador');
                   gotoxy (19,10);
                   write('@');
                   textcolor(15);

                   {linea 8}
                   {linea de rayas vertizales y espacios}
                   for x:=1 to 28 do
                       begin
                            gotoxy(x*2+16,11);
                            write('| |')
                       end;

                   {linea 9}
                   {linea de rayas horizontales}
                   for x:=1 to 69 do
                       begin
                            gotoxy(x+5,12);
                            write('-');
                       end;

                   {linea 10}
                   {linea de rayas vertizales y espacios}
                   for x:=1 to 28 do
                       begin
                            gotoxy(x*2+16,13);
                            write('| |')
                       end;

                   {linea 11}
                   {linea de rayas vertizales y espacios}
                   for x:=1 to 28 do
                       begin
                            gotoxy(x*2+16,14);
                            write('| |')
                       end;
                   {escribio ordenador e inicio la casilla}
                   textcolor(3);
                   gotoxy (6,14);
                   write('ordenador');
                   gotoxy (19,14);
                   write('@');
                   textcolor(15);


                   {linea 12}
                   {linea de rayas vertizales y espacios}
                   for x:=1 to 28 do
                   begin
                        gotoxy(x*2+16,15);
                        write('| |')
                   end;

                   {linea 13}
                   {linea de rayas horizontales}
                   for x:=1 to 69 do
                       begin
                            gotoxy(x+5,16);
                            write('-');
                       end;

                   {linea 14}
                   {linea de rayas vertizales y espacios}
                   for x:=1 to 28 do
                       begin
                            gotoxy(x*2+16,17);
                            write('| |')
                       end;

                   {linea 15}
                   {linea de rayas vertizales y espacios}
                   for x:=1 to 28 do
                       begin
                            gotoxy(x*2+16,18);
                            write('| |')
                       end;

                   {linea 16}
                   {linea de rayas vertizales y espacios}
                   for x:=1 to 28 do
                       begin
                            gotoxy(x*2+16,19);
                            write('| |')
                       end;

                   {escribo oca en las casillas corespondientes}
                   textcolor(10);
                   gotoxy(29,17);
                   write('o');
                   gotoxy(29,18);
                   write('c');
                   gotoxy(29,19);
                   write('a');

                   gotoxy(37,17);
                   write('o');
                   gotoxy(37,18);
                   write('c');
                   gotoxy(37,19);
                   write('a');

                   gotoxy(47,17);
                   write('o');
                   gotoxy(47,18);
                   write('c');
                   gotoxy(47,19);
                   write('a');

                   gotoxy(55,17);
                   write('o');
                   gotoxy(55,18);
                   write('c');
                   gotoxy(55,19);
                   write('a');

                   gotoxy(65,17);
                   write('o');
                   gotoxy(65,18);
                   write('c');
                   gotoxy(65,19);
                   write('a');

                   {escribo jardin en su casilla}
                   textcolor(2);
                   gotoxy(73,17);
                   write('j');
                   gotoxy(73,18);
                   write('a');
                   gotoxy(73,19);
                   write('r');
                   gotoxy(73,20);
                   write('d');
                   gotoxy(73,21);
                   write('i');
                   gotoxy(73,22);
                   write('n');

                   {escribo puente en las casillas correspondientes}
                   textcolor(14);
                   gotoxy(31,17);
                   write('p');
                   gotoxy(31,18);
                   write('u');
                   gotoxy(31,19);
                   write('e');
                   gotoxy(31,20);
                   write('n');
                   gotoxy(31,21);
                   write('t');
                   gotoxy(31,22);
                   write('e');

                   gotoxy(43,17);
                   write('p');
                   gotoxy(43,18);
                   write('u');
                   gotoxy(43,19);
                   write('e');
                   gotoxy(43,20);
                   write('n');
                   gotoxy(43,21);
                   write('t');
                   gotoxy(43,22);
                   write('e');

                  {pongo posada en su casilla}
                  textcolor(6);
                  gotoxy(19+posada_pantalla*2,17);
                  write('p');
                  gotoxy(19+posada_pantalla*2,18);
                  write('o');
                  gotoxy(19+posada_pantalla*2,19);
                  write('s');
                  gotoxy(19+posada_pantalla*2,20);
                  write('a');
                  gotoxy(19+posada_pantalla*2,21);
                  write('d');
                  gotoxy(19+posada_pantalla*2,22);
                  write('a');

                  {pongo calavera en su casilla}
                  textcolor(4);
                  gotoxy(19+calavera_pantalla*2,17);
                  write('c');
                  gotoxy(19+calavera_pantalla*2,18);
                  write('a');
                  gotoxy(19+calavera_pantalla*2,19);
                  write('l');
                  gotoxy(19+calavera_pantalla*2,20);
                  write('a');
                  gotoxy(19+calavera_pantalla*2,21);
                  write('v');
                  gotoxy(19+calavera_pantalla*2,22);
                  write('e');
                  gotoxy(19+calavera_pantalla*2,23);
                  write('l');
                  gotoxy(19+calavera_pantalla*2,24);
                  write('a');

                  {situacin de jugadores, mensajes y dado}
                  textcolor(9);
                  gotoxy(17,30);
                  write('JUGADOR');
                  gotoxy(17,31);
                  write('dado:');

                  textcolor(3);
                  gotoxy(17,40);
                  write('ORDENADOR');
                  gotoxy(17,41);
                  write('dado:');

                  delay (5000);
              end;

      procedure dibujar_pantalla (nueva_casilla, vieja_casilla: t_casilla;
                                 dado_pantalla: t_dado;
                                 color_ficha:integer;
                                 mensaje_pantalla: string);
              var
                 y:integer;{determina la fila de cada jugador a partir del color}

              begin
                   {detreminamos si es color 9 estonces es jugador y ocupa fila jugador, sino ordenador}
                   if color_ficha=9 then
                      begin
                           textcolor(color_ficha);
                           y:= 10;
                           gotoxy(25,31);
                           write(dado_pantalla);
                           gotoxy(17,32);
                           write(mensaje_pantalla);
                      end

                   else
                      begin
                           textcolor(color_ficha);
                           y:= 14;
                           gotoxy(25,41);
                           write(dado_pantalla);
                           gotoxy(17,42);
                           write(mensaje_pantalla);
                      end;

                   {parpadea el lugar de nueva casilla}
                   textcolor (color_ficha+16);
                   gotoxy (19+ nueva_casilla *2, y);
                   write('@');
                   delay(5000);

                   {borro el lugar de la vieja casilla}
                   textcolor (color_ficha);
                   gotoxy(19+ vieja_casilla *2, y);
                   write(' ');
                   delay(3000);

                   {dejo fija la nueva casilla}
                   gotoxy(19+nueva_casilla*2, y);
                   write('@');
                   delay(3000);



              end;



      begin {del programa principal}
           randomize;
           clrscr;
           textcolor(5);
           writeln ('Bienvenido al juego de la oca');
           writeln ('Juega al juego de la oca y deja de hacer el ganso');
           writeln ('A ya vamos');
           delay(8000);
           clrscr;

           posada_casilla:=inicio_posada;
           calavera_casilla:=inicio_calavera(posada_casilla);
           iniciar_pantalla(posada_casilla, calavera_casilla);

           ficha_jugador:= 0;
           ficha_ordenador:= 0;
           turno_jugador:= true;
           turno_ordenador:= true;
           dado_jugador:= 1;
           dado_ordenador:= 1;

           while (ficha_jugador < jardin) and (ficha_ordenador < jardin) do
                 begin
                      ficha_anterior_jugador:=ficha_jugador;
                      ficha_anterior_ordenador:=ficha_ordenador;
                      movimiento (ficha_jugador, turno_jugador, turno_ordenador,
                                  mensaje_jugador, dado_jugador, calavera_casilla, posada_casilla);

                      dibujar_pantalla (ficha_jugador, ficha_anterior_jugador, dado_jugador, 9, mensaje_jugador);


                      movimiento (ficha_ordenador, turno_ordenador, turno_jugador,
                                  mensaje_ordenador, dado_ordenador, calavera_casilla, posada_casilla);

                      dibujar_pantalla (ficha_ordenador, ficha_anterior_ordenador, dado_ordenador, 3, mensaje_ordenador);

               {Dibujar pantalla, unicamente actualizar las casillas y los mensajes}

                 end;
                 textcolor(20);
           if ficha_jugador = jardin then
              begin
               gotoxy(40,47);
               writeln ('Enhorabuena, has ganado');
              end
           else
               begin
                    gotoxy (40,47);
                    writeln ('Lo siento ha ganado el ordenador');
                    gotoxy (40,48);
                    writeln (' Otra vez sera !');
               end;
           delay(10000)
      end.