program juegodelaoca;
  uses crt;
  {definimos la casilla final como una constante ya que no cambia su valor}
  const
       jardin_oca = 27;

  {definimos nuevos tipos de variables para hacernos mas fcil pintar el tablero
  y decir el tipo de casilla que es y lo que tiene que pasar en esa casilla}
  type
      tp_casilla=(oca,puente,calavera,posada,fin,normal);
      tp_casilla_tablero = record
                                 tipo: tp_casilla;
                                 salto:integer;
                           end;
      tp_jugador = record
                         casilla: byte;
                         pierdeturno: boolean;
                   end;
      tp_tablero = array[1..27] of tp_casilla_tablero;
  {variables que vamos a utilizar}
  var
     t: char;
     numtirada: byte;
     casilla: byte;
     tablero: tp_tablero;
     cont: byte;
     jugador,maquina:tp_jugador;
     turno: byte;
   {hacemos 2 funciones para elegir la posicin de la calavera y la posada,que nos devuelve el valor}
     function asigna_calavera(var tab:tp_tablero):integer;

     var calavera_valida: boolean;
         c: integer;

     begin

          repeat
                textcolor(lightblue);
                write('elige casilla calavera: ');

                {$I-}
                readln (c);
                {$I+}

                calavera_valida := true;

                if (IOResult <> 0) then
                begin

                     calavera_valida := false;
                     writeln('caracter no valido, introduzca un numero')
                end

                else
                begin

                     if ((c < 1) or (c > 27)) then
                     begin

                          calavera_valida := false;
                          writeln('casilla no valida (1 al 27)')
                     end
                     else {el numero es mayor que 1 y menor que 27}

                          case (tab[c].tipo) of
                          oca,fin:
                                       begin
                                            writeln('casilla no valida es una oca');
                                            calavera_valida:=false
                                       end;
                          puente:
                               begin
                                    writeln('casilla no valida es un puente');
                                    calavera_valida:=false;
                               end
                          end

                end;

          until (calavera_valida);
          asigna_calavera := c;
     end;

     function asigna_posada(var tab:tp_tablero):integer;

     var posada_valida: boolean;
         c: integer;

     begin

          repeat
                textcolor(lightblue);
                write('elige casilla posada: ');

                {$I-}
                readln (c);
                {$I+}

                posada_valida := true;

                if (IOResult <> 0) then
                begin

                     posada_valida := false;
                     writeln('caracter no valido, introduzca un numero')
                end

                else
                begin

                     if ((c < 13) or (c > 27)) then
                     begin

                          posada_valida := false;
                          writeln('casilla no valida (13 al 27,despus de un puente)')
                     end
                     else {el numero es mayor que 13 y menor que 27}

                          case (tab[c].tipo) of
                          oca,fin:
                                       begin
                                            writeln('casilla no valida es una oca');
                                            posada_valida:=false
                                       end;
                          puente:
                                 begin
                                      writeln('casilla no valida es un puente');
                                      posada_valida:=false;
                                 end;
                          calavera:
                                   begin
                                        writeln('casilla no valida es la calavera');
                                        posada_valida:=false;
                                   end
                          end

                end;

          until (posada_valida);
          asigna_posada := c;
    end;

    {tablero inicial para saber donde poder poner la calavera y la posada}
    procedure tablero_peque;
    begin
         GotoXY(1,1);
         TextColor(Yellow);
         writeln('1 2 3 4 5 6& 7 8 9 10 11 12& 13 14');
         writeln('15 16 17 18 19 20 21 22 23 24 25 26 27!');
         writeln;


         write(' =oca    &=puente   =calavera  $=posada');
         textcolor(white);
         write(' 0=jugador');
         textcolor(lightred);
         write('   0=maquina  ');
         writeln;
         NormVideo;
    end;


    {dibujo del tablero grande y las fichas con colores y la posicion dentro de cada casilla}
    Procedure tablero_grande(var tab: tp_tablero;jug,maq:tp_jugador);
    var
         contador:byte;
         cadena,cadena_linea:string[80];
    begin
         GotoXY(1,6);
         TextColor(Green);
         cadena_linea := '  ---';
         for contador := 1 to 14 do
             cadena_linea := cadena_linea + '-----';
         writeln(cadena_linea);

         write('  |');
         cadena := '  |';
         for contador := 1 to 27 do
         begin
              write(contador:4);
              if ((contador = jug.casilla) and (contador = maq.casilla)) then
              begin
                 TextColor(White);
                 write(' 0');
                 TextColor(LightRed);
                 write('0');
                 TextColor(Green);
                 Write(' |')
              end
              else if (contador = jug.casilla) then
              begin
                 TextColor(White);
                 write(' 0');
                 TextColor(Green);
                 Write('  |')
              end
              else if (contador = maq.casilla) then
              begin
                 TextColor(LightRed);
                 write(' 0');
                 TextColor(Green);
                 Write('  |')
              end
              else
                  write('    |');

              case (tab[contador].tipo) of
                   normal:
                          cadena := cadena + '        |';
                   oca:
                          cadena := cadena + '  oca   |';
                   puente:
                          cadena := cadena + ' puente |';
                   posada:
                          cadena := cadena + ' posada |';
                   calavera:
                          cadena := cadena + 'calavera|';
                   fin:
                          cadena := cadena + ' JARDIN |';
              end;
              if ((contador mod 8)=0) then
              begin
                   writeln;
                   writeln(cadena);
                   writeln(cadena_linea);
                   write('  |');
                   cadena := '  |';
              end;
         end;
         writeln;
         writeln(cadena);

         cadena_linea := '  ---';
         for contador := 1 to 5 do
             cadena_linea := cadena_linea + '-----';
         writeln(cadena_linea);
         NormVideo;

    end;
    {en este procedimiento tenemos conseguimos cambiar el turno saber
    si pasa algo en la casilla en la que hemos caido,perder el turno,salto...
    Tambin nos gestiona tirar los dados y avanzar en el panel... es decir,
    lo que es el groso del programa}
    procedure gestiona_tirada(var tab:tp_tablero;var tur:byte;var jug,maq:tp_jugador;var tecla:char);
    var tirada :byte;
        dado   :byte;

    begin
         {Comprobar si a quien le tocaba turno lo ha perdido}
         if jug.pierdeturno and (tur = 1) then
         begin
             jug.pierdeturno := false;
             tur := 0;
	   end;

         if maq.pierdeturno and (tur = 0) then
         begin
              maq.pierdeturno := false;
              tur := 1;
         end;


         {Tirar los dados}
         if (tur = 1) then
         begin
             repeat
                 textcolor(white);
                 Write('Lanza el dado con la tecla t ("Esc" para salir): ');
                 tecla:=UpCase(ReadKey);
             until (tecla='T') or (tecla=#27);
         end
         else begin
             textcolor(lightred);
             write('Turno de la maquina!:' );
         end;

         if (tecla = #27) then Halt; {Pulsando ESCAPE se termina el juego}
         textcolor(yellow);
         dado:=(random(6)+1);
         writeln(dado);
         delay(1000);
         if (tur = 1) then
         begin
             jug.casilla := jug.casilla + dado;
             if (jug.casilla>27) then jug.casilla:=2*27-jug.casilla;
             tirada := jug.casilla;
         end
         else
         begin
             maq.casilla := maq.casilla + dado;
             if (maq.casilla>27) then maq.casilla:=2*27-maq.casilla;
              tirada := maq.casilla;
         end;

         case (tab[tirada].tipo) of
              oca:
                  begin
                       if (tur = 1) then
                       begin
                            maq.pierdeturno := true;
                            jug.casilla := tab[tirada].salto;
                       end
                       else
                       begin
                            jug.pierdeturno := true;
                            maq.casilla := tab[tirada].salto;
                       end;

                       if (jug.casilla=27) or (maq.casilla=27) then
                       begin
                         if jug.casilla=27 then
                         begin
                         textcolor(green);
                         Writeln('HAS GANADO LA PARTIDA!!!');
                         end
                         else
                         begin
                         textcolor(green);
                         writeln('HAS PERDIDO');
                         end;
                       end
                       else
                       begin
                         textcolor(green);
                         writeln('OCA! Vuelve a tirar...');
                       Delay(2000);
                       end;
                  end;
              puente:
                     begin
                          textcolor(green);
                          writeln('PUENTE! Te mandan a la posada!');
                          writeln('Perdera un turno...');
                          Delay(2000);
                          if (tur = 1) then
                          begin
                               jug.casilla := tab[tirada].salto;
                               jug.pierdeturno := true;
                          end
                          else
                          begin
                                maq.casilla := tab[tirada].salto;
                                maq.pierdeturno := true;
                          end;
                     end;
              calavera:
                     begin
                          if (tur = 1) then
                              jug.casilla := tab[tirada].salto
                          else
                              maq.casilla := tab[tirada].salto;
                          textcolor(green);
                          writeln('! A   E M P E Z A R !');
                          Delay(2000);
                      end;
              posada:
                     begin
                          textcolor(green);
                          writeln('POSADA! Perdera un turno...');
                          Delay(2000);

                          if (tur = 1) then
                             jug.pierdeturno := true
                          else maq.pierdeturno := true;
                     end;
              fin:
                  if (tur = 1) then
                  begin
                     textcolor(green);
                     writeln('HAS GANADO LA PARTIDA!!!');
                  end
                  else
                  begin
                      textcolor(green);
                      writeln('HAS PERDIDO...');
                  end;
         end;

         {Pause de 2 segundos cuando juega la mquina}
         if (tur=0) then Delay(2000);

         {cambiar el turno}
         tur:=(tur+1) MOD 2;
         normvideo;
    end;


  begin
    clrscr;
    {Inicializar el jugador humano y la maquina}
    jugador.casilla:=1;
    jugador.pierdeturno:= false;
    maquina.casilla:=1;
    maquina.pierdeturno:= false;
    randomize;
    writeln('BIENVENIDO AL JUEGO DE LA OCA');
    writeln;


    tablero_peque;
    {inicializar el tablero}
    for cont := 1 to 27 do
        tablero[cont].tipo := normal;

    {asignar ocas}
    tablero[5].tipo := oca;
    tablero[5].salto := 9;
    tablero[9].tipo := oca;
    tablero[9].salto := 14;
    tablero[14].tipo := oca;
    tablero[14].salto := 18;
    tablero[18].tipo := oca;
    tablero[18].salto := 23;
    tablero[23].tipo := oca;
    tablero[23].salto := 27;

    {asigna puente}
    tablero[6].tipo := puente;
    tablero[12].tipo := puente;

    {asigna fin}
    tablero[27].tipo := fin;

    {asigna calavera}
    casilla := asigna_calavera(tablero);
    tablero[casilla].tipo := calavera;
    tablero[casilla].salto := 1;

    {asigna posada}
    casilla := asigna_posada(tablero);
    tablero[casilla].tipo := posada;

    {asignar salto a la posada desde los puentes}
    tablero[6].salto := casilla;
    tablero[12].salto := casilla;

   {*************************************************
   ******* COMIENZO PROGRAMA PRINCIPAL***************
   **************************************************}


    writeln('COMIENZA EL JUEGO');
    writeln;

    turno := 1;
    {para que cada vez que se tire el dado y se meuva una ficha nos dibuje un nuevo
    tablero pero borre el anterior}
    clrscr;
    tablero_peque;
    tablero_grande(tablero,jugador,maquina);
    repeat
    {Se llama a los correspondientes procedimientos en el programa principal}
       clrscr;
       tablero_peque;
       tablero_grande(tablero,jugador,maquina);
       gestiona_tirada(tablero,turno,jugador,maquina,t);
    until (jugador.casilla = 27) or (maquina.casilla = 27) or (t = #27);
    readln;
  end.


 { *********************************************************************
   ************ FIN PROGRAMA PRINCIPAL**********************************
   *********************************************************************}