 PROGRAM OCA;
 USES crt;

 CONST    {Definicin de constantes, ya que se van a emplear a lo largo
           de todo el programa.}
      Puente1=6;
      Puente2=12;
      Oca1=5;
      Oca2=9;
      Oca3=14;
      Oca4=18;
      Oca5=23;
      Fin=27;

 PROCEDURE reglas;    {Procedimiento que escribir por pantalla una breve
                      introduccin con las reglas del juego.}
           Begin
           Writeln('Las reglas son estas:');
           Writeln('');
           Writeln('--Si caes en una casilla "Oca" (Casillas rojas), vas de "Oca a Oca" y vuelves a');
           Writeln('  tirar.');
           Writeln('--Si caes en las casillas "Puente" (Casillas azules), saltas a la "Posada".');
           Writeln('--Si caes en la "Posada" pierdes un turno.');
           Writeln('--Si caes en la "Calavera" vuelves a la casilla 1.');
           Writeln('--Si caes en el "Jardin de la Oca" (Casilla verde) ganas.');
           Writeln('');
           Writeln('NOTA: Para los cambios de turno y pasos de pantalla apretar la tecla ENTER.');
           readln;
           clrscr;
           End;

 PROCEDURE calaveraposada(var c,p:integer);
 {Procedimiento que le pide al jugador que introduzca las casillas
 de la calavera y de la posada.}

           Begin
           Writeln ('Indique la posicion de la "Calavera"');
           Writeln;
           Repeat
           Write ('La posicin debe de encontrarse dentro del tablero y no ');
           Writeln ('puede ser alguna ');
           Writeln ('casilla especial!!!');
           {$I-}
           Readln(c);
           {$I+}
           Until (IOResult=0) and (c>0) and (c<28) and (c<>5) and (c<>6) and (c<>9)
           and (c<>12) and (c<>14) and (c<>18) and (c<>23) and (c<>27);
           Writeln ('La calavera esta en la casilla ',c);

           Writeln ('');

           Readln;
           Clrscr;

           Writeln ('Indique la posicin de la "Posada"');
           Writeln;
           Repeat
           Write ('La posicin debe de encontrase dentro del tablero y no ');
           Writeln ('puede ser alguna ');
           Writeln ('casilla especial!!!');
           {$I-}
           Readln(p);
           {$I+}
           Until (IOResult=0) and (p>12) and (p<28) and (p<>14) and (p<>18) and
           (p<>23) and (p<>27) and (p<>c);
           Writeln('La posada esta en la casilla ',p);
           End;

 PROCEDURE dibujartablero (posiciontablerousuario, posiciontableromaquina:integer);
 {Procedimiento para dibujar el tablero e indicar la posicin del jugador y
 de la mquina en cada momento.}

           Begin
           Write ('0     1     2     3     4     ');
           Textbackground(red);     {Cambio de color del fondo de texto.}
           Write ('5');
           NormVideo;               {Volver al color de fondo anterior.}
           Write ('     ');
           TextBackground(blue);
           Writeln('6');
           NormVideo;
           Write('7     8     ');
           TextBackground(red);
           Write('9');
           NormVideo;
           Write('    10    11    ');
           TextBackground(blue);
           Write('12');
           NormVideo;
           Writeln('    13');
           TextBackground(red);
           Write('14');
           NormVideo;
           Write ('   15    16    17    ');
           TextBackground(red);
           Write('18');
           NormVideo;
           Writeln('    19    20');
           Write('21   22    ');
           TextBackground(red);
           Write('23');
           NormVideo;
           Write('    24    25    26    ');
           TextBackground(green);
           Write('27');
           NormVideo;
           Writeln('');
           Writeln('');

           Writeln ('Jugador => casilla ',posiciontablerousuario);
           Writeln ('Mquina => casilla ',posiciontableromaquina);
           Writeln ('');
           Writeln ('');
           End;

 PROCEDURE sobrepasar27 (Var posiciondemas: integer);
 {Procedimiento para en el caso de que se pase de la casilla del Parque de la
 Oca, retroceda tantas casillas como se haya pasado.}
 Var
    retroceso: integer;

               Begin
               retroceso:= posiciondemas-27;
               posiciondemas:=27-retroceso;
               Writeln ('Casilla ',posiciondemas);
               End;

 PROCEDURE normasoca (var posicionoca:integer);
 {Procedimiento que hace que salte de oca en oca.}

           Begin
            Writeln ('De oca a oca y tiro porque me toca!!!');
               Case posicionoca OF
               Oca1: posicionoca:= Oca2;
               Oca2: posicionoca:= Oca3;
               Oca3: posicionoca:= Oca4;
               Oca4: posicionoca:= Oca5;
               Oca5: posicionoca:= Fin;
               End;

               Writeln ('Casilla ',posicionoca);

           End;

 PROCEDURE normaspuente (posada1:integer; Var posicionpuente:integer);
 {Procedimiento que en caso de caer en una casilla de puente, lo adelanta
 hasta la casilla de "Posada".}

           Begin
                Case posicionpuente OF
                puente1: posicionpuente:= posada1;
                puente2: posicionpuente:= posada1;
                End;

                Writeln ('Casilla ',posicionpuente,' POSADA!!!');
                Writeln ('Prdida de turno!');
           End;

 PROCEDURE normascalavera (Var posicioncalavera:integer);
 {Procedimiento que lo regresa a la casilla 1 en caso de caer en la casilla
 de la "Calavera".}

           Begin
           posicioncalavera:=1;
           Writeln ('Casilla ',posicioncalavera);
           End;

 PROCEDURE jugarusuario (lugarposada, lugarcalavera: integer; Var lugarusuario,lugarmaquina2:integer);
 {Procedimiento para jugar el usuario.}
 Var
    dado: integer;

           Begin
           Writeln ('Es tu turno jugador!');

           Repeat {Para que en el caso de caer en oca, vuelva a tirar.}
                 readln;
                 clrscr;
                 dibujartablero (lugarusuario,lugarmaquina2);
                 {Dibuja el tablero antes de tirar el jugador.}

                 Writeln ('Tira el dado, presione la tecla ENTER');
                 Readln;
                 dado:= random (6)+1;
                 Writeln ('Ha salido ',dado);
                 lugarusuario:=lugarusuario+dado;

                 If (lugarusuario>Fin) then
                 sobrepasar27(lugarusuario);

                 If (lugarusuario=Oca1) or (lugarusuario=Oca2) or (lugarusuario=Oca3)
                 or (lugarusuario=Oca4) or (lugarusuario=Oca5) then
                 normasoca(lugarusuario);

           Until (lugarusuario<>Oca1) and (lugarusuario<>Oca2) and (lugarusuario<>Oca3)
           and (lugarusuario<>Oca4) and (lugarusuario<>Oca5);

           If (lugarusuario=Puente1) or (lugarusuario=Puente2) then
              Begin
              Writeln ('Has cado en la casilla de "Puente". Adelantas hasta la Posada');
              normaspuente (lugarposada, lugarusuario);
              End;

           If (lugarusuario=lugarcalavera) then
              Begin
              Writeln ('Has caido en la casilla de la "Calavera". Vuelves a la casilla 1');
              normascalavera(lugarusuario);
              End;

           If (lugarusuario=Fin) then
           Writeln ('ERES UN MQUINA!! ME HAS GANADO.');

           readln;
           clrscr;
           dibujartablero(lugarusuario,lugarmaquina2); {Actualiza el tablero.}
           End;

 PROCEDURE jugarmaquina (lugarposada2, lugarcalavera2:integer; Var lugarusuario2, lugarmaquina:integer);
 {Procedimiento para jugar la mquina.}
 Var
    dado: integer;

           Begin
           Writeln ('Es mi turno!');

           Repeat {Para que en el caso de caer en oca, vuelva a tirar.}
                 readln;
                 clrscr;
                 dibujartablero(lugarusuario2,lugarmaquina);
                 {Dibuja el tablero antes de tirar la mquina.}

                 dado:= random (6)+1;
                 Writeln ('Me ha salido ',dado);
                 lugarmaquina:= lugarmaquina+dado;

                 If (lugarmaquina>Fin) then
                 sobrepasar27 (lugarmaquina);

                 If (lugarmaquina=Oca1) or (lugarmaquina=Oca2) or (lugarmaquina=Oca3) or
                 (lugarmaquina=Oca4) or (lugarmaquina=Oca5) then
                 normasoca (lugarmaquina);

           Until (lugarmaquina<>Oca1) and (lugarmaquina<>Oca2) and (lugarmaquina<>Oca3) and
           (lugarmaquina<>Oca4) and (lugarmaquina<>Oca5);

           If (lugarmaquina=Puente1) or (lugarmaquina=Puente2) then
              Begin
              Writeln ('He cado en la casilla de "Puente". Adelanto hasta la Posada');
              normaspuente(lugarposada2, lugarmaquina);
              End;

           If (lugarmaquina=lugarcalavera2) then
              Begin
              Writeln ('He cado en la casilla de la "Calavera". Vuelvo a la casilla 1');
              normascalavera (lugarmaquina)
              End;

           If (lugarmaquina=Fin) then
           Writeln ('TE HE GANADO!! He llegado al Jardin de la Oca.');

           readln;
           clrscr;
           dibujartablero(lugarusuario2,lugarmaquina);{Actualiza el tablero.}
           End;



{PROGRAMA PRINCIPAL}

 Var   {Declaracin de variables.}
    calavera, posada:integer;
    usuario,maquina:integer;

          Begin
          clrscr;     {Funcin limpiar la pantalla.}
          randomize;  {Funcin random.}

          Writeln ('******************************* ');
          Writeln ('"BIENVENIDO AL JUEGO DE LA OCA"');
          Writeln ('*******************************');
          Writeln ('');

          readln;
          clrscr;

          reglas;
          calaveraposada(calavera,posada);
          Writeln('');
          Writeln('');

          readln;
          clrscr;

          Writeln ('Comienza el juego!!!');
          usuario:=0;
          maquina:=0;
          While not ((usuario=Fin) or (maquina=Fin)) do
                Begin
                jugarusuario (posada, calavera, usuario, maquina);

                If (usuario=posada) then
                jugarmaquina (posada, calavera, usuario, maquina);

                If (usuario<>Fin) then
                jugarmaquina (posada, calavera, usuario, maquina);

                If (maquina=posada) then
                jugarusuario (posada, calavera, usuario,maquina);

                End;

          Readln
          End.