 {Cabecera del programa}

 program Oca;
 uses crt;
 const
      Usuario = 'A';
      Maquina = 'B';


 {Creacin de funciones y procedimientos necesarios en el programa principal}

     {Funcin para determinar la casilla calavera}

     function asignarcalavera: integer;
     var
        resultado: integer;
     begin
     {Comprobar error E/S y rango}
        Repeat
         {$I-}
         {$r-}
           writeln;
           writeln ('Indique la posicin de la casilla calavera.');
           writeln ('Recuerde que no puede ser ninguna de las casillas especiales.');
           writeln;
           writeln ('Las casillas especiales son:');
           writeln ('  Casillas oca: 5, 9, 14, 18 y 23.');
           writeln ('  Casillas puente: 6 y 12.');
           writeln ('  Casilla destinada a posada.');
           writeln ('  Casilla 27.');
           writeln;
           readln (resultado);
         {$I+}
         {$r+}
        Until
             (IOResult=0) and not  ((resultado > 26)
                                 or (resultado < 1)
                                 or (resultado = 5)
                                 or (resultado = 6)
                                 or (resultado = 9)
                                 or (resultado = 12)
                                 or (resultado = 14)
                                 or (resultado = 18)
                                 or (resultado = 23));
        asignarcalavera:= resultado;
     end;


     {Funcin para determinar la casilla posada}

     function asignarposada (poscalavera: integer): integer;
     var
        resultado: integer;
     begin
     {Comprobar error E/S y rango}
        Repeat
         {$I-}
         {$r-}
           writeln;
           writeln ('Indique la posicin de la casilla posada.');
           writeln ('Esta casilla estar entre la 13 y la 26, exceptuando las especiales y calavera.');
           writeln;
           readln(resultado);
         {$I+}
         {$r+}
        Until
             (IOResult=0) and not  ((resultado < 13)
                                 or (resultado > 26)
                                 or (resultado = 14)
                                 or (resultado = 18)
                                 or (resultado = 23)
                                 or (resultado = poscalavera));
        asignarposada:= resultado;
     end;


     {Funcin para dibujar el tablero}

     procedure dibujartablero (cA, cB, posada, calavera: integer);
     var
        c: integer;
     begin
          {Borrar pantalla}
          clrscr;

          {Mostrar por pantalla colores de casillas especiales y nombre del juego}
          writeln;
          writeln ('***************************** JUEGO DE LA OCA ***************************');
          writeln;
          writeln ('Casillas especiales:');
          writeln;
          textcolor (15);
          writeln (' Casilla oca.');
          textcolor (11);
          writeln (' Casilla puente.');
          textcolor (4);
          writeln (' Casilla calavera.');
          textcolor (6);
          writeln (' Casilla posada.');
          textcolor (2);
          writeln (' Jardn de la oca.');
          textcolor (8);
          writeln;

          {Escribir una serie de nmeros del 0 al 27 correspondientes
          a las casillas del tablero}
          for c:= 0 to 27 do

          {Colorear las casillas especiales en la serie de nmeros}
          begin
                if   ((c = 5)
                   or (c = 9)
                   or (c = 14)
                   or (c = 18)
                   or (c = 23)) then textcolor (15)

                else if ((c = 6) or (c = 12)) then textcolor (11)

                else if  (c = calavera) then textcolor (4)

                else if  (c = posada) then textcolor (6)

                else if  (c = 27) then textcolor (2)

                else
                    textcolor (8);

                {Escribir la serie de nmeros}
		write (c,' ');
          end;

          {Mostrar por pantalla la posicin de los jugadores}

          {Determinar coordenadas de la ficha del usuario}
          if (cA < 10) then
	     gotoxy (2*cA + 1, 14)

          else
	      gotoxy (2*10 + 3*(cA-10) + 1, 14);

          {Colorear la ficha y mostrarla por pantalla}
          textcolor (14);
          write ('');

              {Determinar las coordenadas de la ficha de la mquina}
              if (cB < 10) then
	         gotoxy (2*cB + 1, 15)

              else
	          gotoxy (3*(cB-10) + 21, 15);

              {Colorear la ficha y mostrarla por pantalla}
              textcolor (1);
              write ('');
              writeln;

          {Poner el color por defecto para el texto}
          textcolor (8);
     end;


     {Funcin para que el dado nos devuelva un nmero aleatorio
     dentro de su rango y lo muestre por pantalla}

     function tirardado: integer;
     var
        resultado: integer;
     begin
          resultado:= random (6) + 1;
          writeln;
          write ('Ha salido un ');
          writeln (resultado);
          tirardado:= resultado;
     end;


     {Procedimiento para jugar}

     procedure jugar (var casillas: integer);
     begin
          casillas:= casillas + tirardado;
     end;


     {Funcin para avanzar hasta la siguiente oca}

     function siguienteoca (valor: integer): integer;
     begin
          if (valor = 5)  then siguienteoca := 9;
          if (valor = 9)  then siguienteoca := 14;
          if (valor = 14) then siguienteoca := 18;
          if (valor = 18) then siguienteoca := 23;
          if (valor = 23) then siguienteoca := 27;
     end;


     {Procedimiento para la comprobacin de casillas especiales}

     procedure casillasespeciales (var CALAVERA, POSADA, casillas: integer;
                                   var perderturnoA, perderturnoB: integer;
                                       jugador: char);
     begin

          {Comprobar si hay que hacer rebote}
          if (casillas > 27) then casillas:= 54 - casillas;

          {Comprobar si se ha caido en la casilla calavera}
          if (casillas = CALAVERA) then
             begin
                  writeln ('Casilla calavera.  Vuelta a la casilla 1.');
                  readkey;
                  casillas:= 1;
             end;

          {Comprobar si se ha caido en la casilla puente}
          if ((casillas = 6) or (casillas = 12)) then
             begin
                  writeln ('Casilla puente.  Directamente a la posada.');
                  readkey;
                  casillas:= POSADA;
             end;

          {Comprobar si se ha caido en la casilla posada}
          if (casillas = POSADA) then
             begin
                  writeln ('Casilla posada. Un turno sin jugar.');
                  readkey;

                  {Condiciones para perder turno}
                  if (jugador = 'A') then
                      perderturnoA:= perderturnoA + 1
                  else
                      perderturnoB:= perderturnoB + 1;
             end;

          {Comprobar si se a caido en una casilla oca}
          if ((casillas = 5) or
              (casillas = 9) or
              (casillas = 14) or
              (casillas = 18) or
              (casillas = 23)) then
              begin
                   writeln ('De oca en oca y tiro porque me toca.');
                   readkey;
                   casillas:= siguienteoca(casillas);

                   {Condiciones para repetir tirada}
                   if (jugador = 'B') then
                       perderturnoA:= perderturnoA + 1
                   else
                       perderturnoB:= perderturnoB + 1;
              end;
     end;


 {PROGRAMA PRINCIPAL}

 {Declaracin de variables}
 var
    CALAVERA, POSADA, casillasA, casillasB: integer;
    perderturnoA, perderturnoB: integer;
    jugador: char;
 begin
      {Borrar pantalla}
      clrscr;

      {Mensaje de Bienvenida}
      writeln ('***********************************');
      writeln ('BIENVENIDO AL JUEGO DE LA OCA!!!');
      writeln ('***********************************');

      {Inicializacin del generador de nmeros aleatorios}
      randomize;

      {Asignacin de casillas de calavera y posada}
      CALAVERA:= asignarcalavera;
      POSADA:= asignarposada (CALAVERA);

      {Mostrar tablero para comenzar la partida}
      dibujartablero (casillasA, casillasB, POSADA, CALAVERA);
      writeln;
      writeln ('Pulse una tecla para comenzar la partida.');
      readkey;

      {Desarrollo del juego}

      {Condicin para que juegue el usuario}
      while not ((casillasA = 27) or (casillasB = 27)) do
      begin

           {Comprobar si es el turno del usuario}
           if (perderturnoA = 0) then

              {Turno de juego para el usuario}
              begin
                   {Mostrar dado y movimientos del usuario}
                   dibujartablero (casillasA, casillasB, POSADA, CALAVERA);
                   writeln;
                   write ('Tu turno ');
                   textcolor (14);
                   writeln ('');
                   textcolor (8);
                   jugar (casillasA );
                   writeln ('Pulse una tecla para mover.');
                   readkey;
                   casillasespeciales (CALAVERA, POSADA, casillasA, perderturnoA, perderturnoB, 'A');
                   dibujartablero (casillasA, casillasB, POSADA, CALAVERA);
                   writeln;
                   writeln ('Pulse una tecla para continuar.');
                   readkey;
              end
           else
               {Recuperar el turno}
               perderturnoA:= perderturnoA - 1;

           {Condicin para que juegue la mquina}
           if (casillasA <> 27) then
              begin

                   {Comprobar si es el turno de la mquina}
                   if (perderturnoB = 0) then

                      {Turno de juego de la mquina}
                      begin
                           {Mostrar dado y movimientos de la mquina}
                           dibujartablero (casillasA, casillasB, POSADA, CALAVERA);
                           writeln;
                           write ('Turno del ordenador ');
                           textcolor (1);
                           writeln ('');
                           textcolor (8);
                           jugar (casillasB);
                           writeln ('Pulse una tecla para mover.');
                           readkey;
                           casillasespeciales (CALAVERA, POSADA, casillasB, perderturnoA, perderturnoB, 'B');
                           dibujartablero (casillasA, casillasB, POSADA, CALAVERA);
                           writeln;
                           writeln ('Pulse una tecla para continuar.');
                           readkey;
                     end
                   else
                       {Recuperar el turno}
                       perderturnoB:= perderturnoB - 1;
              end;
      end;

      {Mostrar tablero}
      dibujartablero (casillasA, casillasB, POSADA, CALAVERA);

      {Condicin de fin de juego despus del bucle principal}
      if (casillasA = 27) then

         {Mensaje de felicitacin al usuario por la victoria}
         begin
              writeln ('Enhorabuena!! Usted ha ganado la partida.');
              writeln ('Pulse una tecla para terminar.');
              readkey;
         end
      else
          {Mensaje informando de la victoria de la mquina}
          begin
               writeln ('Lo siento, ha ganado la mquina.');
               writeln ('Otra vez ser. Pulse una tecla para terminar.');
               readkey;
          end
 end.
