PROGRAM oca;
USES Crt;

PROCEDURE dado (VAR d:integer; VAR tur:boolean);
{Este procedimiento lo usaremos para el dado}
     BEGIN
         randomize;
         IF tur THEN
            BEGIN
                 readln;
                 writeln('Turno del usuario');
                 writeln;
                 writeln('Presione enter para lanzar el dado');
                 writeln;
                 readln;
            END
         ELSE
             BEGIN
                  readln;
                  writeln('Turno de la maquina');
                  writeln;
             END;
         d:=(random (6)+1);
     END;

PROCEDURE validarposada (pos:integer);
{Este procedimiento lo usaremos para asegurarnos de que la posada tiene un
valor correcto}
VAR
   val:boolean;
BEGIN
     val:=FALSE;
     WHILE NOT val DO
           BEGIN
                 IF (pos>12) AND (pos<27) THEN
                         CASE pos OF
                              14:writeln('Numero no valido. Introduce nuevamente el numero: ');
                              18:writeln('Numero no valido. Introduce nuevamente el numero: ');
                              23:writeln('Numero no valido. Introduce nuevamente el numero: ');
                          ELSE
                             val:= TRUE;
                          END
                 ELSE
                     writeln ('Numero no valido. Introduce nuevamente un numero: ');
                 IF NOT val THEN
                   readln(pos);
           END;
END;

PROCEDURE validarcalavera (cal,pos:integer);
{Este procedimiento lo usaremos para asegurarnos de que la calavera tiene un
valor correcto}
VAR
   valido:boolean;
BEGIN
     valido:=FALSE;
     WHILE NOT valido DO
           BEGIN
              IF (cal>1) AND (cal<27) THEN
                 BEGIN
                         IF cal=pos THEN
                            writeln('Numero no valido. Introduce nuevamente el numero: ')
                         ELSE
                          CASE cal OF
                              1:writeln('Numero no valido. Introduce nuevamente el numero: ');
                              5:writeln('Numero no valido. Introduce nuevamente el numero: ');
                              6:writeln('Numero no valido. Introduce nuevamente el numero: ');
                              9:writeln('Numero no valido. Introduce nuevamente el numero: ');
                              12:writeln('Numero no valido. Introduce nuevamente el numero: ');
                              14:writeln('Numero no valido. Introduce nuevamente el numero: ');
                              18:writeln('Numero no valido. Introduce nuevamente el numero: ');
                              23:writeln('Numero no valido. Introduce nuevamente el numero: ');
                              27:writeln('Numero no valido. Introduce nuevamente el numero: ');
                          ELSE
                             valido:= TRUE;
                          END
                 END
              ELSE
                     writeln ('Numero no valido. Introduce nuevamente un numero: ');
                IF NOT valido THEN
                   readln(cal);
           END;
END;

PROCEDURE ocaoca(var posicion:integer;VAR tur:boolean);
{Este procedimiento se usara cuando un jugador caiga en la oca}
CONST
     oca1=5;
     oca2=9;
     oca3=14;
     oca4=18;
     oca5=23;
     jardinoca=27;
BEGIN
     IF (((posicion=oca1) OR (posicion=oca2)) OR ((posicion=oca3) OR (posicion=oca4))) OR (posicion=oca5) THEN
        BEGIN
             writeln('De oca a oca y tiro porque me toca');
             writeln;
             IF posicion=oca1 THEN
                posicion:=oca2
             ELSE
                 BEGIN
                      IF posicion=oca2 THEN
                              posicion:=oca3
                      ELSE
                          BEGIN
                               IF posicion=oca3 THEN
                                  posicion:=oca4
                               ELSE
                                   BEGIN
                                        IF posicion=oca4 THEN
                                           posicion:=oca5
                                        ELSE
                                            posicion:=jardinoca;
                                   END;
                          END;
                 END;
             IF tur THEN
                BEGIN
                     tur:=FALSE;
                     writeln('El usuario se encuentra en la casilla: ',posicion);
                     writeln;
                     IF posicion=jardinoca THEN
                        BEGIN
                             writeln('El usuario ha llegado al jardin de la oca.');
                             readln;
                             writeln('El usuario ha ganado la partida.');
                        END
                     ELSE
                        writeln('Vuelve a tirar el usuario.');
                     writeln;
                END
             ELSE
                 BEGIN
                      tur:=TRUE;
                      writeln('La maquina se encuentra en la casilla: ',posicion);
                      writeln;
                      IF posicion=jardinoca THEN
                         BEGIN
                              writeln('La maquina ha llegado al jadin de la oca.');
                              writeln;
                              writeln('La maquina ha ganado la partida.');
                         END
                      ELSE
                         writeln('Vuelve a tirar la maquina.');
                      writeln;
                 END;
        END;
END;

PROCEDURE posad(posadp:integer;VAR posicion,con:integer;VAR tur,pierdetur:boolean);
{Procedimiento por el cual cuando un jugador cae en la posada y pierde turno}
BEGIN
     IF posicion=posadp THEN
        BEGIN
             writeln('Ha caido en la posada y pierde turno.');
             writeln;
             pierdetur:=TRUE;
             con:=0;
             IF tur THEN
                 tur:=FALSE
             ELSE
                  tur:=TRUE;
        END;
END;

PROCEDURE puente(posadp:integer; VAR posicion,con:integer;VAR tur,pierdetur:boolean);
{Procedimiento por el cual cuando un jugador cae en el puente, va a la posada
y pierde turno}
BEGIN
      IF (posicion=6) OR (posicion=12) THEN
         BEGIN
              writeln('Has caido en la casilla puente y vas a la posada:',posadp,' y pierdes el turno');
              writeln;
              posicion:=posadp;
              pierdetur:=TRUE;
              con:=0;
              IF tur THEN
                 tur:=FALSE
              ELSE
                  tur:=TRUE;
      END;
END;

PROCEDURE muerte(calav:integer; var posicion:integer; tur:boolean);
{Procedimiento para que si caes en la calavera, pases a estar en la
casilla 1}
BEGIN
  IF posicion=calav THEN
     BEGIN
          writeln('Has caido en la calavera y vuelves a la casilla 1.');
          writeln;
          posicion:=1;
     END;
END;

PROCEDURE restar(VAR posicion:integer);
{procedimiento para restar el numero de casillas que se pasan de 27}
CONST
     jardin=27;
VAR
   dif:integer;
BEGIN
     dif:=posicion-jardin;
     posicion:=jardin-dif;
END;

PROCEDURE jugada(pos,cal:integer;VAR posic,cont:integer;VAR turn,pierdeturn:boolean);
{Procedimiento que controla todos los movimientos de los jugadores y si cae
en alguna casilla reservada, ejecuta el procedimiento correspondiente}
VAR
t:integer;
 BEGIN
     dado(t,turn);
     writeln('El dado da el valor: ', t);
     writeln;
     posic:=posic+t;
     IF posic>27 THEN
        restar(posic);
     IF turn THEN
        BEGIN
             writeln('El usuario se encuentra en la casilla: ',posic);
             IF posic=27 THEN
                BEGIN
                     writeln('El usuario ha llegado al jardin de la oca.');
                     writeln;
                     writeln('El usuario ha ganado la partida.');
                END;
        END
     ELSE
         BEGIN
              writeln('La maquina se encuentra en la casilla: ',posic);
              IF posic=27 THEN
                 BEGIN
                      writeln('La maquina ha llegado al jadin de la oca.');
                      writeln;
                      writeln('La maquina ha ganado la partida.');
                 END;
         END;
     writeln;
     posad(pos,posic,cont,turn,pierdeturn);
     ocaoca(posic,turn);
     puente(pos,posic,cont,turn,pierdeturn);
     muerte(cal,posic,turn);
     IF NOT pierdeturn THEN
        BEGIN
             IF turn THEN
                turn:=FALSE
             ELSE
                 turn:=TRUE;
        END
     ELSE
         BEGIN
              IF cont>1 THEN
                 BEGIN
                      cont:=0;
                      pierdeturn:=FALSE;
                      IF turn THEN
                         turn:=FALSE
                      ELSE
                          turn:=TRUE;
                 END
              ELSE
                  cont:=cont+1;
         END;
 END;

{-------------------------------------------}
{Comienza el programa principal}
VAR
   j1,j2,posada,calavera,contador:integer;
   turno,pierdeturno:boolean; {Si turno es verdadero juega el usuario
                  Si turno es falso juega la maquina}
BEGIN
     writeln('*****************************************');
     writeln('************ JUEGO DE LA OCA ************');
     writeln('*****************************************');
     writeln;
     writeln('Introduzca el numero de casilla de la posada: ');
     {$I-}
     readln(posada);
     WHILE IOResult<>0 DO
           BEGIN
                writeln('Valor erroneo. Introduce correctamente el numero: ');
                readln(posada);
           END;
     {$I+}
     validarposada(posada);
     writeln('Introduzca el numero de casilla de la calavera: ');
     {$I-}
     readln(calavera);
     WHILE IOResult<>0 DO
           BEGIN
                writeln('Valor erroneo. Introduce correctamente el numero: ');
                readln(calavera);
           END;
     {$I+}
     validarcalavera(calavera,posada);
     j1:= 0;
     j2:= 0;
     turno:=TRUE;
     pierdeturno:=FALSE;
     contador:=0;
     writeln;
     writeln('Comienza el juego.');
     writeln;
     writeln('El primero en tirar sera el usuario.');
     writeln;
     WHILE ((j1<27) and (j2<27)) DO
           BEGIN
                IF turno THEN
                   jugada(posada,calavera,j1,contador,turno,pierdeturno)
                ELSE
                    jugada(posada,calavera,j2,contador,turno,pierdeturno);
           END;
     writeln('Partida terminada.');
     readln;
END.

