
Program Juego_De_La_Oca;

{Vctor Mndez Arnal y Jorge Salas Ortega}

procedure Presentacion(var posada,calavera:integer);

begin
  writeln;
  writeln;
  writeln('                BIENVENIDO AL JUEGO DE LA OCA');
  writeln('                -----------------------------');
  writeln;
  writeln;
  write('  |-------------------------------------------------------|');  writeln('  * INSTRUCCIONES *');
  write('  |      -12-|       -11-|      -10-|       -9-|       -8-|');  writeln;
  write('  |  Puente  |           |          |   Oca    |          |');  writeln(' Casillas Oca: Va');
  write('  |          |           |          |          |          |');  writeln(' hasta la siguiente');
  write('  |__________|___________|__________|__________|__________|');  writeln(' oca, vuelve a tirar');
  write('  |      -13-|       -24-|      -23-|      -22-|       -7-|');  writeln;
  write('  |          |           |   Oca    |          |          |');  writeln(' Casillas Puente:');
  write('  |          |           |          |          |          |');  writeln(' Salta a la posada y');
  write('  |__________|___________|__________|__________|__________|');  writeln(' pierde un turno');
  write('  |      -14-|       -25-|      -27-|      -21-|       -6-|');  writeln;
  write('  |   Oca    |           |          |          |  Puente  |');  writeln(' Casilla Posada:');
  write('  |          |           |  JARDIN  |          |          |');  writeln(' Elegida por usted,');
  write('  |__________|___________|  DE LA   |__________|__________|');  writeln(' si cae pierde turno');
  write('  |      -15-|       -26-|   OCA    |      -20-|       -5-|');  writeln;
  write('  |          |           |          |          |   Oca    |');  writeln(' Casilla Calavera:');
  write('  |          |           |          |          |          |');  writeln(' Elegida por usted,');
  write('  |__________|___________|__________|__________|__________|');  writeln(' si cae vuelve a la');
  write('  |      -16-|       -17-|      -18-|      -19-|       -4-|');  writeln(' casilla nmero 1');
  write('  |          |           |   Oca    |          |          |');  writeln;
  write('  |          |           |          |          |          |');  writeln(' Casilla Jardn de');
  write('  |__________|___________|__________|__________|__________|');  writeln(' la Oca: El primero');
  write('  |                   -0-|       -1-|       -2-|       -3-|');  writeln(' que llega con el');
  write('  |        INICIO        |          |          |          |');  writeln(' nmero exacto gana,');
  write('  |                      |          |          |          |');  writeln(' sino retrocede las');
  write('  |______________________|__________|__________|__________|');  writeln(' casillas sobrantes');
  writeln;
  writeln;
  writeln;
  writeln('  Instrucciones durante el juego: Para ir avanzando en el juego debe presionar');
  writeln('  la tecla "enter"  la tecla "intro", as mismo tambin tendra que hacerlo');
  writeln('  para lanzar el dado de su jugador y el dado de la computadora.');
  writeln('  __________________________');
  writeln;
  writeln;
  writeln;

  {$I-}
   repeat
      write('  Indique la casilla de la posada (superior a la casilla 12): ');
      readln(posada);
      writeln;
   until (IOResult=0) and (posada>12) and (posada<27) and (posada<>14)
         and (posada<>18) and (posada<>23);
   {$I+}


   {$I-}
   repeat
      write('  Indique la casilla de la calavera: ');
      readln(calavera);
      writeln;
   until (IOResult=0) and (calavera>0) and (calavera<27) and (calavera<>5)
         and (calavera<>6) and (calavera<>9) and (calavera<>12) and (calavera<>14)
         and (calavera<>18) and (calavera<>23) and (calavera<>posada)
   {$I+}

end;

{Procedimiento de presentacin del juego, donde se muestra el tablero y unas
pequeas instrucciones de como jugar y donde se preguntan dos variables del juego.}


procedure Tablero(turno:char;casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera:integer;ganador:string);


begin
  writeln;
  writeln;
  writeln('                BIENVENIDO AL JUEGO DE LA OCA');
  writeln('                -----------------------------');
  writeln;
  writeln;
  write('  |-------------------------------------------------------|');  writeln('  * PARTIDA *');
  write('  |      -12-|       -11-|      -10-|       -9-|       -8-|');  writeln;
  write('  |  Puente  |           |          |   Oca    |          |');  writeln(' Turno: ',turno);
  write('  |          |           |          |          |          |');  writeln;
  write('  |__________|___________|__________|__________|__________|');  writeln(' Casilla posada: ',posada);
  write('  |      -13-|       -24-|      -23-|      -22-|       -7-|');  writeln(' Casilla calavera:',calavera);
  write('  |          |           |   Oca    |          |          |');  writeln;
  write('  |          |           |          |          |          |');  writeln(' JUGADOR (A)');
  write('  |__________|___________|__________|__________|__________|');  writeln;
  write('  |      -14-|       -25-|      -27-|      -21-|       -6-|');  writeln(' Numero dado: ',dadoA);
  write('  |   Oca    |           |          |          |  Puente  |');  writeln(' Casilla vieja: ',casantA);
  write('  |          |           |  JARDIN  |          |          |');  writeln(' Casilla nueva: ',casillaA);
  write('  |__________|___________|  DE LA   |__________|__________|');  writeln;
  write('  |      -15-|       -26-|   OCA    |      -20-|       -5-|');  writeln(' MAQUINA (B)');
  write('  |          |           |          |          |   Oca    |');  writeln;
  write('  |          |           |          |          |          |');  writeln(' Numero dado: ',dadoB);
  write('  |__________|___________|__________|__________|__________|');  writeln(' Casilla vieja: ',casantB);
  write('  |      -16-|       -17-|      -18-|      -19-|       -4-|');  writeln(' Casilla nueva: ',casillaB);
  write('  |          |           |   Oca    |          |          |');  writeln;
  write('  |          |           |          |          |          |');  writeln;
  write('  |__________|___________|__________|__________|__________|');  writeln;
  write('  |                   -0-|       -1-|       -2-|       -3-|');  writeln('    ',ganador);
  write('  |        INICIO        |          |          |          |');  writeln;
  write('  |                      |          |          |          |');  writeln;
  write('  |______________________|__________|__________|__________|');  writeln;
  writeln;
  writeln;
  writeln;

end;

{Procedimiento principal del juego, donde se van mostrando las casillas de los
jugadores, las tiradas que realizan, etc.}


function tiradaA:integer;
begin
  tiradaA:=0;
  tiradaA:=random(6)+1;

end;

{Funcin que hace la funcin del dado y devuelve un nmero aleatorio entre
0 y 6, se utiliza para el jugador A, el usuario.}


function tiradaB:integer;
begin
  tiradaB:=0;
  tiradaB:=random(6)+1;

end;

{Funcin que hace la funcin del dado y devuelve un nmero aleatorio entre
0 y 6, se utiliza para el jugador B, la computadora.}

var
  resto,posada,casillaA,casantA,casillaB,casantB,dadoA,dadoB,calavera:integer;
  A,B,turno:char;
  ganador:string;

begin
  presentacion(posada,calavera);
  randomize;
  turno:='A';
  casillaA:=0;
  casantA:=0;
  casillaB:=0;
  casantB:=0;
  tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);

    repeat
        begin

            if turno='A' then
              begin
               writeln('  Pulse la tecla "enter"  "intro" para lanzar el dado');
               readln;
               dadoA:=tiradaA;
               casillaA:=casillaA+dadoA;
               casantA:=casillaA-dadoA;
               tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);


               if casillaA>27 then
                 begin
                    resto:=casillaA-27;
                    casillaA:=27-resto;
                    tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);
                    readln;
                 end;



               if casillaA=posada then
                 begin
                    writeln('  Has cado en la posada, pierdes un turno');
                    readln;
                    turno:='B';
                    tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);

                 end;

               if casillaA=calavera then
                 begin
                    writeln('  Has cado en la calavera, retrocedes hasta la casilla 1');
                    readln;
                    casillaA:=1;
                    casantA:=calavera;
                    turno:='B';
                    tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);

                 end;

               case casillaA of

                  5:   begin
                         writeln('  Has cado en una oca, avanzas hasta la siguiente casilla de una oca (9)');
                         writeln('  y vuelves a tirar');
                         readln;
                         casillaA:=9;
                         casantA:=5;
                         turno:='A';
                         tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);

                       end;


                  6:   begin
                         writeln('  Has cado en un puente, vas a la posada y pierdes un turno');
                         casillaA:=posada;
                         readln;
                         casantA:=6;
                         turno:='B';
                         tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);

                       end;

                  9:   begin
                         writeln('  Has cado en una oca, avanzas hasta la siguiente casilla de una oca (14)');
                         writeln('  y vuelves a tirar');
                         readln;
                         casillaA:=14;
                         casantA:=9;
                         turno:='A';
                         tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);

                       end;


                 12:   begin
                         writeln('  Has cado en un puente, vas a la posada y pierdes un turno');
                         readln;
                         casillaA:=posada;
                         casantA:=12;
                         turno:='B';
                         tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);

                       end;

                 14:   begin
                         writeln('  Has cado en una oca, avanzas hasta la siguiente casilla de una oca (18)');
                         writeln('  y vuelves a tirar');
                         readln;
                         casillaA:=18;
                         casantA:=14;
                         turno:='A';
                         tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);

                       end;

                 18:   begin
                         writeln('  Has cado en una oca, avanzas hasta la siguiente casilla de una oca (23)');
                         writeln('  y vuelves a tirar');
                         readln;
                         casillaA:=23;
                         casantA:=18;
                         turno:='A';
                         tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);

                       end;

                 23:   begin
                         writeln('  Has cado en una oca, avanzas hasta la siguiente casilla de una oca (27)');
                         readln;
                         casillaA:=27;
                         casantA:=23;
                         ganador:='HAS GANADO';
                         tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);
                         readln;
                       end;

                 27:   begin
                         ganador:='HAS GANADO';
                         tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);
                         readln;
                       end;

                else   begin
                         readln;
                         turno:='B';
                         tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);
                       end;
               end;
              end;


            if turno='B' then

              begin
               writeln('  Pulse la tecla "enter"  "intro" para que lanze el dado la mquina');
               readln;
               dadoB:=tiradaB;
               casillaB:=casillaB+dadoB;
               casantB:=casillaB-dadoB;
               tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);


                 if casillaB>27 then
                   begin
                     resto:=casillaB-27;
                     casillaB:=27-resto;
                     tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);
                     readln;
                   end;



                 if casillaB=posada then
                   begin
                     writeln('  He cado en la posada, pierdo un turno');
                     readln;
                     turno:='A';
                     tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);

                   end;


                 if casillaB=calavera then
                   begin
                     writeln('  He cado en la calavera, vuelvo a la casilla 1');
                     readln;
                     casillaB:=1;
                     casantB:=calavera;
                     turno:='A';
                     tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);

                   end;


               case casillaB of

                  5:   begin
                         writeln('  He cado en una oca, avanzo hasta la siguiente casilla de una oca (9)');
                         writeln('  y vuelvo a tirar');
                         readln;
                         casillaB:=9;
                         casantB:=5;
                         turno:='B';
                         tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);

                       end;


                  6:   begin
                         writeln('  He cado en un puente, voy a la posada y pierdo un turno');
                         readln;
                         casillaB:=posada;
                         casantB:=6;
                         turno:='A';
                         tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);

                       end;

                  9:   begin
                         writeln('  He cado en una oca, avanzo hasta la siguiente casilla de una oca (14)');
                         writeln('  y vuelvo a tirar');
                         readln;
                         casillaB:=14;
                         casantB:=9;
                         turno:='B';
                         tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);

                       end;


                 12:   begin
                         writeln('  He cado en un puente, voy a la posada y pierdo un turno');
                         readln;
                         casillaB:=posada;
                         casantB:=12;
                         turno:='A';
                         tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);

                       end;

                 14:   begin
                         writeln('  He cado en una oca, avanzo hasta la siguiente casilla de una oca (18)');
                         writeln('  y vuelvo a tirar');
                         readln;
                         casillaB:=18;
                         casantB:=14;
                         turno:='B';
                         tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);

                       end;

                 18:   begin
                         writeln('  He cado en una oca, avanzo hasta la siguiente casilla de una oca (23)');
                         writeln('  y vuelvo a tirar');
                         readln;
                         casillaB:=23;
                         casantB:=18;
                         turno:='B';
                         tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);

                       end;

                 23:   begin
                         writeln('  He cado en una oca, avanzo hasta la siguiente casilla de una oca (27)');
                         readln;
                         casillaB:=27;
                         casantB:=23;
                         ganador:='TE HE GANADO';
                         tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);
                         readln;
                       end;

                 27:   begin
                         ganador:='TE HE GANADO';
                         tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);
                         readln;
                       end;


                else   begin
                         readln;
                         turno:='A';
                         tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);
                       end;

               end;
              end;
        end;

   until (casillaA=27) or (casillaB=27)

end.

