Program JuegoDeLaOca;

Const
  tmax=27;

Procedure Posada (var casillapos:integer);
   Begin
      {$I+}
      Repeat
         writeln ('Introduce la casilla que ser la posada');
         readln (casillapos);
      until (IOresult=0) and (casillapos<>5) and (casillapos<>6) and
         (casillapos<>9) and (casillapos<>12) and (casillapos<>14) and
         (casillapos<>18) and (casillapos<>23) and (casillapos<27) and
         (casillapos<>0);
      {$I-}
   end;

Procedure Calavera (caspos:integer;var casical:integer);
   Begin
     {$I+}
     Repeat
        writeln ('Introduce la casilla que ser la calavera');
        readln (casical);
        writeln;
     until (casical>12) and (casical<>14) and (casical<>18) and
           (casical<>23) and (casical<tmax) and (casical<>0) and
           (casical<>caspos)and (IOresult=0);
     {$I-}
   end;

Procedure dibujartablero(posada,calavera,posmaq,posjug:integer);
   var
   indi:integer;
   Begin
     for indi:=1 to tmax do
     begin
        write (indi:2,' : ');
        case indi of
           5:write (' Oca /');
           9:write (' Oca /');
          14:write (' Oca /');
          18:write (' Oca /');
          23:write (' Oca /');
           6:write (' Puente /');
          12:write (' Puente /');
          27:write (' Jardn de la oca /');
        end;
        if indi=posada then write (' Posada /');
        if indi=calavera then write (' Calavera /');
        if indi=posjug then write (' posicion USUARIO');
        if indi=posmaq then write (' posicion MAQUINA');
        writeln;
     end;
   end;

Function Tirardado:integer;
   Begin
      tirardado:=random(6)+1;
   end;

Procedure tiradajugador (ndad:integer;var pos:integer);
   Begin
      ndad:=tirardado;
      writeln('Has sacado un: ',ndad);
      pos:=pos+ndad;
      if (pos>tmax) then
          pos:=pos-(pos-tmax)*2;
   end;

Procedure CasillasEspeciales (caposada,cacalavera:integer; var posicion,turno,
                                num:integer);
   Begin
      If (posicion=5) or (posicion=9) or (posicion=14)  or (posicion=18)
         or (posicion=23) then  {oca}
         begin
            case posicion of
               5:  posicion:=9;
               9:  posicion:=14;
               14: posicion:=18;
               18: posicion:=23;
               23: posicion:=27;
            end;
            writeln ('Has caido en OCA, pasas a la siguiente oca, y vuelves a tirar');
            if (turno=1) then
               turno:=1
            else
               turno:=2;
            num:=1;
         end;
      if  (posicion=6) or (posicion=12) then   {PUENTE}
         begin
            posicion:=caposada;
            num:=2;
            writeln('Has cado en PUENTE, vas a la posada');
         end;
      if (posicion=caposada) then    {POSADA}
         begin
            num:=2;
            writeln ('Has cado en POSADA. pierde un turno');
         end;
      if  (posicion=cacalavera) then   {CALAVERA}
         begin
            posicion:=1;
            num:=1;
            writeln ('Has cado en CALAVERA, retrocedes a la casilla 1');
         end;
      if (posicion=6) or (posicion=12) or (posicion=caposada) or
         (posicion=cacalavera) then
         begin
            if turno=1 then
               turno:=2
            else
               turno:=1;
         end;
      readln;
  end;

Procedure casillasnormales (cpos,ccal,posi:integer; var ntur,numve:integer);
   Begin
      if (posi<>5) and (posi<>9) and (posi<>14) and (posi<>18) and
         (posi<>23) and (posi<>6) and (posi<>12) and (posi<>cpos) and
         (posi<>ccal) and (posi<>27) and (posi<>0) then
         Begin
            if ntur=1 then ntur:=2
            else ntur:=1;
            numve:=1;
         end;
   end;

Function finjuego (posjugad,posmaquin:integer):boolean;  {TERMINAR EL JUEGO}
   begin
      if (posjugad=27) then
        begin
           finjuego:=true;
           writeln ('HAS GANADO EL JUEGO!!!!!!!!!!!!!!!!');
        end;
      if (posmaquin=27) then
        begin
           finjuego:=true;
           writeln ('Te ha ganado la mquina!!!!!!!!!');
        end;
   end;


{=======================PROGRAMA PRINCIPAL=======================}
Var
  pmaq:integer;
  pusuar:integer;
  ndado,nveces:integer;
  cposada,ccalavera:integer;
  nturno:integer;
  ind:integer;

Begin
  randomize;
  writeln ('"""""""""Bienvenido al juego de la oca""""""""""""""""');
  readln;
  Posada (cposada);
  Calavera (cposada,ccalavera);
  nturno:=1;
  nveces:=1;
  pmaq:=0;
  pusuar:=0;
  dibujartablero(cposada,ccalavera,pmaq,pusuar);
  writeln;
  Repeat
     If (nturno=1) then
       begin
          for ind:=nveces downto 1 do
            begin
              writeln ('Turno del USUARIO');
              writeln;
              writeln ('Tire el dado: pulse enter');
              readln;
              tiradajugador(ndado,pusuar);
              CasillasEspeciales (cposada,ccalavera,pusuar,nturno,nveces);
              casillasnormales (cposada,ccalavera,pusuar,nturno,nveces);
              dibujartablero(cposada,ccalavera,pmaq,pusuar);
              writeln;
            end;
       end
     else
       begin
         for ind:=nveces downto 1 do
           begin
             writeln ('Turno de la MAQUINA');
             readln;
             tiradajugador (ndado,pmaq);
             CasillasEspeciales (cposada,ccalavera,pmaq,nturno,nveces);
             casillasnormales (cposada,ccalavera,pmaq,nturno,nveces);
             dibujartablero(cposada,ccalavera,pmaq,pusuar);
             writeln;
           end;

      end;

  until finjuego(pusuar,pmaq)=true;
  readln;
end.