program juego_de_la_oca;	

uses crt;  {acceso a libreria xa poder hacer el clrscr} 

{---------------------------------------------------------------------------}		

function pide_opcion:boolean;

var opcion:integer;
	begin
	{$I-}
		repeat
			writeln;
			textColor (14); 
			writeln('JUEGO DE LA OCA by Barrett');
			writeln;
			textColor (15); 
			writeln('1: JUEGO.');
			writeln('2: INSTRUCCIONES.');
			writeln('3: VER HISTORIA DE LA OCA.');
			writeln('4: SALIR.');
			writeln;
			write('Elige una opcion:');
			readln(opcion);
			clrscr;
			If IOResult<>0 then writeln('Elige una de las opciones.');	
	{$I+}
		case opcion of
			1: pide_opcion:=true;
			2: begin
					writeln;
					textColor (11); 
					writeln('INSTRUCCIONES DEL JUEGO DE LA OCA.');
					textColor (15); 
					writeln;
					write('Los jugadores empiezan desde la posicion de inicio (casilla 0) y tiran por orden ');
					writeln('un dado con el proposito de alcanzar el Jardin de la OCA (casilla 27).');
					writeln('Hay algunas casillas especiales: ');
					write('Oca: casillas 5, 9, 14, 18 y 23. Si se cae en estas casillas se avanza hasta ');
					writeln('la siguiente oca y se vuelve a tirar.');
					writeln('Puente: casillas 6 y 12. Desde los puentes se va a la posada y se pierde turno.');
					writeln('Posada: Si se cae en esta casilla se pierde un turno.');
					writeln('Calavera: Si se cae en esta casilla hay que volver a la casilla 1.');
					write('Jardin de la Oca: casilla 27. Es necesario sacar los puntos justos para entrar. ');
					writeln('En caso de exceso se retroceden desde la meta tantas casillas como puntos sobrantes.');
					writeln
				end;
			3: begin
					writeln;
					textColor (11); 
					writeln('HISTORIA DEL JUEGO DE LA OCA.');
					textColor (15); 
					writeln;
					write('Cuenta una leyenda griega que durante el sitio de Troya los guerreros ');
					writeln('griegos se aburrian tanto que inventaron juegos para entretenerse.'); 
					write('Uno de estos juegos fue precisamente el Juego de la Oca" y cuentan que ');
					writeln('quien se lo invento fue Palamedes hijo del rey de Eubea y nieto de Poseidon.');
					write('En el 1908 se descubrio en Creta una pieza arqueologica que data ');
					write('del 2000 A.C. y que fue llamada el "Disco de Phaistos", que probablemente ');
					writeln('era un tablero para  jugar al Juego de la Oca.'); 
					write('Es un disco hecho de arcilla que tiene grabada una espiral con 31 casillas en   una ');
					write('cara y 30 en la otra; en 8 de las casillas hay, tambien grabadas figuras ');
					writeln('de pajaros muy grandes.');
					writeln;
					writeln
				end;
			4: pide_opcion:=false;
		end;
			until (IOResult=0) and ((opcion=1) or (opcion=4))
	end;
	
{---------------------------------------------------------------------------}		
	
function comprueba_casilla_especial(casilla,posa,cala:integer):integer;
	{va a decir el tipo de casilla que ocupa una determinada posicion.}
	begin
		case casilla of 
			5,9,14,18,23: 
				begin
					comprueba_casilla_especial:=1 {oca}	
				end;
			6,12: 
				begin
					comprueba_casilla_especial:=2 {puente}
				end;
			27: 
				begin
					comprueba_casilla_especial:=5 {jardin}
				end;
		else
			if casilla=posa then 
				begin
					comprueba_casilla_especial:=3 {posada}	
				end
			else 
			if casilla=cala then
				begin
					comprueba_casilla_especial:=4 {calavera}				
				end
			else
				comprueba_casilla_especial:=0 {otra casilla}
		end;
	end;

{----------------------------------------------------------------------------------}
		
procedure pide_casillas_especiales (var posa,cala:integer);
{va a pedir y mostrar al usuario los numeros que fijaran las casillas especiales posada y calavera}	
	var casillaintroducida:integer;	
	begin
	{$I-}
		repeat
			textColor (12); 
			write('Introduce la casilla POSADA: ');
			readln(casillaintroducida);
			textColor (15); 
			If IOResult<>0 then writeln('Debes introducir otro numero.')
		until (IOResult=0) and (casillaintroducida>12) and (casillaintroducida<28) 
			and (comprueba_casilla_especial(casillaintroducida,posa,cala)=0);
		posa:=casillaintroducida;
	
		repeat	
			textColor (12); 
			write('Introduce la casilla CALAVERA: ');
			readln(casillaintroducida);
			textColor (15); 
			writeln;
			If IOResult<>0 then writeln('Debes introducir otro numero.')
		until (IOResult=0) and (casillaintroducida>1) and (casillaintroducida<28)
			and (comprueba_casilla_especial(casillaintroducida,posa,cala)=0);
		cala:=casillaintroducida
	{$I+}		
	end;
	
{---------------------------------------------------------------------------------}		
		
procedure pide_nombre_jugador (var nombre:string);
	begin
		writeln;
		textColor (11); 
		writeln('LA PARTIDA AL JUEGO DE LA OCA HA COMENZADO!');
		textColor (15);
		writeln; 
		write('Introduce tu nombre: ');
		readln(nombre);
		writeln
	end;
 
{-------------------------------------------------------------------------}

function tirada_dado:integer;
	{tiro el dado. no entra nada y sale un integer}
	begin	
		tirada_dado:=random(6)+1 
		{random(6)-->va desde 0 hasta 5, si sumo 1-->va desde 1 hasta 6}
	end;
	
{-------------------------------------------------------------------------}
		
procedure mueve_ficha (var casillajug:integer; var jugador1espera,jugador2espera:boolean;
						turno,posa,cala,tirada_dado:integer);
	var tiradaactual:integer;
	begin
		writeln('La tirada de dado ha sido: ',tirada_dado);
		writeln;
		
		tiradaactual:=casillajug + tirada_dado;
		
		if (turno=1) and (jugador1espera=true) then 
			begin
				jugador1espera:=false;
				writeln('Has perdido un turno.')
			end
		else if (turno=2) and (jugador2espera=true) then 
			begin
				jugador2espera:=false;
				writeln('Has perdido un turno.')
			end
		else
			if tiradaactual<28 then 
				case comprueba_casilla_especial(tiradaactual,posa,cala) of
					0:  casillajug:=tiradaactual;	
					1:  begin
							case tiradaactual of
								5: casillajug:=9;
								9: casillajug:=14;
								14: casillajug:=18;
								18: casillajug:=23;
								23: casillajug:=27
							end;
							begin
								textColor (10);
								writeln('De oca a oca y tiro porque me toca.');
								textColor (15)
							end;
							if turno=2 then 
								jugador1espera:=true
							else 
								jugador2espera:=true
						end;
					2:  begin
							if (tiradaactual=6) or (tiradaactual=12) then
								begin
									casillajug:=posa;
									if turno=1 then 
										jugador1espera:=true
									else 
										jugador2espera:=true	
								end; 
							begin
								textColor (12);
								writeln('Caes en puente y a la posada se te lleva la corriente. Pierdes turno...');
								textColor (15)
							end
						end;
					3:  begin
							casillajug:=posa;
							begin
								textColor (12);
								writeln('Has caido en la posada, espera un turno bebiendo cerveza!');
								textColor (15)
							end;
							if turno=1 then 
								jugador1espera:=true
							else 
								jugador2espera:=true					
						end;
					4:  begin
							casillajug:=1; 
							begin
								textColor (6);
								writeln('Has caido en la calavera, vuelves a la primera casilla.');
								textcolor(15)
							end
						end;
					5:  begin
							casillajug:=27;
							begin
								textColor (2);
								writeln('Se ha llegado al jardin!! Pulsa intro para conocer al ganador'); {se queda como esta xq es el final del juego}
								textcolor (15)
							end
						end
				end
			else
				begin
					case tiradaactual of
						28: casillajug:=(tiradaactual-2);
						29: casillajug:=(tiradaactual-4);
						30: casillajug:=(tiradaactual-6);
						31: casillajug:=(tiradaactual-8);
						32: casillajug:=(tiradaactual-10)
					end;
					writeln('Te has pasado, retrocedes desde el jardin')
				end
	end;
	
{--------------------------------------------------------------------------}
	
procedure muestra_tablero(casillajug1,casillajug2:integer; nombre:string);
{las variables aqui no cambian, lo k ocurre esk le entran datos cambiados en cada turno}
	begin
		writeln(nombre,' esta en la posicion: ',casillajug1);
		writeln('La maquina esta en la posicion: ',casillajug2)
	end;
	
{--------------------------------------------------------------------------}

procedure cambia_turno(var turno:integer);
	begin
		if turno=1 then turno:=2
		else turno:=1
	end;

{---------------------------------------------------------------------------}	

var
	turno,posada,calavera,casillajug1,casillajug2:integer; 
	nombre,pausa:string;	
	jugador1enposada,jugador2enposada:boolean;
	
		{turno: guarda el turno del jugador 1:yo o 2:maquina}
		{casilla1,casilla2: guarda posiciones de jugador 1 y 2}
		{jugador1enposada: siempre en false xa q juego se ejecute normal, si es true cambio de turno}
		{var siempre jugador1enposada=false y el juego se ejecuta normal. Si cae en posada cambio a jugador1enposada=true
		y entonces cuando ejecute, como no esta en false no hara nada y le digo que la vuela a poner false. lo mismo con
		jugador2enposada}
			
begin
	clrscr;
	randomize;
	casillajug1:=0;
	casillajug2:=0;
	turno:=1;
	jugador1enposada:=false;
	jugador2enposada:=false;
	
if pide_opcion= true then
	begin
		pide_nombre_jugador(nombre);
		pide_casillas_especiales(posada,calavera);
	
		repeat
			if turno=1 then
				mueve_ficha(casillajug1,jugador1enposada,jugador2enposada,turno,posada,calavera,tirada_dado)
			else 
				mueve_ficha(casillajug2,jugador1enposada,jugador2enposada,turno,posada,calavera,tirada_dado);
			muestra_tablero(casillajug1,casillajug2,nombre);
			cambia_turno(turno);
			writeln;
			textColor (8); 
			writeln('Pulsa intro para seguir jugando...');
			writeln('**********************************');
			textColor (15); 
			readln(pausa)
		until (comprueba_casilla_especial(casillajug1,posada,calavera)=5)
			or (comprueba_casilla_especial(casillajug2,posada,calavera)=5);
			{comprueba que comprueba_casilla_especial es jardin para jugador 1(casilla1) o 2(casilla2)} 
			
		if (comprueba_casilla_especial(casillajug1,posada,calavera)=5) then
			begin
				textColor (2); 
				writeln('!!! HA GANADO: ',nombre,' !!!');
				textcolor(15)
			end
		else 
		if  (comprueba_casilla_especial(casillajug2,posada,calavera)=5) then
			begin
				textColor (2); 
				writeln('!!! TE HA GANADO LA MAQUINA !!!');
				textColor (15)
			end
	end
else
	begin
		textColor (11);
		writeln;
		writeln('HA ELEGIDO SALIR DEL JUEGO.');
		writeln;
		textColor (15);
		writeln('Pulse cualquier tecla...');
		readln(pausa)
	end
end.
